/* Generated by Pyrex 0.9.3 on Tue Apr 12 20:02:59 2005 */

#include "Python.h"
#include "structmember.h"
#ifndef PY_LONG_LONG
  #define PY_LONG_LONG LONG_LONG
#endif
#include "stdlib.h"
#include "string.h"
#include "setjmp.h"
#include "pari/pari.h"
#include "pari/anal.h"


typedef struct {PyObject **p; char *s;} __Pyx_InternTabEntry; /*proto*/
typedef struct {PyObject **p; char *s; long n;} __Pyx_StringTabEntry; /*proto*/
static PyObject *__Pyx_UnpackItem(PyObject *, int); /*proto*/
static int __Pyx_EndUnpack(PyObject *, int); /*proto*/
static int __Pyx_PrintItem(PyObject *); /*proto*/
static int __Pyx_PrintNewline(void); /*proto*/
static void __Pyx_Raise(PyObject *type, PyObject *value, PyObject *tb); /*proto*/
static void __Pyx_ReRaise(void); /*proto*/
static PyObject *__Pyx_Import(PyObject *name, PyObject *from_list); /*proto*/
static PyObject *__Pyx_GetExcValue(void); /*proto*/
static int __Pyx_ArgTypeTest(PyObject *obj, PyTypeObject *type, int none_allowed, char *name); /*proto*/
static int __Pyx_TypeTest(PyObject *obj, PyTypeObject *type); /*proto*/
static int __Pyx_GetStarArgs(PyObject **args, PyObject **kwds, char *kwd_list[], int nargs, PyObject **args2, PyObject **kwds2); /*proto*/
static void __Pyx_WriteUnraisable(char *name); /*proto*/
static void __Pyx_AddTraceback(char *funcname); /*proto*/
static PyTypeObject *__Pyx_ImportType(char *module_name, char *class_name, long size);  /*proto*/
static int __Pyx_SetVtable(PyObject *dict, void *vtable); /*proto*/
static int __Pyx_GetVtable(PyObject *dict, void *vtabptr); /*proto*/
static PyObject *__Pyx_CreateClass(PyObject *bases, PyObject *dict, PyObject *name, char *modname); /*proto*/
static int __Pyx_InternStrings(__Pyx_InternTabEntry *t); /*proto*/
static int __Pyx_InitStrings(__Pyx_StringTabEntry *t); /*proto*/
static PyObject *__Pyx_GetName(PyObject *dict, PyObject *name); /*proto*/

static PyObject *__pyx_m;
static PyObject *__pyx_b;
static int __pyx_lineno;
static char *__pyx_filename;
staticforward char **__pyx_f;

static char __pyx_mdoc[] = "\npy_pari -- Python interface to PARI C-library.\n\nThis module provides a new interface to the PARI C-library.  It is\nmodeled on the gp interpreter, but with all the advantages associated\nwith using a real programming language (Python) instead of a hacked\ninterpreter.\n\nHere are several advantages of Python/PARI over GP:\n\n      - Improved memory management and garbage collection:\n\n            * Automatic garbage collection!  Each Python/PARI object\n              has its own piece of memory allocated from the Python\n              heap.  When objects go out of scope the Python memory\n              manager deletes them.  (Implementation: I grafted\n              genuine memory management onto PARI by creatinging a\n              mini \"PARI stack\" in the Python heap for each GEN that\n              is wrapped by a Python object.  In some cases it is\n              necessary to copy this GEN back to the main PARI stack\n              for computations, but this is very fast.)\n\n\n            * If the \"PARI stack overflows\", then py_pari\n            *automatically* doubles the PARI stack and your\n            computation continues uninterrupted.  The main stack is\n            unlikely to overflow because it is only used for very\n            small atomic computations; as soon as an object is\n            computed it is moved of the stack into its own chunk of\n            memory in the Python heap.\n\n      - Exception handling.  try, except, raise\n      \n      - Genuine object oriented language with user defined classes,\n        multiple inheritence, polymorphism, etc.\n      \n      - Object serialization:  This makes loading and saving objects\n        to disk easy.\n            >>> a = pari(5)\n            >>> import pickle\n            >>> s = pickle.dumps(a); \n            >>> z = pickle.loads(s);\n            >>> print z\n            5\n            >>> type(z)\n            <type \'py_pari.gen\'>\n            >>> a == z\n            True\n            >>> a is z\n            False\n\n      - Python: easy access to massive amount of software aleady written \n            in Python, e.g., for compression, networking, 2d and 3d\n            graphics, etc.\n\nPROBLEMS/WARNINGS\n\n      - PARI commands run at the C-level and cannot be interrupted from\n        the Python interpreter with ctrl-C until they return from C level.\n        This is in accord with how the Python interpreter works.\n        \n      - Some of the PARI error and log messages print to stdout.  This\n        can be very annoying, since it might interfere with output the\n        user is trying to send to a file.  Possible fixes: (1) Modify \n    \n";

/* Declarations from py_pari */

staticforward PyTypeObject __pyx_type_7py_pari_gen;

struct __pyx_obj_7py_pari_gen {
  PyObject_HEAD
  struct __pyx_vtabstruct_7py_pari_gen *__pyx_vtab;
  GEN g;
  PyObject *refers_to;
  pari_sp b;
};

struct __pyx_vtabstruct_7py_pari_gen {
  PyObject *((*init)(struct __pyx_obj_7py_pari_gen *,GEN ,pari_sp ));
  GEN ((*_gen)(struct __pyx_obj_7py_pari_gen *));
};
static struct __pyx_vtabstruct_7py_pari_gen *__pyx_vtabptr_7py_pari_gen;

static PyTypeObject *__pyx_ptype_7py_pari_gen = 0;
static gp_data __pyx_v_7py_pari___GP_DATA;
static int __pyx_v_7py_pari_REAL_PREC;
static pariout_t __pyx_v_7py_pari_fmt;
static unsigned long __pyx_v_7py_pari_num_primes;
static pari_sp __pyx_v_7py_pari_stack_avma;
static struct __pyx_obj_7py_pari_gen *__pyx_v_7py_pari_ZERO;
static struct __pyx_obj_7py_pari_gen *__pyx_v_7py_pari_ONE;
static struct __pyx_obj_7py_pari_gen *__pyx_v_7py_pari_TWO;
static long __pyx_k3;
static unsigned long __pyx_k4;
static PyObject *__pyx_k5;
static PyObject *__pyx_k6;
static PyObject *__pyx_k7;
static PyObject *__pyx_k8;
static PyObject *__pyx_k9;
static PyObject *__pyx_k10;
static int __pyx_k11;
static int __pyx_k12;
static int __pyx_k13;
static int __pyx_k14;
static PyObject *__pyx_k15;
static int __pyx_k16;
static PyObject *__pyx_k17;
static long __pyx_k18;
static PyObject *__pyx_k19;
static PyObject *__pyx_k20;
static PyObject *__pyx_k21;
static long __pyx_k22;
static long __pyx_k23;
static long __pyx_k24;
static PyObject *__pyx_k25;
static long __pyx_k26;
static long __pyx_k27;
static PyObject *__pyx_k28;
static PyObject *__pyx_k29;
static PyObject *__pyx_k30;
static PyObject *__pyx_k31;
static PyObject *__pyx_k32;
static long __pyx_k33;
static long __pyx_k34;
static PyObject *__pyx_k35;
static PyObject *__pyx_k36;
static PyObject *__pyx_k38;
static int __pyx_k39;
static int __pyx_k40;
static PyObject *__pyx_k41;
static PyObject *__pyx_k42;
static int (__pyx_f_7py_pari_is_int_or_real_type(GEN )); /*proto*/
static size_t (__pyx_f_7py_pari_fix_size(size_t )); /*proto*/
static int (__pyx_f_7py_pari_init_stack(size_t )); /*proto*/
static GEN (__pyx_f_7py_pari_str_to_GEN(char (*))); /*proto*/
static PyObject *(__pyx_f_7py_pari_GEN_to_str(GEN )); /*proto*/
static PyObject *(__pyx_f_7py_pari_save_avma(void)); /*proto*/
static struct __pyx_obj_7py_pari_gen *(__pyx_f_7py_pari_new_gen_noclear(GEN )); /*proto*/
static struct __pyx_obj_7py_pari_gen *(__pyx_f_7py_pari_new_gen(GEN )); /*proto*/
static struct __pyx_obj_7py_pari_gen *(__pyx_f_7py_pari___xxx_new_gen(GEN ,pari_sp )); /*proto*/
static struct __pyx_obj_7py_pari_gen *(__pyx_f_7py_pari__new_gen(GEN ,pari_sp )); /*proto*/
static struct __pyx_obj_7py_pari_gen *(__pyx_f_7py_pari_new_ref(GEN ,struct __pyx_obj_7py_pari_gen *)); /*proto*/
static int (__pyx_f_7py_pari_get_var(PyObject *)); /*proto*/

/* Implementation of py_pari */

static char (__pyx_k1[]) = "\n* Make it so when asking for, e.g., the n-th prime, if not enough primes have\n  been precomputed, py_pari automatically precomputes enough primes and answers\n  the question.  Make py_pari robust like MAGMA, and not lame like gp.\n\n";
static char (__pyx_k37[]) = "";

static PyObject *__pyx_n_gc;
static PyObject *__pyx_n_my_sigint;
static PyObject *__pyx_n_init_fmt;
static PyObject *__pyx_n__init;
static PyObject *__pyx_n_pari;
static PyObject *__pyx_n_stack_ptr;
static PyObject *__pyx_n_stack_top;
static PyObject *__pyx_n_stack_bottom;
static PyObject *__pyx_n_stack_size;
static PyObject *__pyx_n_stack_usage;
static PyObject *__pyx_n_stack_available;
static PyObject *__pyx_n_execute;
static PyObject *__pyx_n_eval;
static PyObject *__pyx_n__error;
static PyObject *__pyx_n_min;
static PyObject *__pyx_n_max;
static PyObject *__pyx_n_prime_list;
static PyObject *__pyx_n_nth_prime;
static PyObject *__pyx_n_euler;
static PyObject *__pyx_n_pi;
static PyObject *__pyx_n_factorial;
static PyObject *__pyx_n_vector;
static PyObject *__pyx_n_matrix;
static PyObject *__pyx_n_set_real_precision;
static PyObject *__pyx_n_get_real_precision;
static PyObject *__pyx_n_set_series_precision;
static PyObject *__pyx_n_get_series_precision;
static PyObject *__pyx_n_init_primes;

static PyObject *__pyx_k37p;

static int __pyx_f_7py_pari_is_int_or_real_type(GEN __pyx_v_g) {
  int __pyx_v_t;
  int __pyx_r;
  int __pyx_1;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2033 */
  __pyx_v_t = typ(__pyx_v_g);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2034 */
  __pyx_1 = (__pyx_v_t == t_INT);
  if (!__pyx_1) {
    __pyx_1 = (__pyx_v_t == t_REAL);
  }
  __pyx_r = __pyx_1;
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_WriteUnraisable("py_pari.is_int_or_real_type");
  __pyx_L0:;
  return __pyx_r;
}

static size_t __pyx_f_7py_pari_fix_size(size_t __pyx_v_a) {
  size_t __pyx_v_b;
  size_t __pyx_r;
  int __pyx_1;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2038 */
  __pyx_v_b = (__pyx_v_a - (__pyx_v_a & (BYTES_IN_LONG - 1)));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2039 */
  __pyx_1 = (__pyx_v_b < 1024);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2040 */
    __pyx_v_b = 1024;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2041 */
  __pyx_r = __pyx_v_b;
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_WriteUnraisable("py_pari.fix_size");
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_n_MemoryError;

static PyObject *__pyx_k43p;

static char (__pyx_k43[]) = "Unable to allocate %s bytes memory for PARI.";

static int __pyx_f_7py_pari_init_stack(size_t __pyx_v_size) {
  size_t __pyx_v_s;
  int __pyx_r;
  pari_sp __pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2049 */
  __pyx_1 = bot;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2051 */
    PyMem_Free(((void (*))bot));
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2053 */
  __pyx_2 = (__pyx_v_size == 0);
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2054 */
    __pyx_v_size = (2 * (top - bot));
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2057 */
  __pyx_v_s = __pyx_f_7py_pari_fix_size(__pyx_v_size);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2062 */
  bot = ((pari_sp )PyMem_Malloc(__pyx_v_s));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2063 */
  __pyx_2 = (!bot);
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2064 */
    __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_MemoryError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2064; goto __pyx_L1;}
    __pyx_4 = PyInt_FromLong(((long )__pyx_v_size)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2064; goto __pyx_L1;}
    __pyx_5 = PyNumber_Remainder(__pyx_k43p, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2064; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __Pyx_Raise(__pyx_3, __pyx_5, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2064; goto __pyx_L1;}
    goto __pyx_L4;
  }
  __pyx_L4:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2065 */
  top = (bot + __pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2066 */
  avma = top;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2067 */
  __pyx_v_7py_pari_stack_avma = avma;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.init_stack");
  __pyx_r = -1;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_n_KeyboardInterrupt;

static PyObject *__pyx_f_7py_pari_my_sigint(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_my_sigint(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_signum = 0;
  PyObject *__pyx_v_frame = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"signum","frame",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_signum, &__pyx_v_frame)) return 0;
  Py_INCREF(__pyx_v_signum);
  Py_INCREF(__pyx_v_frame);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2071 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_KeyboardInterrupt); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2071; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2071; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.my_sigint");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_signum);
  Py_DECREF(__pyx_v_frame);
  return __pyx_r;
}

static char (__pyx_k44[]) = "g";

static PyObject *__pyx_f_7py_pari_init_fmt(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_init_fmt(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2078 */
  __pyx_v_7py_pari_fmt.format = (__pyx_k44[0]);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2079 */
  __pyx_v_7py_pari_fmt.fieldw = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2080 */
  __pyx_v_7py_pari_fmt.sigd = (-1);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2081 */
  __pyx_v_7py_pari_fmt.sp = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2082 */
  __pyx_v_7py_pari_fmt.prettyp = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2083 */
  __pyx_v_7py_pari_fmt.TeXstyle = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2085 */
  GP_DATA->fmt = (&__pyx_v_7py_pari_fmt);

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("py_pari.init_fmt");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_n_initialized;
static PyObject *__pyx_n_RuntimeError;
static PyObject *__pyx_n_signal;
static PyObject *__pyx_n_SIGINT;

static PyObject *__pyx_k45p;

static char (__pyx_k45[]) = "pari_init has already been called.";

static PyObject *__pyx_f_7py_pari__init(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari__init[] = "\n    Initialize the PARI system.\n    \n    INPUT:\n        size -- long, the number of bytes for the initial PARI stack\n                (see note below)\n        maxprime -- unsigned long, upper limit on a precomputed prime\n                    number table  (default: 500000)\n\n    NOTES:\n    \n        * In py_pari, the PARI stack is different than in gp or the\n          PARI C library.  In Python, instead of the PARI stack\n          holding the results of all computations, it *only* holds the\n          results of an individual computation.  Each time a new\n          Python/PARI object is computed, it it copied to its own\n          space in the Python heap, and the memory it occupied on the\n          PARI stack is freed.  Thus it is not necessary to make the\n          stack very large.  Also, unlike in PARI, if the stack does\n          overflow, in most cases the PARI stack is automatically\n          increased and the relevant step of the computation rerun.\n\n          This design obviously involves some performance penalties\n          over the way PARI works, but it scales much better and is\n          far more robus for large projects.\n          \n        * If you do not want prime numbers, put maxprime=2, but be\n          careful because many PARI functions require this table.  If\n          you get the error message \"not enough precomputed primes\",\n          increase this parameter.\n          \n    ";
static PyObject *__pyx_f_7py_pari__init(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_size;
  unsigned long __pyx_v_maxprime;
  PyObject *__pyx_v_signal;
  PyObject *__pyx_v_stack_avma;
  PyObject *__pyx_r;
  unsigned long __pyx_1;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  PyObject *__pyx_6 = 0;
  static char *__pyx_argnames[] = {"size","maxprime",0};
  __pyx_v_size = __pyx_k3;
  __pyx_v_maxprime = __pyx_k4;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|ll", __pyx_argnames, &__pyx_v_size, &__pyx_v_maxprime)) return 0;
  __pyx_v_signal = Py_None; Py_INCREF(__pyx_v_signal);
  __pyx_v_stack_avma = Py_None; Py_INCREF(__pyx_v_stack_avma);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2122 */
  __pyx_1 = precdl;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2123 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_RuntimeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2123; goto __pyx_L1;}
    __Pyx_Raise(__pyx_2, __pyx_k45p, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2123; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2125 */
  pari_init(1024,__pyx_v_maxprime);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2126 */
  __pyx_3 = __pyx_f_7py_pari_init_stack(__pyx_v_size); if (__pyx_3 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2126; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2127 */
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_init_fmt); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2127; goto __pyx_L1;}
  __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2127; goto __pyx_L1;}
  __pyx_5 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2127; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  Py_DECREF(__pyx_5); __pyx_5 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2128 */
  __pyx_2 = __Pyx_Import(__pyx_n_signal, 0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2128; goto __pyx_L1;}
  Py_DECREF(__pyx_v_signal);
  __pyx_v_signal = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2129 */
  __pyx_4 = PyObject_GetAttr(__pyx_v_signal, __pyx_n_signal); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2129; goto __pyx_L1;}
  __pyx_5 = PyObject_GetAttr(__pyx_v_signal, __pyx_n_SIGINT); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2129; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_my_sigint); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2129; goto __pyx_L1;}
  __pyx_6 = PyTuple_New(2); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2129; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_6, 0, __pyx_5);
  PyTuple_SET_ITEM(__pyx_6, 1, __pyx_2);
  __pyx_5 = 0;
  __pyx_2 = 0;
  __pyx_5 = PyObject_CallObject(__pyx_4, __pyx_6); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2129; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  Py_DECREF(__pyx_6); __pyx_6 = 0;
  Py_DECREF(__pyx_5); __pyx_5 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2130 */
  __pyx_2 = PyInt_FromLong(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2130; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_initialized, __pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2130; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2131 */
  __pyx_4 = PyLong_FromUnsignedLong(avma); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2131; goto __pyx_L1;}
  Py_DECREF(__pyx_v_stack_avma);
  __pyx_v_stack_avma = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2132 */
  __pyx_v_7py_pari_num_primes = __pyx_v_maxprime;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2133 */
  __pyx_6 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2133; goto __pyx_L1;}
  __pyx_5 = PyInt_FromLong(0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2133; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2133; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_5);
  __pyx_5 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_6, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2133; goto __pyx_L1;}
  Py_DECREF(__pyx_6); __pyx_6 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_4, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2133; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_7py_pari_ZERO));
  ((PyObject *)__pyx_v_7py_pari_ZERO) = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2134 */
  __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2134; goto __pyx_L1;}
  __pyx_6 = PyInt_FromLong(1); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2134; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2134; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_6);
  __pyx_6 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_5, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2134; goto __pyx_L1;}
  Py_DECREF(__pyx_5); __pyx_5 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_4, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2134; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_7py_pari_ONE));
  ((PyObject *)__pyx_v_7py_pari_ONE) = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2135 */
  __pyx_6 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2135; goto __pyx_L1;}
  __pyx_5 = PyInt_FromLong(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2135; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2135; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_5);
  __pyx_5 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_6, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2135; goto __pyx_L1;}
  Py_DECREF(__pyx_6); __pyx_6 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_4, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2135; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_7py_pari_TWO));
  ((PyObject *)__pyx_v_7py_pari_TWO) = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2136 */
  __pyx_5 = PyInt_FromLong(0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2136; goto __pyx_L1;}
  __pyx_r = __pyx_5;
  __pyx_5 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  Py_XDECREF(__pyx_6);
  __Pyx_AddTraceback("py_pari._init");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_signal);
  Py_DECREF(__pyx_v_stack_avma);
  return __pyx_r;
}

static GEN __pyx_f_7py_pari_str_to_GEN(char (*__pyx_v_s)) {
  int __pyx_v_n;
  GEN __pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2148 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2149 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2149; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2149; goto __pyx_L1;}
    __pyx_4 = PyString_FromString(__pyx_v_s); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2149; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2149; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
    __pyx_3 = 0;
    __pyx_4 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2149; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2150 */
  __pyx_r = flisseq(__pyx_v_s);
  goto __pyx_L0;

  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.str_to_GEN");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_n_str;

static PyObject *__pyx_k47p;

static char (__pyx_k47[]) = "converting a gen to a string";

static PyObject *__pyx_f_7py_pari_GEN_to_str(GEN __pyx_v_g) {
  char (*__pyx_v_c);
  int __pyx_v_n;
  PyObject *__pyx_v_s;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  __pyx_v_s = Py_None; Py_INCREF(__pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2155 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2156 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2157 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2157; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2157; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2157; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k47p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k47p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2157; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2159 */
  __pyx_v_c = GENtostr(__pyx_v_g);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2160 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2160; goto __pyx_L1;}
  __pyx_4 = PyString_FromString(__pyx_v_c); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2160; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2160; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_4);
  __pyx_4 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2160; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2161 */
  free(__pyx_v_c);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2162 */
  Py_INCREF(__pyx_v_s);
  __pyx_r = __pyx_v_s;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.GEN_to_str");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  return __pyx_r;
}

static char (__pyx_k48[]) = "\n            g -- PARI GEN\n            b -- pointer to memory chunk where PARI gen lives\n                 (if nonzero then this memory is freed when the object\n                  goes out of scope)\n        ";

static PyObject *__pyx_f_7py_pari_3gen_init(struct __pyx_obj_7py_pari_gen *__pyx_v_self,GEN __pyx_v_g,pari_sp __pyx_v_b) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2177 */
  __pyx_k48;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2183 */
  __pyx_v_self->g = __pyx_v_g;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2184 */
  __pyx_v_self->b = __pyx_v_b;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2185 */
  __pyx_1 = PyDict_New(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2185; goto __pyx_L1;}
  Py_DECREF(__pyx_v_self->refers_to);
  __pyx_v_self->refers_to = __pyx_1;
  __pyx_1 = 0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.init");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static void __pyx_f_7py_pari_3gen___dealloc__(PyObject *__pyx_v_self); /*proto*/
static void __pyx_f_7py_pari_3gen___dealloc__(PyObject *__pyx_v_self) {
  pari_sp __pyx_1;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2188 */
  __pyx_1 = ((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->b;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2190 */
    PyMem_Free(((void (*))((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->b));
    goto __pyx_L2;
  }
  __pyx_L2:;

  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("py_pari.gen.__dealloc__");
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
}

static PyObject *__pyx_f_7py_pari_3gen___repr__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___repr__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2193 */
  __pyx_1 = __pyx_f_7py_pari_GEN_to_str(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2193; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.__repr__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static GEN __pyx_f_7py_pari_3gen__gen(struct __pyx_obj_7py_pari_gen *__pyx_v_self) {
  GEN __pyx_r;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2196 */
  __pyx_r = __pyx_v_self->g;
  goto __pyx_L0;

  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_WriteUnraisable("py_pari.gen._gen");
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_py_pari_py;

static PyObject *__pyx_k49p;

static char (__pyx_k49[]) = "sage.pari.py_pari_py";

static PyObject *__pyx_f_7py_pari_3gen___reduce__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___reduce__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_z;
  PyObject *__pyx_v_sage;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_z = Py_None; Py_INCREF(__pyx_v_z);
  __pyx_v_sage = Py_None; Py_INCREF(__pyx_v_sage);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2199 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2199; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2199; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2199; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_z);
  __pyx_v_z = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2200 */
  __pyx_1 = __Pyx_Import(__pyx_k49p, 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2200; goto __pyx_L1;}
  Py_DECREF(__pyx_v_sage);
  __pyx_v_sage = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2201 */
  __pyx_2 = PyObject_GetAttr(__pyx_v_sage, __pyx_n_pari); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2201; goto __pyx_L1;}
  __pyx_3 = PyObject_GetAttr(__pyx_2, __pyx_n_py_pari_py); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2201; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_1 = PyObject_GetAttr(__pyx_3, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2201; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2201; goto __pyx_L1;}
  Py_INCREF(__pyx_v_z);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z);
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2201; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_1);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_2);
  __pyx_1 = 0;
  __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.__reduce__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_z);
  Py_DECREF(__pyx_v_sage);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k50p;

static char (__pyx_k50[]) = "error adding PARI objects";

static PyObject *__pyx_f_7py_pari_3gen__add(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen__add(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_other = 0;
  PyObject *__pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"other",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_other)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_7py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2207; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2208 */
  __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2208; goto __pyx_L1;}
  Py_DECREF(__pyx_v_n);
  __pyx_v_n = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2209 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2209; goto __pyx_L1;}
  if (__pyx_2) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2209; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2209; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    Py_INCREF(__pyx_k50p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k50p);
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2209; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2210 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gadd(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_other->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2210; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen._add");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_k51p;

static char (__pyx_k51[]) = "error subtracting PARI objects";

static PyObject *__pyx_f_7py_pari_3gen__sub(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen__sub(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_other = 0;
  PyObject *__pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"other",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_other)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_7py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2212; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2213 */
  __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2213; goto __pyx_L1;}
  Py_DECREF(__pyx_v_n);
  __pyx_v_n = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2214 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2214; goto __pyx_L1;}
  if (__pyx_2) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2214; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2214; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    Py_INCREF(__pyx_k51p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k51p);
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2214; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2215 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gsub(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_other->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2215; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen._sub");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_k52p;

static char (__pyx_k52[]) = "error multiplying PARI objects";

static PyObject *__pyx_f_7py_pari_3gen__mul(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen__mul(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_other = 0;
  PyObject *__pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"other",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_other)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_7py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2217; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2218 */
  __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2218; goto __pyx_L1;}
  Py_DECREF(__pyx_v_n);
  __pyx_v_n = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2219 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2219; goto __pyx_L1;}
  if (__pyx_2) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2219; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2219; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    Py_INCREF(__pyx_k52p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k52p);
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2219; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2220 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gmul(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_other->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2220; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen._mul");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_k53p;

static char (__pyx_k53[]) = "error dividing PARI objects";

static PyObject *__pyx_f_7py_pari_3gen__div(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen__div(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_other = 0;
  PyObject *__pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"other",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_other)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_7py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2222; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2223 */
  __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2223; goto __pyx_L1;}
  Py_DECREF(__pyx_v_n);
  __pyx_v_n = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2224 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2224; goto __pyx_L1;}
  if (__pyx_2) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2224; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2224; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    Py_INCREF(__pyx_k53p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k53p);
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2224; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2225 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gdiv(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),forcecopy(__pyx_v_other->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2225; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen._div");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_k54p;

static char (__pyx_k54[]) = "error quotienting PARI objects";

static PyObject *__pyx_f_7py_pari_3gen__mod(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen__mod(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_other = 0;
  PyObject *__pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"other",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_other)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_7py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2227; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2228 */
  __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2228; goto __pyx_L1;}
  Py_DECREF(__pyx_v_n);
  __pyx_v_n = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2229 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2229; goto __pyx_L1;}
  if (__pyx_2) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2229; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2229; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    Py_INCREF(__pyx_k54p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k54p);
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2229; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2230 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gmod(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_other->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2230; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen._mod");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_n__add;

static PyObject *__pyx_f_7py_pari_3gen___add__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___add__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2233 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2233; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2233; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2233; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_self);
  __pyx_v_self = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2233 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2233; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2233; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2233; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_other);
  __pyx_v_other = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2234 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n__add); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2234; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2234; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2234; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.__add__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_n__sub;

static PyObject *__pyx_f_7py_pari_3gen___sub__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___sub__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2237 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2237; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2237; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2237; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_self);
  __pyx_v_self = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2237 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2237; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2237; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2237; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_other);
  __pyx_v_other = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2238 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n__sub); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2238; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2238; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2238; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.__sub__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_n__mul;

static PyObject *__pyx_f_7py_pari_3gen___mul__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___mul__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2241 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2241; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2241; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2241; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_self);
  __pyx_v_self = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2241 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2241; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2241; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2241; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_other);
  __pyx_v_other = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2242 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n__mul); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2242; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2242; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2242; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.__mul__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_n__div;

static PyObject *__pyx_f_7py_pari_3gen___div__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___div__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2245 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2245; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2245; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2245; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_self);
  __pyx_v_self = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2245 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2245; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2245; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2245; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_other);
  __pyx_v_other = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2246 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n__div); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2246; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2246; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2246; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.__div__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_n__mod;

static PyObject *__pyx_f_7py_pari_3gen___mod__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___mod__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2249 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2249; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2249; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2249; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_self);
  __pyx_v_self = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2249 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2249; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2249; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2249; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_other);
  __pyx_v_other = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2250 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n__mod); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2250; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2250; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2250; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.__mod__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen___neg__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___neg__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2253 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gneg(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2253; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.__neg__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k55p;

static char (__pyx_k55[]) = "error exponentiating PARI object";

static PyObject *__pyx_f_7py_pari_3gen___pow__(PyObject *__pyx_v_self, PyObject *__pyx_v_n, PyObject *__pyx_v_m); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___pow__(PyObject *__pyx_v_self, PyObject *__pyx_v_n, PyObject *__pyx_v_m) {
  struct __pyx_obj_7py_pari_gen *__pyx_v__n;
  struct __pyx_obj_7py_pari_gen *__pyx_v__self;
  int __pyx_v_j;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_n);
  Py_INCREF(__pyx_v_m);
  ((PyObject*)__pyx_v__n) = Py_None; Py_INCREF(((PyObject*)__pyx_v__n));
  ((PyObject*)__pyx_v__self) = Py_None; Py_INCREF(((PyObject*)__pyx_v__self));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2257 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2257; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2257; goto __pyx_L1;}
  Py_INCREF(__pyx_v_n);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_n);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2257; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2257; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__n));
  ((PyObject *)__pyx_v__n) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2258 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2258; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2258; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2258; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2258; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__self));
  ((PyObject *)__pyx_v__self) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2261 */
  __pyx_v_j = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2262 */
  __pyx_4 = __pyx_v_j;
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2263 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2263; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_j); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2263; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2263; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k55p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k55p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2263; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2265 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gpow(forcecopy(__pyx_v__self->g),__pyx_v__n->g,__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2265; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.__pow__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__n);
  Py_DECREF(__pyx_v__self);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_m);
  return __pyx_r;
}

static PyObject *__pyx_k56p;
static PyObject *__pyx_k57p;

static char (__pyx_k56[]) = "Use ** for exponentiation, not '^', which means xor\n";
static char (__pyx_k57[]) = "in Python, and has the wrong precedence.";

static PyObject *__pyx_f_7py_pari_3gen___xor__(PyObject *__pyx_v_self, PyObject *__pyx_v_n); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___xor__(PyObject *__pyx_v_self, PyObject *__pyx_v_n) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_n);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_self), __pyx_ptype_7py_pari_gen, 1, "self")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2267; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2268 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_RuntimeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2268; goto __pyx_L1;}
  __pyx_2 = PyNumber_Add(__pyx_k56p, __pyx_k57p); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2268; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, __pyx_2, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2268; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("py_pari.gen.__xor__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_n);
  return __pyx_r;
}

static PyObject *__pyx_k58p;

static char (__pyx_k58[]) = "error right shifting PARI object";

static PyObject *__pyx_f_7py_pari_3gen___rshift__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___rshift__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  long __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_n = PyInt_AsLong(__pyx_arg_n); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2271; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_self), __pyx_ptype_7py_pari_gen, 1, "self")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2271; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2272 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2273 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2273; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2273; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2273; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k58p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k58p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2273; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2274 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(gshift(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),(-__pyx_v_n)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2274; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.__rshift__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k59p;

static char (__pyx_k59[]) = "error left shifting PARI object";

static PyObject *__pyx_f_7py_pari_3gen___lshift__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___lshift__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  long __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_n = PyInt_AsLong(__pyx_arg_n); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2276; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_self), __pyx_ptype_7py_pari_gen, 1, "self")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2276; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2277 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2278 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2278; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2278; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2278; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k59p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k59p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2278; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2279 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(gshift(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_n))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2279; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.__lshift__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k60p;

static char (__pyx_k60[]) = "error inverting PARI object";

static PyObject *__pyx_f_7py_pari_3gen___invert__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___invert__(PyObject *__pyx_v_self) {
  PyObject *__pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2282 */
  __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2282; goto __pyx_L1;}
  Py_DECREF(__pyx_v_n);
  __pyx_v_n = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2283 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2283; goto __pyx_L1;}
  if (__pyx_2) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2283; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2283; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    Py_INCREF(__pyx_k60p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k60p);
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2283; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2284 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(ginv(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2284; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.__invert__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_polcoeff;
static PyObject *__pyx_n_isinstance;
static PyObject *__pyx_n_tuple;
static PyObject *__pyx_n_nrows;
static PyObject *__pyx_n_IndexError;
static PyObject *__pyx_n_ncols;

static PyObject *__pyx_k61p;
static PyObject *__pyx_k62p;
static PyObject *__pyx_k63p;

static char (__pyx_k61[]) = "row i(=%s) must be between 0 and %s";
static char (__pyx_k62[]) = "column j(=%s) must be between 0 and %s";
static char (__pyx_k63[]) = "index (%s) must be between 0 and %s";

static PyObject *__pyx_f_7py_pari_3gen___getitem__(PyObject *__pyx_v_self, PyObject *__pyx_v_n); /*proto*/
static char __pyx_doc_7py_pari_3gen___getitem__[] = "\n        Return a *copy* of the nth entry.\n\n        The indexing is 0-based, like in Python.  However, *copying*\n        the nth entry instead of returning reference is different\n        than what one usually does in Python.  However, we do it\n        this way for consistency with the PARI/GP interpreter, which\n        does make copies.\n        ";
static PyObject *__pyx_f_7py_pari_3gen___getitem__(PyObject *__pyx_v_self, PyObject *__pyx_v_n) {
  PyObject *__pyx_v_i;
  PyObject *__pyx_v_j;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  int __pyx_6;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_n);
  __pyx_v_i = Py_None; Py_INCREF(__pyx_v_i);
  __pyx_v_j = Py_None; Py_INCREF(__pyx_v_j);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2299 */
  __pyx_1 = (typ(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g) == t_POL);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2300 */
    __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_polcoeff); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2300; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2300; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2300; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2302 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2302; goto __pyx_L1;}
  __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_tuple); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2302; goto __pyx_L1;}
  __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2302; goto __pyx_L1;}
  Py_INCREF(__pyx_v_n);
  PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_n);
  PyTuple_SET_ITEM(__pyx_4, 1, __pyx_3);
  __pyx_3 = 0;
  __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2302; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  __pyx_1 = PyObject_IsTrue(__pyx_3); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2302; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2303 */
    __pyx_2 = PyInt_FromLong(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2303; goto __pyx_L1;}
    __pyx_4 = PyObject_GetItem(__pyx_v_n, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2303; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_3 = PyInt_FromLong(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2303; goto __pyx_L1;}
    __pyx_2 = PyObject_GetItem(__pyx_v_n, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2303; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_v_i);
    __pyx_v_i = __pyx_4;
    __pyx_4 = 0;
    Py_DECREF(__pyx_v_j);
    __pyx_v_j = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2304 */
    __pyx_3 = PyInt_FromLong(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2304; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_i, __pyx_3, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2304; goto __pyx_L1;}
    __pyx_1 = __pyx_1 < 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (!__pyx_1) {
      __pyx_4 = PyObject_GetAttr(__pyx_v_self, __pyx_n_nrows); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2304; goto __pyx_L1;}
      __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2304; goto __pyx_L1;}
      __pyx_3 = PyObject_CallObject(__pyx_4, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2304; goto __pyx_L1;}
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      if (PyObject_Cmp(__pyx_v_i, __pyx_3, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2304; goto __pyx_L1;}
      __pyx_1 = __pyx_1 >= 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
    }
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2305 */
      __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2305; goto __pyx_L1;}
      __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_nrows); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2305; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2305; goto __pyx_L1;}
      __pyx_5 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2305; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2305; goto __pyx_L1;}
      Py_INCREF(__pyx_v_i);
      PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_i);
      PyTuple_SET_ITEM(__pyx_2, 1, __pyx_5);
      __pyx_5 = 0;
      __pyx_3 = PyNumber_Remainder(__pyx_k61p, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2305; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __Pyx_Raise(__pyx_4, __pyx_3, 0);
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2305; goto __pyx_L1;}
      goto __pyx_L4;
    }
    __pyx_L4:;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2306 */
    __pyx_5 = PyInt_FromLong(0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2306; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_j, __pyx_5, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2306; goto __pyx_L1;}
    __pyx_1 = __pyx_1 < 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    if (!__pyx_1) {
      __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ncols); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2306; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2306; goto __pyx_L1;}
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2306; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      if (PyObject_Cmp(__pyx_v_j, __pyx_3, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2306; goto __pyx_L1;}
      __pyx_1 = __pyx_1 >= 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
    }
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2307 */
      __pyx_5 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2307; goto __pyx_L1;}
      __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ncols); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2307; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2307; goto __pyx_L1;}
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2307; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2307; goto __pyx_L1;}
      Py_INCREF(__pyx_v_j);
      PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_j);
      PyTuple_SET_ITEM(__pyx_2, 1, __pyx_3);
      __pyx_3 = 0;
      __pyx_4 = PyNumber_Remainder(__pyx_k62p, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2307; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __Pyx_Raise(__pyx_5, __pyx_4, 0);
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2307; goto __pyx_L1;}
      goto __pyx_L5;
    }
    __pyx_L5:;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2308 */
    __pyx_3 = PyInt_FromLong(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2308; goto __pyx_L1;}
    __pyx_2 = PyNumber_Add(__pyx_v_j, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2308; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_1 = PyInt_AsLong(__pyx_2); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2308; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_5 = PyInt_FromLong(1); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2308; goto __pyx_L1;}
    __pyx_4 = PyNumber_Add(__pyx_v_i, __pyx_5); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2308; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    __pyx_6 = PyInt_AsLong(__pyx_4); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2308; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_3 = ((PyObject *)__pyx_f_7py_pari_new_ref(((GEN )(((GEN )(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g[__pyx_1]))[__pyx_6])),((struct __pyx_obj_7py_pari_gen *)__pyx_v_self))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2308; goto __pyx_L1;}
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2310 */
  __pyx_2 = PyInt_FromLong(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2310; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_v_n, __pyx_2, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2310; goto __pyx_L1;}
  __pyx_1 = __pyx_1 < 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__pyx_1) {
    __pyx_5 = PyInt_FromLong(glength(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2310; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_n, __pyx_5, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2310; goto __pyx_L1;}
    __pyx_1 = __pyx_1 >= 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
  }
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2311 */
    __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2311; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong((glength(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g) - 1)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2311; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2311; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_n);
    PyTuple_SET_ITEM(__pyx_2, 1, __pyx_3);
    __pyx_3 = 0;
    __pyx_5 = PyNumber_Remainder(__pyx_k63p, __pyx_2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2311; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __Pyx_Raise(__pyx_4, __pyx_5, 0);
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2311; goto __pyx_L1;}
    goto __pyx_L6;
  }
  __pyx_L6:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2312 */
  __pyx_3 = PyInt_FromLong(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2312; goto __pyx_L1;}
  __pyx_2 = PyNumber_Add(__pyx_v_n, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2312; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_6 = PyInt_AsLong(__pyx_2); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2312; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_4 = ((PyObject *)__pyx_f_7py_pari_new_ref(((GEN )(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g[__pyx_6])),((struct __pyx_obj_7py_pari_gen *)__pyx_v_self))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2312; goto __pyx_L1;}
  __pyx_r = __pyx_4;
  __pyx_4 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.gen.__getitem__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_i);
  Py_DECREF(__pyx_v_j);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_n);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen___getslice__(PyObject *__pyx_v_self, int __pyx_arg_i, int __pyx_arg_j); /*proto*/
static char __pyx_doc_7py_pari_3gen___getslice__[] = "\n        EXAMPLES:\n            >>> v = pari(xrange(20))\n            >>> v[2:5]\n            [2, 3, 4]\n            >>> v[:]\n            [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19]\n            >>> v[10:]\n            [10, 11, 12, 13, 14, 15, 16, 17, 18, 19]\n            >>> v[:5]\n            [0, 1, 2, 3, 4]\n            >>> v\n            [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19]\n            >>> v[-1]\n            Traceback (most recent call last):\n            ...\n            IndexError: index (-1) must be between 0 and 19\n            >>> v[:-3]\n            [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16]\n            >>> v[5:]\n            [5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19]\n        ";
static PyObject *__pyx_f_7py_pari_3gen___getslice__(PyObject *__pyx_v_self, int __pyx_arg_i, int __pyx_arg_j) {
  long __pyx_v_i;
  long __pyx_v_j;
  long __pyx_v_l;
  long __pyx_v_k;
  PyObject *__pyx_v_v;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_i = __pyx_arg_i;
  __pyx_v_j = __pyx_arg_j;
  __pyx_v_v = Py_None; Py_INCREF(__pyx_v_v);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2339 */
  __pyx_v_l = glength(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2340 */
  __pyx_1 = (__pyx_v_j >= __pyx_v_l);
  if (__pyx_1) {
    __pyx_v_j = __pyx_v_l;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2341 */
  __pyx_1 = (__pyx_v_i < 0);
  if (__pyx_1) {
    __pyx_v_i = 0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2342 */
  __pyx_1 = (__pyx_v_j <= __pyx_v_i);
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_vector); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2342; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2342; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2342; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2342; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
    goto __pyx_L4;
  }
  __pyx_L4:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2343 */
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_vector); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2343; goto __pyx_L1;}
  __pyx_4 = PyInt_FromLong((__pyx_v_j - __pyx_v_i)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2343; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2343; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_4);
  __pyx_4 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2343; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_v_v);
  __pyx_v_v = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2344 */
  for (__pyx_v_k = __pyx_v_i; __pyx_v_k < __pyx_v_j; ++__pyx_v_k) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2345 */
    __pyx_2 = PyInt_FromLong(__pyx_v_k); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2345; goto __pyx_L1;}
    __pyx_3 = PyObject_GetItem(__pyx_v_self, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2345; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_4 = PyInt_FromLong((__pyx_v_k - __pyx_v_i)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2345; goto __pyx_L1;}
    if (PyObject_SetItem(__pyx_v_v, __pyx_4, __pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2345; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_L5:;
  }
  __pyx_L6:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2346 */
  Py_INCREF(__pyx_v_v);
  __pyx_r = __pyx_v_v;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.__getslice__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_v);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n___setitem__;

static PyObject *__pyx_k65p;
static PyObject *__pyx_k66p;
static PyObject *__pyx_k67p;

static char (__pyx_k65[]) = "row i(=%s) must be between 0 and %s";
static char (__pyx_k66[]) = "column j(=%s) must be between 0 and %s";
static char (__pyx_k67[]) = "index (%s) must be between 0 and %s";

static int __pyx_f_7py_pari_3gen___setitem__(PyObject *__pyx_v_self, PyObject *__pyx_v_n, PyObject *__pyx_v_y); /*proto*/
static char __pyx_doc_7py_pari_3gen___setitem__[] = "\n        Set the nth entry to a reference to y.  \n        \n        WARNINGS:\n\n            -- There is a known BUG: If v is a vector and entry i of v is a vector,\n                        v[i][j] = x\n               should set entry j of v[i] to x.  Instead it sets it to nonsense.\n               I do not understand why this occurs.  The following is a safe way\n               to do the same thing:\n                        tmp = v[i]; tmp[j] = x    \n        \n            -- The indexing is 0-based, like everywhere else in Python, but\n               *unlike* in GP/PARI.\n            \n            -- Assignment sets the nth entry to a reference to y,\n               assuming y is an object of type gen.  This is the same\n               as in Python, but *different* than what happens in the\n               gp interpreter, where assignment makes a copy of y.\n\n            -- Because setting creates references it is *possible* to\n               make circular references, unlike in GP.  Do *not* do\n               this (see the example below).  If you need circular\n               references, work at the Python level (where they work\n               well), not the PARI object level.\n\n        EXAMPLES:\n            >>> v = pari(range(10))\n            >>> v\n            [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\n            >>> v[0] = 10\n            >>> w = pari([5,8,-20])\n            >>> v\n            [10, 1, 2, 3, 4, 5, 6, 7, 8, 9]\n            >>> v[1] = w\n            >>> v\n            [10, [5, 8, -20], 2, 3, 4, 5, 6, 7, 8, 9]\n            >>> w[0] = -30\n            >>> v\n            [10, [-30, 8, -20], 2, 3, 4, 5, 6, 7, 8, 9]\n            >>> t = v[1]; t[1] = 10   # don\'t do v[1][1] !!! (because of mysterious BUG...)\n            >>> v\n            [10, [-30, 10, -20], 2, 3, 4, 5, 6, 7, 8, 9]\n            >>> w\n            [-30, 10, -20]\n            \n        Finally, we create a circular reference:\n            >>> v = pari([0])\n            >>> w = pari([v])\n            >>> v\n            [0]\n            >>> w\n            [[0]]\n            >>> v[0] = w\n            >>> # Now there is a circular reference.  Trying to access v[0] will crash SAGE.\n\n        ";
static int __pyx_f_7py_pari_3gen___setitem__(PyObject *__pyx_v_self, PyObject *__pyx_v_n, PyObject *__pyx_v_y) {
  int __pyx_v_e;
  struct __pyx_obj_7py_pari_gen *__pyx_v_x;
  PyObject *__pyx_v_i;
  PyObject *__pyx_v_j;
  int __pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  int __pyx_6;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_n);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v_x) = Py_None; Py_INCREF(((PyObject*)__pyx_v_x));
  __pyx_v_i = Py_None; Py_INCREF(__pyx_v_i);
  __pyx_v_j = Py_None; Py_INCREF(__pyx_v_j);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2407 */
  __pyx_v_e = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2408 */
  __pyx_1 = __pyx_v_e;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2408; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_e); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2408; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2408; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_n___setitem__);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_n___setitem__);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2408; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2411 */
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2411; goto __pyx_L1;}
  __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2411; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2411; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2411; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_x));
  ((PyObject *)__pyx_v_x) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2412 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2412; goto __pyx_L1;}
  __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_tuple); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2412; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2412; goto __pyx_L1;}
  Py_INCREF(__pyx_v_n);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_4);
  __pyx_4 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2412; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_1 = PyObject_IsTrue(__pyx_4); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2412; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2413 */
    if (PyObject_SetItem(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->refers_to, __pyx_v_n, ((PyObject *)__pyx_v_x)) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2413; goto __pyx_L1;}

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2414 */
    __pyx_2 = PyInt_FromLong(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2414; goto __pyx_L1;}
    __pyx_3 = PyObject_GetItem(__pyx_v_n, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2414; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_v_i);
    __pyx_v_i = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2415 */
    __pyx_4 = PyInt_FromLong(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2415; goto __pyx_L1;}
    __pyx_2 = PyObject_GetItem(__pyx_v_n, __pyx_4); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2415; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_v_j);
    __pyx_v_j = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2416 */
    __pyx_3 = PyInt_FromLong(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2416; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_i, __pyx_3, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2416; goto __pyx_L1;}
    __pyx_1 = __pyx_1 < 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (!__pyx_1) {
      __pyx_4 = PyObject_GetAttr(__pyx_v_self, __pyx_n_nrows); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2416; goto __pyx_L1;}
      __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2416; goto __pyx_L1;}
      __pyx_3 = PyObject_CallObject(__pyx_4, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2416; goto __pyx_L1;}
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      if (PyObject_Cmp(__pyx_v_i, __pyx_3, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2416; goto __pyx_L1;}
      __pyx_1 = __pyx_1 >= 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
    }
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2417 */
      __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2417; goto __pyx_L1;}
      __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_nrows); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2417; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2417; goto __pyx_L1;}
      __pyx_5 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2417; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2417; goto __pyx_L1;}
      Py_INCREF(__pyx_v_i);
      PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_i);
      PyTuple_SET_ITEM(__pyx_2, 1, __pyx_5);
      __pyx_5 = 0;
      __pyx_3 = PyNumber_Remainder(__pyx_k65p, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2417; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __Pyx_Raise(__pyx_4, __pyx_3, 0);
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2417; goto __pyx_L1;}
      goto __pyx_L4;
    }
    __pyx_L4:;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2418 */
    __pyx_5 = PyInt_FromLong(0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2418; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_j, __pyx_5, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2418; goto __pyx_L1;}
    __pyx_1 = __pyx_1 < 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    if (!__pyx_1) {
      __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ncols); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2418; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2418; goto __pyx_L1;}
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2418; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      if (PyObject_Cmp(__pyx_v_j, __pyx_3, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2418; goto __pyx_L1;}
      __pyx_1 = __pyx_1 >= 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
    }
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2419 */
      __pyx_5 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2419; goto __pyx_L1;}
      __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ncols); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2419; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2419; goto __pyx_L1;}
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2419; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2419; goto __pyx_L1;}
      Py_INCREF(__pyx_v_j);
      PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_j);
      PyTuple_SET_ITEM(__pyx_2, 1, __pyx_3);
      __pyx_3 = 0;
      __pyx_4 = PyNumber_Remainder(__pyx_k66p, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2419; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __Pyx_Raise(__pyx_5, __pyx_4, 0);
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2419; goto __pyx_L1;}
      goto __pyx_L5;
    }
    __pyx_L5:;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2420 */
    __pyx_3 = PyInt_FromLong(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2420; goto __pyx_L1;}
    __pyx_2 = PyNumber_Add(__pyx_v_j, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2420; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_1 = PyInt_AsLong(__pyx_2); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2420; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_5 = PyInt_FromLong(1); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2420; goto __pyx_L1;}
    __pyx_4 = PyNumber_Add(__pyx_v_i, __pyx_5); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2420; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    __pyx_6 = PyInt_AsLong(__pyx_4); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2420; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    (((GEN )(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g[__pyx_1]))[__pyx_6]) = ((long )__pyx_v_x->g);

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2421 */
    __pyx_r = 0;
    goto __pyx_L0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2423 */
  __pyx_3 = PyInt_FromLong(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2423; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_v_n, __pyx_3, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2423; goto __pyx_L1;}
  __pyx_1 = __pyx_1 < 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (!__pyx_1) {
    __pyx_2 = PyInt_FromLong(glength(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2423; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_n, __pyx_2, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2423; goto __pyx_L1;}
    __pyx_1 = __pyx_1 >= 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
  }
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2424 */
    __pyx_5 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2424; goto __pyx_L1;}
    __pyx_4 = PyInt_FromLong((glength(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g) - 1)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2424; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2424; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_4);
    __pyx_4 = 0;
    __pyx_2 = PyNumber_Remainder(__pyx_k67p, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2424; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __Pyx_Raise(__pyx_5, __pyx_2, 0);
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2424; goto __pyx_L1;}
    goto __pyx_L6;
  }
  __pyx_L6:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2425 */
  if (PyObject_SetItem(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->refers_to, __pyx_v_n, ((PyObject *)__pyx_v_x)) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2425; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2428 */
  __pyx_v_e = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2429 */
  __pyx_6 = __pyx_v_e;
  if (__pyx_6) {
    __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2429; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_e); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2429; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2429; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
    Py_INCREF(__pyx_n___setitem__);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_n___setitem__);
    __pyx_3 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_4, __pyx_5); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2429; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L7;
  }
  __pyx_L7:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2430 */
  __pyx_3 = PyInt_FromLong(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2430; goto __pyx_L1;}
  __pyx_4 = PyNumber_Add(__pyx_v_n, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2430; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_1 = PyInt_AsLong(__pyx_4); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2430; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  (((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g[__pyx_1]) = ((long )__pyx_v_x->g);

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.gen.__setitem__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_i);
  Py_DECREF(__pyx_v_j);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static int __pyx_f_7py_pari_3gen___len__(PyObject *__pyx_v_self); /*proto*/
static int __pyx_f_7py_pari_3gen___len__(PyObject *__pyx_v_self) {
  int __pyx_r;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2433 */
  __pyx_r = glength(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g);
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("py_pari.gen.__len__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ncols(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ncols(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2436 */
  __pyx_1 = PyInt_FromLong(glength(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2436; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ncols");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}


static PyObject *__pyx_f_7py_pari_3gen_nrows(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_nrows(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2440 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2441 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2441; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2441; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2441; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_n_nrows);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_n_nrows);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2441; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2442 */
  __pyx_2 = PyInt_FromLong(glength(((GEN )(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g[1])))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2442; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.nrows");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_polcoeff(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_polcoeff[] = "\n        EXAMPLES:\n            >>> f = pari(\"x^2 + y^3 + x*y\")\n            >>> f\n            x^2 + y*x + y^3\n            >>> f.polcoeff(1)\n            y\n            >>> f.polcoeff(3)\n            0\n            >>> f.polcoeff(3, \"y\")\n            1\n            >>> f.polcoeff(1, \"y\")\n            x\n        ";
static PyObject *__pyx_f_7py_pari_3gen_polcoeff(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  PyObject *__pyx_v_var = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"n","var",0};
  __pyx_v_var = __pyx_k5;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l|O", __pyx_argnames, &__pyx_v_n, &__pyx_v_var)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_var);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2459 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(polcoeff0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_n,__pyx_f_7py_pari_get_var(__pyx_v_var)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2459; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.polcoeff");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_var);
  return __pyx_r;
}

static int __pyx_f_7py_pari_3gen___cmp__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static char __pyx_doc_7py_pari_3gen___cmp__[] = "\n        Comparisons.\n        ";
static int __pyx_f_7py_pari_3gen___cmp__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  int __pyx_v_tg;
  int __pyx_v_to;
  PyObject *__pyx_v_sg;
  PyObject *__pyx_v_so;
  int __pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  __pyx_v_sg = Py_None; Py_INCREF(__pyx_v_sg);
  __pyx_v_so = Py_None; Py_INCREF(__pyx_v_so);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_7py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2466; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2470 */
  __pyx_1 = gegal(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g,((struct __pyx_obj_7py_pari_gen *)__pyx_v_other)->g);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2471 */
    __pyx_r = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2473 */
  __pyx_v_tg = typ(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2474 */
  __pyx_v_to = typ(((struct __pyx_obj_7py_pari_gen *)__pyx_v_other)->g);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2476 */
  __pyx_1 = __pyx_f_7py_pari_is_int_or_real_type(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g);
  if (__pyx_1) {
    __pyx_1 = __pyx_f_7py_pari_is_int_or_real_type(((struct __pyx_obj_7py_pari_gen *)__pyx_v_other)->g);
  }
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2477 */
    __pyx_r = gcmp(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g,((struct __pyx_obj_7py_pari_gen *)__pyx_v_other)->g);
    goto __pyx_L0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2479 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2479; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2479; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_self);
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2479; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_v_sg);
  __pyx_v_sg = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2480 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2480; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2480; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_other);
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2480; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_v_so);
  __pyx_v_so = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2481 */
  if (PyObject_Cmp(__pyx_v_sg, __pyx_v_so, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2481; goto __pyx_L1;}
  __pyx_1 = __pyx_1 < 0;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2482 */
    __pyx_r = (-1);
    goto __pyx_L0;
    goto __pyx_L4;
  }
  /*else*/ {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2484 */
    __pyx_r = 1;
    goto __pyx_L0;
  }
  __pyx_L4:;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.__cmp__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_sg);
  Py_DECREF(__pyx_v_so);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_n___cmp__;
static PyObject *__pyx_n_bool;

static PyObject *__pyx_f_7py_pari_3gen___richcmp__(PyObject *__pyx_v_self, PyObject *__pyx_v_other, int __pyx_v_op); /*proto*/
static char __pyx_doc_7py_pari_3gen___richcmp__[] = "\n        EXAMPLES:\n            >>> a = pari(5)\n            >>> b = 10\n            >>> a < b\n            True\n            >>> a <= b\n            True\n            >>> a <= 5\n            True\n            >>> a > b\n            False\n            >>> a >= b\n            False\n            >>> a >= pari(10)\n            False\n            >>> a == 5\n            True\n            >>> a is 5\n            False\n        ";
static PyObject *__pyx_f_7py_pari_3gen___richcmp__(PyObject *__pyx_v_self, PyObject *__pyx_v_other, int __pyx_v_op) {
  int __pyx_v_n;
  struct __pyx_obj_7py_pari_gen *__pyx_v_x;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  ((PyObject*)__pyx_v_x) = Py_None; Py_INCREF(((PyObject*)__pyx_v_x));
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_self), __pyx_ptype_7py_pari_gen, 1, "self")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2487; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2511 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2511; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2511; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2511; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2511; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_x));
  ((PyObject *)__pyx_v_x) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2512 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n___cmp__); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2512; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2512; goto __pyx_L1;}
  Py_INCREF(((PyObject *)__pyx_v_x));
  PyTuple_SET_ITEM(__pyx_2, 0, ((PyObject *)__pyx_v_x));
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2512; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_4 = PyInt_AsLong(__pyx_3); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2512; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_v_n = __pyx_4;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2513 */
  __pyx_4 = (__pyx_v_op == 0);
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2514 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2514; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong((__pyx_v_n < 0)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2514; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2514; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2514; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_4 = (__pyx_v_op == 1);
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2516 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2516; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong((__pyx_v_n <= 0)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2516; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2516; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_3);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2516; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_4 = (__pyx_v_op == 2);
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2518 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2518; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong((__pyx_v_n == 0)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2518; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2518; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2518; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_4 = (__pyx_v_op == 3);
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2520 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2520; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong((__pyx_v_n != 0)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2520; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2520; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_3);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2520; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_4 = (__pyx_v_op == 4);
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2522 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2522; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong((__pyx_v_n > 0)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2522; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2522; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2522; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_4 = (__pyx_v_op == 5);
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2524 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2524; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong((__pyx_v_n >= 0)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2524; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2524; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_3);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2524; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.__richcmp__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_copy(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_copy(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2527 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2527; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.copy");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_replace;
static PyObject *__pyx_n_find;

static PyObject *__pyx_k70p;
static PyObject *__pyx_k71p;
static PyObject *__pyx_k72p;
static PyObject *__pyx_k73p;
static PyObject *__pyx_k74p;
static PyObject *__pyx_k75p;
static PyObject *__pyx_k76p;
static PyObject *__pyx_k77p;
static PyObject *__pyx_k78p;
static PyObject *__pyx_k79p;

static char (__pyx_k70[]) = "Mat(";
static char (__pyx_k71[]) = "[";
static char (__pyx_k72[]) = "]";
static char (__pyx_k73[]) = "~";
static char (__pyx_k74[]) = "";
static char (__pyx_k75[]) = ";";
static char (__pyx_k76[]) = ";";
static char (__pyx_k77[]) = "], [";
static char (__pyx_k78[]) = "[";
static char (__pyx_k79[]) = "]";

static PyObject *__pyx_f_7py_pari_3gen_list_str(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_list_str[] = "\n        Return str that might correctly evaluate to a Python-list.\n        ";
static PyObject *__pyx_f_7py_pari_3gen_list_str(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_s;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_s = Py_None; Py_INCREF(__pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2540 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2540; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2540; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2540; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2541 */
  __pyx_1 = PySequence_GetSlice(__pyx_v_s, 0, 4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2541; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_k70p, &__pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2541; goto __pyx_L1;}
  __pyx_4 = __pyx_4 == 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2542 */
    __pyx_2 = PySequence_GetSlice(__pyx_v_s, 4, (-1)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2542; goto __pyx_L1;}
    __pyx_3 = PyNumber_Add(__pyx_k71p, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2542; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_1 = PyNumber_Add(__pyx_3, __pyx_k72p); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2542; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_v_s);
    __pyx_v_s = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2543 */
  __pyx_2 = PyObject_GetAttr(__pyx_v_s, __pyx_n_replace); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2543; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2543; goto __pyx_L1;}
  Py_INCREF(__pyx_k73p);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_k73p);
  Py_INCREF(__pyx_k74p);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k74p);
  __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2543; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2544 */
  __pyx_2 = PyObject_GetAttr(__pyx_v_s, __pyx_n_find); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2544; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2544; goto __pyx_L1;}
  Py_INCREF(__pyx_k75p);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_k75p);
  __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2544; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_2 = PyInt_FromLong((-1)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2544; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_2, &__pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2544; goto __pyx_L1;}
  __pyx_4 = __pyx_4 != 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2545 */
    __pyx_3 = PyObject_GetAttr(__pyx_v_s, __pyx_n_replace); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2545; goto __pyx_L1;}
    __pyx_1 = PyTuple_New(2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2545; goto __pyx_L1;}
    Py_INCREF(__pyx_k76p);
    PyTuple_SET_ITEM(__pyx_1, 0, __pyx_k76p);
    Py_INCREF(__pyx_k77p);
    PyTuple_SET_ITEM(__pyx_1, 1, __pyx_k77p);
    __pyx_2 = PyObject_CallObject(__pyx_3, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2545; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_v_s);
    __pyx_v_s = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2546 */
    __pyx_3 = PyNumber_Add(__pyx_k78p, __pyx_v_s); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2546; goto __pyx_L1;}
    __pyx_1 = PyNumber_Add(__pyx_3, __pyx_k79p); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2546; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_v_s);
    __pyx_v_s = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2547 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_eval); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2547; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2547; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_s);
    __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2547; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
    goto __pyx_L3;
  }
  /*else*/ {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2549 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_eval); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2549; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2549; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_s);
    __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2549; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
  }
  __pyx_L3:;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.list_str");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k80p;

static char (__pyx_k80[]) = "error in __int__";

static PyObject *__pyx_f_7py_pari_3gen___int__(PyObject *__pyx_v_self); /*proto*/
static char __pyx_doc_7py_pari_3gen___int__[] = "\n        Return C int.\n        ";
static PyObject *__pyx_f_7py_pari_3gen___int__(PyObject *__pyx_v_self) {
  int __pyx_v_err;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2556 */
  __pyx_v_err = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2557 */
  __pyx_1 = __pyx_v_err;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2557; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2557; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2557; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k80p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k80p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2557; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2558 */
  __pyx_2 = PyInt_FromLong(gtolong(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2558; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.__int__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_python;

static PyObject *__pyx_k81p;

static char (__pyx_k81[]) = "sage.pari.py_pari_py";

static PyObject *__pyx_f_7py_pari_3gen_python(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_python[] = "\n        Return Python eval of self.\n        ";
static PyObject *__pyx_f_7py_pari_3gen_python(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_sage;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_sage = Py_None; Py_INCREF(__pyx_v_sage);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2570 */
  __pyx_1 = __Pyx_Import(__pyx_k81p, 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2570; goto __pyx_L1;}
  Py_DECREF(__pyx_v_sage);
  __pyx_v_sage = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2571 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_sage, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2571; goto __pyx_L1;}
  __pyx_2 = PyObject_GetAttr(__pyx_1, __pyx_n_py_pari_py); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2571; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_1 = PyObject_GetAttr(__pyx_2, __pyx_n_python); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2571; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2571; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2571; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.python");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_sage);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_long;

static PyObject *__pyx_k82p;

static char (__pyx_k82[]) = "error in __long__";

static PyObject *__pyx_f_7py_pari_3gen___long__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___long__(PyObject *__pyx_v_self) {
  int __pyx_v_err;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2575 */
  __pyx_v_err = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2576 */
  __pyx_1 = __pyx_v_err;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2576; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2576; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2576; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k82p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k82p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2576; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2577 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_long); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2577; goto __pyx_L1;}
  __pyx_4 = PyInt_FromLong(gtolong(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2577; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2577; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_4);
  __pyx_4 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2577; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_r = __pyx_4;
  __pyx_4 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.__long__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k83p;

static char (__pyx_k83[]) = "error in __float__";

static PyObject *__pyx_f_7py_pari_3gen___float__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___float__(PyObject *__pyx_v_self) {
  int __pyx_v_err;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2581 */
  __pyx_v_err = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2582 */
  __pyx_1 = __pyx_v_err;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2582; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2582; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2582; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k83p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k83p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2582; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2583 */
  __pyx_2 = PyFloat_FromDouble(gtodouble(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2583; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.__float__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k84p;

static char (__pyx_k84[]) = "error in __bool__";

static PyObject *__pyx_f_7py_pari_3gen___bool__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___bool__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_err;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2587 */
  __pyx_v_err = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2588 */
  __pyx_1 = __pyx_v_err;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2588; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2588; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2588; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k84p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k84p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2588; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2589 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2589; goto __pyx_L1;}
  __pyx_4 = PyInt_FromLong((((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g != stoi(0))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2589; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2589; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_4);
  __pyx_4 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2589; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_r = __pyx_4;
  __pyx_4 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.__bool__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_isprime(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_isprime[] = "\n        isprime(x, flag=0): Returns True if x is a PROVEN prime\n        number, and False otherwise. \n\n        INPUT:\n            flag -- int \n                    0 (default): use a combination of algorithms.\n                    1: certify primality using the Pocklington-Lehmer Test.\n                    2: certify primality using the APRCL test.\n        OUTPUT:\n            bool -- True or False\n        EXAMPLES:\n            >>> pari(9).isprime()\n            False\n            >>> pari(17).isprime()\n            True\n            >>> n = pari(561)    # smallest Carmichael number\n            >>> n.isprime()      # not just a pseudo-primality test!\n            False\n            >>> n.isprime(1)\n            False\n            >>> n.isprime(2)\n            False\n        ";
static PyObject *__pyx_f_7py_pari_3gen_isprime(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_flag = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  long __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"flag",0};
  __pyx_v_flag = __pyx_k6;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_flag);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2620 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2620; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2620; goto __pyx_L1;}
  __pyx_3 = PyInt_FromLong((gisprime(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g,__pyx_2) != stoi(0))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2620; goto __pyx_L1;}
  __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2620; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
  __pyx_3 = 0;
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2620; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.isprime");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_flag);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_divrem(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_divrem[] = "\n\n        divrem(x, y, {v}): Euclidean division of x by y giving as a\n            2-dimensional column vector the quotient and the\n            remainder, with respect to v (to main variable if v is\n            omitted).\n\n        >>> \n        ";
static PyObject *__pyx_f_7py_pari_3gen_divrem(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  PyObject *__pyx_v_var = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__y;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"y","var",0};
  __pyx_v_var = __pyx_k7;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|O", __pyx_argnames, &__pyx_v_y, &__pyx_v_var)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  Py_INCREF(__pyx_v_var);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2637 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2637; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2637; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2637; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2637; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2638 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(divrem(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),__pyx_v__y->g,__pyx_f_7py_pari_get_var(__pyx_v_var)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2638; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.divrem");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  Py_DECREF(__pyx_v_var);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_lex(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_lex[] = "\n\n        lex(x,y): Compare x and y lexicographically (1 if x>y, 0 if\n            x==y, -1 if x<y)\n        \n        ";
static PyObject *__pyx_f_7py_pari_3gen_lex(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__y;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2648 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2648; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2648; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2648; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2648; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2649 */
  __pyx_1 = PyInt_FromLong(lexcmp(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g,__pyx_v__y->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2649; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.lex");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_max(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_max[] = "\n        max(x,y): Return the maximum of x and y.\n        ";
static PyObject *__pyx_f_7py_pari_3gen_max(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__y;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2656 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2656; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2656; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2656; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2656; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2657 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gmax(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),__pyx_v__y->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2657; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.max");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_min(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_min[] = "\n        min(x,y): Return the minumum of x and y.\n        ";
static PyObject *__pyx_f_7py_pari_3gen_min(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__y;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2664 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2664; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2664; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2664; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2664; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2665 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gmin(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),__pyx_v__y->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2665; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.min");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_shift(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_shift[] = "\n        shift(x,n): shift x left n bits if n>=0, right -n bits if n<0.\n        ";
static PyObject *__pyx_f_7py_pari_3gen_shift(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2671 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gshift(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),__pyx_v_n))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2671; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.shift");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_shiftmul(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_shiftmul[] = "\n        shiftmul(x,n): Return the product of x by 2^n (n>=0 or n<0).\n        ";
static PyObject *__pyx_f_7py_pari_3gen_shiftmul(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2677 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gmul2n(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),__pyx_v_n))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2677; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.shiftmul");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_sign(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_sign[] = "\n        sign(x): Return the sign of x, where x is of type integer, real\n            or fraction.\n        ";
static PyObject *__pyx_f_7py_pari_3gen_sign(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2684 */
  __pyx_1 = PyInt_FromLong(gsigne(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2684; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.sign");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_vecmax(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_vecmax[] = "\n        vecmax(x): Return the maximum of the elements of the vector/matrix x,\n        ";
static PyObject *__pyx_f_7py_pari_3gen_vecmax(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2690 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(vecmax(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2690; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.vecmax");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_vecmin(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_vecmin[] = "\n        vecmin(x): Return the maximum of the elements of the vector/matrix x,\n        ";
static PyObject *__pyx_f_7py_pari_3gen_vecmin(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2697 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(vecmin(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2697; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.vecmin");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_n_NotImplementedError;

static PyObject *__pyx_f_7py_pari_3gen_Col(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Col[] = "\n        Col(x): Transforms the object x into a column vector. \n        ";
static PyObject *__pyx_f_7py_pari_3gen_Col(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2712 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2712; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2712; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Col");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_List(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_List[] = "\n        List(x): transforms the PARI vector or list x into a list.\n\n        EXAMPLES:\n            >>> v = pari([1,2,3])\n            >>> v\n            [1, 2, 3]\n            >>> v.type()\n            \'t_VEC\'\n            >>> w = v.List()\n            >>> w\n            List([1, 2, 3])\n            >>> w.type()\n            \'t_LIST\'\n        ";
static PyObject *__pyx_f_7py_pari_3gen_List(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2730 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gtolist(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2730; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.List");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Mat(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Mat[] = "\n        Mat(x): transforms any PARI x into a matrix.\n\n        EXAMPLES:\n            >>> x = pari(5)\n            >>> x.type()\n            \'t_INT\'\n            >>> y = x.Mat()\n            >>> y\n            Mat(5)\n            >>> y.type()\n            \'t_MAT\'\n            >>> x = pari(\'[1,2;3,4]\')\n            >>> x.type()\n            \'t_MAT\'\n            >>> x = pari(\'[1,2,3,4]\')\n            >>> x.type()\n            \'t_VEC\'\n            >>> y = x.Mat()\n            >>> y\n            Mat([1, 2, 3, 4])\n            >>> y.type()\n            \'t_MAT\'\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Mat(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2757 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gtomat(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2757; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Mat");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Mod(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Mod[] = "\n        Mod(x, y): creates the object x modulo y.\n\n        INPUT:\n            x -- gen\n            y -- gen\n            \n        EXAMPLES:\n            >>> z = pari(3)\n            >>> x = z.Mod(pari(7))\n            >>> x\n            Mod(3, 7)\n            >>> x**2\n            Mod(2, 7)\n            >>> x**100\n            Mod(4, 7)\n            >>> x.type()\n            \'t_INTMOD\'\n\n            >>> f = pari(\"x^2 + x + 1\")\n            >>> g = pari(\"x\")\n            >>> a = g.Mod(f)\n            >>> a\n            Mod(x, x^2 + x + 1)\n            >>> a*a\n            Mod(-x - 1, x^2 + x + 1)\n            >>> a.type()\n            \'t_POLMOD\'\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Mod(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__y;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2790 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2790; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2790; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2790; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2790; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2791 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gmodulcp(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),__pyx_v__y->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2791; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.Mod");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_n_TypeError;

static PyObject *__pyx_k85p;

static char (__pyx_k85[]) = "Unable to convert PARI object %s to a polynomial.";

static PyObject *__pyx_f_7py_pari_3gen_Pol(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Pol[] = "\n        Pol(x): convert x (usually a vector or a power series) into a\n        polynomial, starting with the leading coefficient\n\n        INPUT:\n            x -- gen\n            var -- (optional) which variable\n        OUTPUT:\n            gen -- a polynomial\n        EXAMPLES:\n            >>> v = pari(\"[1,2,3,4]\")\n            >>> f = v.Pol()\n            >>> f\n            x^3 + 2*x^2 + 3*x + 4\n            >>> f*f\n            x^6 + 4*x^5 + 10*x^4 + 20*x^3 + 25*x^2 + 24*x + 16\n            \n            >>> v = pari(\"[1,2;3,4]\")\n            >>> v.Pol()\n            [1, 3]~*x + [2, 4]~\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Pol(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_var = 0;
  long __pyx_v_t;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"var",0};
  __pyx_v_var = __pyx_k8;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_var)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_var);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2817 */
  __pyx_v_t = typ(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2818 */
  __pyx_1 = (__pyx_v_t != t_POL);
  if (__pyx_1) {
    __pyx_1 = (__pyx_v_t != t_SER);
    if (__pyx_1) {
      __pyx_1 = (__pyx_v_t != t_POL);
      if (__pyx_1) {
        __pyx_1 = (__pyx_v_t != t_RFRAC);
        if (__pyx_1) {
          __pyx_1 = (__pyx_v_t != t_QFR);
          if (__pyx_1) {
            __pyx_1 = (__pyx_v_t != t_QFI);
            if (__pyx_1) {
              __pyx_1 = (__pyx_v_t != t_VEC);
              if (__pyx_1) {
                __pyx_1 = (__pyx_v_t != t_COL);
                if (__pyx_1) {
                  __pyx_1 = (__pyx_v_t != t_MAT);
                }
              }
            }
          }
        }
      }
    }
  }
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2820 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2820; goto __pyx_L1;}
    __pyx_3 = PyNumber_Remainder(__pyx_k85p, __pyx_v_x); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2820; goto __pyx_L1;}
    __Pyx_Raise(__pyx_2, __pyx_3, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2820; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2821 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(gtopoly(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),__pyx_f_7py_pari_get_var(__pyx_v_var)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2821; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.Pol");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_var);
  return __pyx_r;
}

static PyObject *__pyx_k86p;

static char (__pyx_k86[]) = "Unable to convert PARI object %s to a polynomial.";

static PyObject *__pyx_f_7py_pari_3gen_Polrev(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Polrev[] = "\n        Polrev(x): convert x (usually a vector or a power series) into a\n        polynomial, starting with the constant\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen -- a polynomial\n        EXAMPLES:\n            >>> v = pari(\"[1,2,3,4]\")\n            >>> f = v.Polrev()\n            >>> f\n            4*x^3 + 3*x^2 + 2*x + 1\n            >>> f*f\n            16*x^6 + 24*x^5 + 25*x^4 + 20*x^3 + 10*x^2 + 4*x + 1\n            \n        Note that Polrev does *not* reverse the coefficients of a polynomial!\n            >>> f.Polrev()\n            4*x^3 + 3*x^2 + 2*x + 1\n            >>> v = pari(\"[1,2;3,4]\")\n            >>> v.Polrev()\n            [2, 4]~*x + [1, 3]~\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Polrev(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_var = 0;
  long __pyx_v_t;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"var",0};
  __pyx_v_var = __pyx_k9;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_var)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_var);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2849 */
  __pyx_v_t = typ(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2850 */
  __pyx_1 = (__pyx_v_t != t_POL);
  if (__pyx_1) {
    __pyx_1 = (__pyx_v_t != t_SER);
    if (__pyx_1) {
      __pyx_1 = (__pyx_v_t != t_POL);
      if (__pyx_1) {
        __pyx_1 = (__pyx_v_t != t_RFRAC);
        if (__pyx_1) {
          __pyx_1 = (__pyx_v_t != t_QFR);
          if (__pyx_1) {
            __pyx_1 = (__pyx_v_t != t_QFI);
            if (__pyx_1) {
              __pyx_1 = (__pyx_v_t != t_VEC);
              if (__pyx_1) {
                __pyx_1 = (__pyx_v_t != t_COL);
                if (__pyx_1) {
                  __pyx_1 = (__pyx_v_t != t_MAT);
                }
              }
            }
          }
        }
      }
    }
  }
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2852 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2852; goto __pyx_L1;}
    __pyx_3 = PyNumber_Remainder(__pyx_k86p, __pyx_v_x); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2852; goto __pyx_L1;}
    __Pyx_Raise(__pyx_2, __pyx_3, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2852; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2853 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(gtopolyrev(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),__pyx_f_7py_pari_get_var(__pyx_v_var)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2853; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.Polrev");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_var);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Qfb(PyObject *__pyx_v_a, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Qfb[] = "\n        Qfb(a,b,c,{D=0.}): binary quadratic form a*x^2+b*x*y+c*y^2.\n            D is optional (0.0 by default) and initializes\n            Shanks\'s distance if b^2-4*a*c>0\n\n        INPUT:\n            a -- gen\n            b -- gen\n            c -- gen\n            D -- gen\n        OUTPUT:\n            gen -- binary quadratic form\n        EXAMPLES:\n            >>> pari(3).Qfb(7, 2)\n            Qfb(3, 7, 2, 0.E-28)\n            \n        ";
static PyObject *__pyx_f_7py_pari_3gen_Qfb(PyObject *__pyx_v_a, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_b = 0;
  PyObject *__pyx_v_c = 0;
  PyObject *__pyx_v_D = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__b;
  struct __pyx_obj_7py_pari_gen *__pyx_v__c;
  struct __pyx_obj_7py_pari_gen *__pyx_v__D;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"b","c","D",0};
  __pyx_v_D = __pyx_k10;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO|O", __pyx_argnames, &__pyx_v_b, &__pyx_v_c, &__pyx_v_D)) return 0;
  Py_INCREF(__pyx_v_a);
  Py_INCREF(__pyx_v_b);
  Py_INCREF(__pyx_v_c);
  Py_INCREF(__pyx_v_D);
  ((PyObject*)__pyx_v__b) = Py_None; Py_INCREF(((PyObject*)__pyx_v__b));
  ((PyObject*)__pyx_v__c) = Py_None; Py_INCREF(((PyObject*)__pyx_v__c));
  ((PyObject*)__pyx_v__D) = Py_None; Py_INCREF(((PyObject*)__pyx_v__D));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2875 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2875; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2875; goto __pyx_L1;}
  Py_INCREF(__pyx_v_b);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_b);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2875; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2875; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__b));
  ((PyObject *)__pyx_v__b) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2876 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2876; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2876; goto __pyx_L1;}
  Py_INCREF(__pyx_v_c);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_c);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2876; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2876; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__c));
  ((PyObject *)__pyx_v__c) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2877 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2877; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2877; goto __pyx_L1;}
  Py_INCREF(__pyx_v_D);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_D);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2877; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2877; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__D));
  ((PyObject *)__pyx_v__D) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2878 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(Qfb0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_a)->g),__pyx_v__b->g,__pyx_v__c->g,__pyx_v__D->g,__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2878; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.Qfb");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__b);
  Py_DECREF(__pyx_v__c);
  Py_DECREF(__pyx_v__D);
  Py_DECREF(__pyx_v_a);
  Py_DECREF(__pyx_v_b);
  Py_DECREF(__pyx_v_c);
  Py_DECREF(__pyx_v_D);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Ser(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Ser[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Ser(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2884 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2884; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2884; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Ser");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Set(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Set[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Set(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2889 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2889; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2889; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Set");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Str(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Str[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Str(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2894 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2894; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2894; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Str");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Strchr(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Strchr[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Strchr(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2899 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2899; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2899; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Strchr");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Strexpand(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Strexpand[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Strexpand(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2904 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2904; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2904; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Strexpand");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Strtex(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Strtex[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Strtex(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2909 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2909; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2909; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Strtex");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Vec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Vec[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Vec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2914 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gtovec(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2914; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Vec");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_k87p;

static char (__pyx_k87[]) = "x must have PARI type one of t_VECSMALL, t_INT or t_STR";

static PyObject *__pyx_f_7py_pari_3gen_Vecsmall(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Vecsmall[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Vecsmall(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_t;
  PyObject *__pyx_r;
  int __pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2920 */
  __pyx_v_t = typ(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2921 */
  __pyx_1 = (__pyx_v_t == t_VECSMALL);
  if (!__pyx_1) {
    __pyx_1 = (__pyx_v_t == t_INT);
    if (!__pyx_1) {
      __pyx_1 = (__pyx_v_t == t_STR);
    }
  }
  __pyx_2 = (!__pyx_1);
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2922 */
    __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2922; goto __pyx_L1;}
    __Pyx_Raise(__pyx_3, __pyx_k87p, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2922; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2923 */
  __pyx_3 = ((PyObject *)__pyx_f_7py_pari_new_gen(gtovecsmall(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g)))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2923; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.Vecsmall");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_binary(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_binary[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_binary(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2928 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2928; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2928; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.binary");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_bitand(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_bitand[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_bitand(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2933 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2933; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2933; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.bitand");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_bitneg(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_bitneg[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_bitneg(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2938 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2938; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2938; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.bitneg");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_bitnegimply(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_bitnegimply[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_bitnegimply(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2943 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2943; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2943; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.bitnegimply");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_bitor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_bitor[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_bitor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2948 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2948; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2948; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.bitor");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_bittest(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_bittest[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_bittest(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2953 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2953; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2953; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.bittest");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_bitxor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_bitxor[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_bitxor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2958 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2958; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2958; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.bitxor");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ceil(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_ceil[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_ceil(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2963 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2963; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2963; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ceil");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_centerlift(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_centerlift[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_centerlift(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2968 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2968; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2968; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.centerlift");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_changevar(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_changevar[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_changevar(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2973 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2973; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2973; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.changevar");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_component(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_component[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_component(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2978 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2978; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2978; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.component");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_conj(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_conj[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_conj(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2983 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2983; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2983; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.conj");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_conjvec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_conjvec[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_conjvec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2988 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2988; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2988; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.conjvec");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_denominator(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_denominator[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_denominator(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2993 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2993; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2993; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.denominator");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_floor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_floor[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_floor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2998 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gfloor(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2998; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.floor");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_frac(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_frac[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_frac(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3003 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3003; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3003; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.frac");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_k88p;

static char (__pyx_k88[]) = "error in imag";

static PyObject *__pyx_f_7py_pari_3gen_imag(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_imag(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3007 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3008 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3009 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3009; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3009; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3009; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k88p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k88p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3009; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3010 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(gimag(forcecopy(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g))))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3010; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.imag");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_length(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_length[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_length(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3015 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3015; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3015; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.length");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_k89p;

static char (__pyx_k89[]) = "error in lift";

static PyObject *__pyx_f_7py_pari_3gen_lift(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_lift[] = "\n        EXAMPLES:\n            >>> x = pari(\"x\")\n            >>> a = x.Mod(x**3 + 17*x + 3)\n            >>> a\n            Mod(x, x^3 + 17*x + 3)\n            >>> b = a**4; b\n            Mod(-17*x^2 - 3*x, x^3 + 17*x + 3)\n            >>> b.lift()\n            -17*x^2 - 3*x\n        ";
static PyObject *__pyx_f_7py_pari_3gen_lift(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3029 */
  __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3029; goto __pyx_L1;}
  Py_DECREF(__pyx_v_n);
  __pyx_v_n = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3030 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3030; goto __pyx_L1;}
  if (__pyx_2) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3030; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3030; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    Py_INCREF(__pyx_k89p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k89p);
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3030; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3031 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(lift(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3031; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.lift");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_numerator(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_numerator[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_numerator(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3036 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3036; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3036; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.numerator");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_numtoperm(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_numtoperm[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_numtoperm(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3041 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3041; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3041; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.numtoperm");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_padicprec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_padicprec[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_padicprec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3046 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3046; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3046; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.padicprec");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_permtonum(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_permtonum[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_permtonum(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3051 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3051; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3051; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.permtonum");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_precision(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_precision[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_precision(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3056 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3056; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3056; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.precision");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_random(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_random[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_random(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3061 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3061; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3061; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.random");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_k90p;

static char (__pyx_k90[]) = "error in real";

static PyObject *__pyx_f_7py_pari_3gen_real(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_real(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3065 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3066 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3067 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3067; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3067; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3067; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k90p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k90p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3067; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3068 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(greal(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3068; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.real");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_round(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_round[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_round(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3073 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3073; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3073; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.round");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_simplify(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_simplify[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_simplify(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3078 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3078; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3078; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.simplify");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_sizebyte(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_sizebyte[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_sizebyte(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3083 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3083; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3083; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.sizebyte");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_sizedigit(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_sizedigit[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_sizedigit(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3088 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3088; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3088; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.sizedigit");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_truncate(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_truncate[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_truncate(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3093 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3093; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3093; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.truncate");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_valuation(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_valuation[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_valuation(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3098 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3098; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3098; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.valuation");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_variable(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_variable[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_variable(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3103 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3103; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3103; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.variable");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_k91p;

static char (__pyx_k91[]) = "error in sqrt";

static PyObject *__pyx_f_7py_pari_3gen_sqrt(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_sqrt(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_prec;
  int __pyx_v_err;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"prec",0};
  __pyx_v_prec = __pyx_k11;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|i", __pyx_argnames, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3112 */
  __pyx_v_err = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3113 */
  __pyx_1 = __pyx_v_err;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3113; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3113; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3113; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k91p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k91p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3113; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3114 */
  __pyx_1 = (!__pyx_v_prec);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3115 */
    __pyx_v_prec = __pyx_v_7py_pari_REAL_PREC;
    goto __pyx_L3;
  }
  __pyx_1 = (__pyx_v_prec < 3);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3117 */
    __pyx_v_prec = 3;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3118 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(gsqrt(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),__pyx_v_prec))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3118; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.sqrt");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_k92p;

static char (__pyx_k92[]) = "error evaluating gamma(%s)";

static PyObject *__pyx_f_7py_pari_3gen_gamma(PyObject *__pyx_v_s, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_gamma[] = "\n        gamma(x): Gamma function at s.\n        INPUT:\n            s -- gen (real or complex number\n        OUTPUT:\n            gen -- value of zeta at s.\n        EXAMPLES:\n        ";
static PyObject *__pyx_f_7py_pari_3gen_gamma(PyObject *__pyx_v_s, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_prec;
  int __pyx_v_err;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {"prec",0};
  __pyx_v_prec = __pyx_k12;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|i", __pyx_argnames, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3130 */
  __pyx_v_err = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3131 */
  __pyx_1 = __pyx_v_err;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3131; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3131; goto __pyx_L1;}
    __pyx_4 = PyNumber_Remainder(__pyx_k92p, __pyx_v_s); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3131; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3131; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
    __pyx_3 = 0;
    __pyx_4 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3131; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3132 */
  __pyx_1 = (!__pyx_v_prec);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3133 */
    __pyx_v_prec = __pyx_v_7py_pari_REAL_PREC;
    goto __pyx_L3;
  }
  __pyx_1 = (__pyx_v_prec < 3);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3135 */
    __pyx_v_prec = 3;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3136 */
  __pyx_4 = ((PyObject *)__pyx_f_7py_pari_new_gen(ggamma(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_s)->g),__pyx_v_prec))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3136; goto __pyx_L1;}
  __pyx_r = __pyx_4;
  __pyx_4 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.gen.gamma");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  return __pyx_r;
}

static PyObject *__pyx_k93p;

static char (__pyx_k93[]) = "error evaluating zeta(%s)";

static PyObject *__pyx_f_7py_pari_3gen_zeta(PyObject *__pyx_v_s, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_zeta[] = "\n        zeta(s): Riemann zeta function at s with s a complex\n                 or a p-adic number.\n        INPUT:\n            s -- gen (real or complex number\n        OUTPUT:\n            gen -- value of zeta at s.\n        EXAMPLES:\n        ";
static PyObject *__pyx_f_7py_pari_3gen_zeta(PyObject *__pyx_v_s, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_prec;
  int __pyx_v_err;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {"prec",0};
  __pyx_v_prec = __pyx_k13;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|i", __pyx_argnames, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3150 */
  __pyx_v_err = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3151 */
  __pyx_1 = __pyx_v_err;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3151; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3151; goto __pyx_L1;}
    __pyx_4 = PyNumber_Remainder(__pyx_k93p, __pyx_v_s); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3151; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3151; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
    __pyx_3 = 0;
    __pyx_4 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3151; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3152 */
  __pyx_1 = (!__pyx_v_prec);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3153 */
    __pyx_v_prec = __pyx_v_7py_pari_REAL_PREC;
    goto __pyx_L3;
  }
  __pyx_1 = (__pyx_v_prec < 3);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3155 */
    __pyx_v_prec = 3;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3156 */
  __pyx_4 = ((PyObject *)__pyx_f_7py_pari_new_gen(gzeta(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_s)->g),__pyx_v_prec))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3156; goto __pyx_L1;}
  __pyx_r = __pyx_4;
  __pyx_4 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.gen.zeta");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  return __pyx_r;
}

static PyObject *__pyx_k94p;

static char (__pyx_k94[]) = "error in issquare";

static PyObject *__pyx_f_7py_pari_3gen_issquare(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_issquare(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_err;
  GEN __pyx_v_G;
  GEN __pyx_v_t;
  struct __pyx_obj_7py_pari_gen *__pyx_v_g;
  PyObject *__pyx_v_v;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);
  ((PyObject*)__pyx_v_g) = Py_None; Py_INCREF(((PyObject*)__pyx_v_g));
  __pyx_v_v = Py_None; Py_INCREF(__pyx_v_v);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3167 */
  __pyx_v_err = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3168 */
  __pyx_1 = __pyx_v_err;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3168; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3168; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3168; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k94p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k94p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3168; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3169 */
  __pyx_v_t = gcarrecomplet(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),(&__pyx_v_G));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3170 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3170; goto __pyx_L1;}
  __pyx_4 = ((PyObject *)__pyx_f_7py_pari_new_gen_noclear(__pyx_v_t)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3170; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3170; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_4);
  __pyx_4 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3170; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_v_v);
  __pyx_v_v = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3171 */
  __pyx_1 = PyObject_IsTrue(__pyx_v_v); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3171; goto __pyx_L1;}
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3172 */
    __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(__pyx_v_G)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3172; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3172; goto __pyx_L1;}
    Py_INCREF(__pyx_v_v);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_v);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_2);
    __pyx_2 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
    goto __pyx_L3;
  }
  /*else*/ {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3174 */
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3174; goto __pyx_L1;}
    Py_INCREF(__pyx_v_v);
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_v);
    Py_INCREF(Py_None);
    PyTuple_SET_ITEM(__pyx_4, 1, Py_None);
    __pyx_r = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L0;
  }
  __pyx_L3:;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.issquare");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_g);
  Py_DECREF(__pyx_v_v);
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_issquarefree(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_issquarefree(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3177 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3177; goto __pyx_L1;}
  __pyx_2 = PyInt_FromLong(issquarefree(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3177; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3177; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
  __pyx_2 = 0;
  __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3177; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.issquarefree");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k95p;

static char (__pyx_k95[]) = "error in lcm";

static PyObject *__pyx_f_7py_pari_3gen_lcm(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_lcm(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__y;
  int __pyx_v_err;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3181 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3181; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3181; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3181; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3181; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3183 */
  __pyx_v_err = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3184 */
  __pyx_4 = __pyx_v_err;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3184; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_err); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3184; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3184; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k95p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k95p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3184; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3185 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(glcm(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),forcecopy(__pyx_v__y->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3185; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.lcm");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_k96p;

static char (__pyx_k96[]) = "error in gcd";

static PyObject *__pyx_f_7py_pari_3gen_gcd(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_gcd(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__y;
  int __pyx_v_err;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3189 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3189; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3189; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3189; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3189; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3191 */
  __pyx_v_err = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3192 */
  __pyx_4 = __pyx_v_err;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3192; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_err); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3192; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3192; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k96p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k96p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3192; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3193 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(ggcd(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),forcecopy(__pyx_v__y->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3193; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.gcd");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_k97p;

static char (__pyx_k97[]) = "error in bezout";

static PyObject *__pyx_f_7py_pari_3gen_bezout(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_bezout(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__y;
  struct __pyx_obj_7py_pari_gen *__pyx_v_u;
  struct __pyx_obj_7py_pari_gen *__pyx_v_v;
  struct __pyx_obj_7py_pari_gen *__pyx_v_g;
  GEN __pyx_v_U;
  GEN __pyx_v_V;
  GEN __pyx_v_G;
  int __pyx_v_err;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));
  ((PyObject*)__pyx_v_u) = Py_None; Py_INCREF(((PyObject*)__pyx_v_u));
  ((PyObject*)__pyx_v_v) = Py_None; Py_INCREF(((PyObject*)__pyx_v_v));
  ((PyObject*)__pyx_v_g) = Py_None; Py_INCREF(((PyObject*)__pyx_v_g));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3198 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3198; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3198; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3198; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3198; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3200 */
  __pyx_v_err = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3201 */
  __pyx_4 = __pyx_v_err;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3201; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_err); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3201; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3201; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k97p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k97p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3201; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3202 */
  __pyx_v_G = gbezout(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),forcecopy(__pyx_v__y->g),(&__pyx_v_U),(&__pyx_v_V));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3203 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen_noclear(__pyx_v_G)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3203; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_g));
  ((PyObject *)__pyx_v_g) = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3204 */
  __pyx_3 = ((PyObject *)__pyx_f_7py_pari_new_gen_noclear(__pyx_v_U)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3204; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_u));
  ((PyObject *)__pyx_v_u) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3205 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(__pyx_v_V)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3205; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_v));
  ((PyObject *)__pyx_v_v) = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3206 */
  __pyx_1 = PyTuple_New(3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3206; goto __pyx_L1;}
  Py_INCREF(((PyObject *)__pyx_v_g));
  PyTuple_SET_ITEM(__pyx_1, 0, ((PyObject *)__pyx_v_g));
  Py_INCREF(((PyObject *)__pyx_v_u));
  PyTuple_SET_ITEM(__pyx_1, 1, ((PyObject *)__pyx_v_u));
  Py_INCREF(((PyObject *)__pyx_v_v));
  PyTuple_SET_ITEM(__pyx_1, 2, ((PyObject *)__pyx_v_v));
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.bezout");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_u);
  Py_DECREF(__pyx_v_v);
  Py_DECREF(__pyx_v_g);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_n_bezout;

static PyObject *__pyx_f_7py_pari_3gen_xgcd(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_xgcd(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3209 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_x, __pyx_n_bezout); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3209; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3209; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3209; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.xgcd");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_k98p;

static char (__pyx_k98[]) = "error in elladd";

static PyObject *__pyx_f_7py_pari_3gen_elladd(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_elladd[] = "\n        e.elladd(z1, z2)\n\n        Sum of the points z1 and z2 on the elliptic curve e.\n\n        INPUT:\n            e -- elliptic curve E\n            z1 -- point on E\n            z2 -- point on E\n            \n        OUTPUT:\n            point on E\n\n        EXAMPLES:\n        First we create an elliptic curve:\n        \n            >>> e = pari([0, 1, 1, -2, 0]).ellinit()\n            >>> str(e)[:65]   # first part of output\n            \'[0, 1, 1, -2, 0, 4, -4, 1, -3, 112, -856, 389, 1404928/389, [0.90\'\n            \n        Next we add two points on the elliptic curve.  Notice that\n        the Python lists are automatically converted to PARI objects so\n        you don\'t have to do that explicitly in your code.\n        \n            >>> e.elladd([1,0,1], [-1,1,1])\n            [-3/4, -15/8]\n        ";
static PyObject *__pyx_f_7py_pari_3gen_elladd(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_z1 = 0;
  PyObject *__pyx_v_z2 = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__z1;
  struct __pyx_obj_7py_pari_gen *__pyx_v__z2;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"z1","z2",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_z1, &__pyx_v_z2)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_z1);
  Py_INCREF(__pyx_v_z2);
  ((PyObject*)__pyx_v__z1) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z1));
  ((PyObject*)__pyx_v__z2) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z2));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3244 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3244; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3244; goto __pyx_L1;}
  Py_INCREF(__pyx_v_z1);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z1);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3244; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3244; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__z1));
  ((PyObject *)__pyx_v__z1) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3244 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3244; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3244; goto __pyx_L1;}
  Py_INCREF(__pyx_v_z2);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z2);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3244; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3244; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__z2));
  ((PyObject *)__pyx_v__z2) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3246 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3247 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3247; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3247; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3247; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k98p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k98p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3247; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3248 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(addell(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v__z1->g,__pyx_v__z2->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3248; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.elladd");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__z1);
  Py_DECREF(__pyx_v__z2);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_z1);
  Py_DECREF(__pyx_v_z2);
  return __pyx_r;
}

static PyObject *__pyx_k99p;

static char (__pyx_k99[]) = "error in ellak";

static PyObject *__pyx_f_7py_pari_3gen_ellak(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_ellak[] = "\n        e.ellak(n): Returns the coefficient a_n of the L-function of\n        the elliptic curve e, i.e. the coefficient of a newform of\n        weight 2 newform.\n\n        The curve e must be a medium or long vector of the type given\n        by ellinit. For this function to work for every n and not just\n        those prime to the conductor, e must be a minimal Weierstrass\n        equation. If this is not the case, use the function\n        ellminimalmodel first before using ellak (or you will get\n        INCORRECT RESULTS!)\n\n        INPUT:\n            e -- a PARI elliptic curve.\n            n -- integer ..\n\n        EXAMPLES:\n            >>> e = pari([0, -1, 1, -10, -20]).ellinit()\n            >>> e.ellak(6)\n            2\n            >>> e.ellak(2005)        \n            2\n            >>> e.ellak(-1)\n            0\n            >>> e.ellak(0)\n            0\n        ";
static PyObject *__pyx_f_7py_pari_3gen_ellak(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_n = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__n;
  int __pyx_v_r;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_n)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_n);
  ((PyObject*)__pyx_v__n) = Py_None; Py_INCREF(((PyObject*)__pyx_v__n));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3279 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3279; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3279; goto __pyx_L1;}
  Py_INCREF(__pyx_v_n);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_n);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3279; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3279; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__n));
  ((PyObject *)__pyx_v__n) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3281 */
  __pyx_v_r = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3282 */
  __pyx_4 = __pyx_v_r;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3282; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3282; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_n);
    Py_INCREF(__pyx_k99p);
    PyTuple_SET_ITEM(__pyx_2, 1, __pyx_k99p);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3282; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3283 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(akell(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v__n->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3283; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellak");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__n);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_n);
  return __pyx_r;
}

static PyObject *__pyx_n_ellan;

static PyObject *__pyx_k100p;

static char (__pyx_k100[]) = "error in ellan";

static PyObject *__pyx_f_7py_pari_3gen_ellan(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_ellan[] = "\n        EXAMPLES:\n            >>> e = pari([0, -1, 1, -10, -20]).ellinit()\n            >>> e.ellan(3)\n            [1, -2, -1]\n            >>> e.ellan(20)\n            [1, -2, -1, 2, 1, 2, -2, 0, -2, -2, 1, -2, 4, 4, -1, -4, -2, 4, 0, 2]\n            >>> e.ellan(-1)\n            []\n        ";
static PyObject *__pyx_f_7py_pari_3gen_ellan(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  int __pyx_v_r;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3297 */
  __pyx_v_r = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3298 */
  __pyx_1 = (__pyx_v_r == 64);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3299 */
    __pyx_1 = __pyx_f_7py_pari_init_stack(0); if (__pyx_1 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3299; goto __pyx_L1;}

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3300 */
    __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ellan); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3300; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3300; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3300; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3300; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_1 = __pyx_v_r;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3302 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3302; goto __pyx_L1;}
    __pyx_4 = PyInt_FromLong(__pyx_v_n); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3302; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3302; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_4);
    Py_INCREF(__pyx_k100p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k100p);
    __pyx_4 = 0;
    __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3302; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3303 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(anell(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_n))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3303; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.ellan");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k101p;

static char (__pyx_k101[]) = "in apell, p='%s' not a prime";

static PyObject *__pyx_f_7py_pari_3gen_ellap(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_ellap[] = "\n        e.ellak(p): Returns the prime-indexed coefficient a_p of the\n        L-function of the elliptic curve e, i.e. the coefficient of a\n        newform of weight 2 newform.\n\n        If p is not prime, this function will return an INCORRECT\n        answer.\n\n        The curve e must be a medium or long vector of the type given\n        by ellinit. For this function to work for every n and not just\n        those prime to the conductor, e must be a minimal Weierstrass\n        equation. If this is not the case, use the function\n        ellminimalmodel first before using ellak (or you will get\n        INCORRECT RESULTS!)\n\n        INPUT:\n            e -- a PARI elliptic curve.\n            p -- prime integer ..\n\n        EXAMPLES:\n            >>> e = pari([0, -1, 1, -10, -20]).ellinit()\n            >>> e.ellap(2)\n            -2\n            >>> e.ellap(2003)\n            4\n            >>> e.ellak(-1)\n            0\n        ";
static PyObject *__pyx_f_7py_pari_3gen_ellap(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_p = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__p;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {"p",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_p)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_p);
  ((PyObject*)__pyx_v__p) = Py_None; Py_INCREF(((PyObject*)__pyx_v__p));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3335 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3335; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3335; goto __pyx_L1;}
  Py_INCREF(__pyx_v_p);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_p);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3335; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3335; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__p));
  ((PyObject *)__pyx_v__p) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3337 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3338 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3338; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3338; goto __pyx_L1;}
    __pyx_3 = PyNumber_Remainder(__pyx_k101p, __pyx_v_p); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3338; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3338; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_2);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_3);
    __pyx_2 = 0;
    __pyx_3 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_5); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3338; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3339 */
  __pyx_3 = ((PyObject *)__pyx_f_7py_pari_new_gen(apell(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v__p->g))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3339; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.gen.ellap");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__p);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_p);
  return __pyx_r;
}

static PyObject *__pyx_k102p;

static char (__pyx_k102[]) = "error in ellbil";

static PyObject *__pyx_f_7py_pari_3gen_ellbil(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_ellbil[] = "\n        EXAMPLES:\n            >>> e = pari([0,1,1,-2,0]).ellinit()\n            >>> e.ellbil([1, 0, 1], [-1, 1, 1])\n            0.41818898449886058562988945847\n            >>> get_real_precision()\n            5\n\n        Increasing the precision does not increase the result, since quantities\n        related to the elliptic curve were computed to low precision.\n            >>> set_real_precision(10)\n            >>> e.ellbil([1, 0, 1], [-1, 1, 1])\n            0.41818898449886058562988945847\n            \n        However, if we recompute the elliptic curve after increasing the precision,\n        then the bilinear pairing will be computed to higher precision as well.\n            >>> e = pari([0,1,1,-2,0]).ellinit()\n            >>> e.ellbil([1, 0, 1], [-1, 1, 1])\n            0.41818898449886058562988945821587638237833645961491348466736402242784203834394\n            >>> set_real_precision(5)\n        ";
static PyObject *__pyx_f_7py_pari_3gen_ellbil(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_z1 = 0;
  PyObject *__pyx_v_z2 = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__z1;
  struct __pyx_obj_7py_pari_gen *__pyx_v__z2;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"z1","z2",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_z1, &__pyx_v_z2)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_z1);
  Py_INCREF(__pyx_v_z2);
  ((PyObject*)__pyx_v__z1) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z1));
  ((PyObject*)__pyx_v__z2) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z2));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3365 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3365; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3365; goto __pyx_L1;}
  Py_INCREF(__pyx_v_z1);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z1);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3365; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3365; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__z1));
  ((PyObject *)__pyx_v__z1) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3366 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3366; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3366; goto __pyx_L1;}
  Py_INCREF(__pyx_v_z2);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z2);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3366; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3366; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__z2));
  ((PyObject *)__pyx_v__z2) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3368 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3369 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3369; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3369; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3369; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k102p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k102p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3369; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3370 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(bilhell(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v__z1->g,__pyx_v__z2->g,__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3370; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellbil");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__z1);
  Py_DECREF(__pyx_v__z2);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_z1);
  Py_DECREF(__pyx_v_z2);
  return __pyx_r;
}

static PyObject *__pyx_k103p;

static char (__pyx_k103[]) = "error in ellchangecurve";

static PyObject *__pyx_f_7py_pari_3gen_ellchangecurve(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_ellchangecurve[] = "\n        EXAMPLES:\n            >>> e = pari([1,2,3,4,5]).ellinit()\n            >>> e.ellglobalred()\n            [10351, [1, -1, 0, -1], 1]\n            >>> f = e.ellchangecurve([1,-1,0,-1])\n            >>> f[:5]\n            [1, -1, 0, 4, 3]\n        ";
static PyObject *__pyx_f_7py_pari_3gen_ellchangecurve(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_ch = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__ch;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"ch",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_ch)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_ch);
  ((PyObject*)__pyx_v__ch) = Py_None; Py_INCREF(((PyObject*)__pyx_v__ch));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3383 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3383; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3383; goto __pyx_L1;}
  Py_INCREF(__pyx_v_ch);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_ch);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3383; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3383; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__ch));
  ((PyObject *)__pyx_v__ch) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3385 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3386 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3386; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3386; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3386; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k103p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k103p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3386; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3387 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(coordch(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g),__pyx_v__ch->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3387; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellchangecurve");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__ch);
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_ch);
  return __pyx_r;
}

static PyObject *__pyx_k104p;

static char (__pyx_k104[]) = "error in ellchangepoint";

static PyObject *__pyx_f_7py_pari_3gen_ellchangepoint(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_ellchangepoint[] = "\n        x.ellchangepoint(y): change data on point or vector of points x\n                             on an elliptic curve according to y=[u,r,s,t]\n\n        EXAMPLES:\n            >>> e = pari([0,1,1,-2,0]).ellinit()\n            >>> x = pari([1,0,1])\n            >>> e.ellisoncurve([1,4,4])\n            False\n            >>> e.ellisoncurve(x)\n            True\n            >>> f = e.ellchangecurve([1,2,3,-1])\n            >>> f[:5]   # show only first five entries\n            [6, -2, -1, 17, 8]\n            >>> x.ellchangepoint([1,2,3,-1])\n            [-1, 4]\n            >>> f.ellisoncurve([-1,4])\n            True\n        ";
static PyObject *__pyx_f_7py_pari_3gen_ellchangepoint(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__y;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3410 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3410; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3410; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3410; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3410; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3412 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3413 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3413; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3413; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3413; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k104p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k104p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3413; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3414 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(pointch(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),__pyx_v__y->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3414; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellchangepoint");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_n_ArithmeticError;

static PyObject *__pyx_k105p;
static PyObject *__pyx_k106p;
static PyObject *__pyx_k107p;

static char (__pyx_k105[]) = "k(=%s) must be positive";
static char (__pyx_k106[]) = "k(=%s) must be even";
static char (__pyx_k107[]) = "in elleisnum: invalid input";

static PyObject *__pyx_f_7py_pari_3gen_elleisnum(PyObject *__pyx_v_om, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_elleisnum[] = "\n        om.elleisnum(k, {flag=0}, {prec}): om=[om1,om2] being a\n            2-component vector giving a basis of a lattice L and k an\n            even positive integer, computes the numerical value of the\n            Eisenstein series of weight k. When flag is non-zero and\n            k=4 or 6, this gives g2 or g3 with the correct\n            normalization.\n\n        INPUT:\n            om -- gen, 2-component vector giving a basis of a lattice L\n            k  -- int (even positive)\n            flag -- int (default 0)\n            pref -- precision\n\n        OUTPUT:\n            gen -- numerical value of E_k\n\n        EXAMPLES:\n            >>> e = pari([0,1,1,-2,0]).ellinit()\n            >>> om = e.omega()\n            >>> om\n            [2.4902125608550550753213577919, 1.9717377015516482044224076983*I]\n            >>> om.elleisnum(2)\n            -5.2886493396542576217915346957 + 0.E-27*I\n            >>> om.elleisnum(4)\n            111.999999999999999999999999974\n            >>> om.elleisnum(100)\n            2.1531424857607763611270703364 E50\n            >>> om.elleisnum(5)\n            Traceback (most recent call last):\n            ...\n            ArithmeticError: k(=5) must be even\n            >>> om.elleisnum(0)\n            Traceback (most recent call last):\n            ...\n            ArithmeticError: k(=0) must be positive\n        ";
static PyObject *__pyx_f_7py_pari_3gen_elleisnum(PyObject *__pyx_v_om, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_k;
  int __pyx_v_flag;
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  long __pyx_5;
  static char *__pyx_argnames[] = {"k","flag",0};
  __pyx_v_flag = __pyx_k14;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l|i", __pyx_argnames, &__pyx_v_k, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_om);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3454 */
  __pyx_1 = (__pyx_v_k <= 0);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3455 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_ArithmeticError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3455; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_k); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3455; goto __pyx_L1;}
    __pyx_4 = PyNumber_Remainder(__pyx_k105p, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3455; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __Pyx_Raise(__pyx_2, __pyx_4, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3455; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3456 */
  __pyx_5 = (__pyx_v_k % 2);
  if (__pyx_5) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3457 */
    __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_ArithmeticError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3457; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_k); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3457; goto __pyx_L1;}
    __pyx_4 = PyNumber_Remainder(__pyx_k106p, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3457; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __Pyx_Raise(__pyx_3, __pyx_4, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3457; goto __pyx_L1;}
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3459 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3460 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3460; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3460; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3460; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k107p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k107p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3460; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L4;
  }
  __pyx_L4:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3461 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(elleisnum(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_om)->g),__pyx_v_k,__pyx_v_flag,__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3461; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.elleisnum");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_om);
  return __pyx_r;
}

static PyObject *__pyx_k108p;

static char (__pyx_k108[]) = "error in elleta";

static PyObject *__pyx_f_7py_pari_3gen_elleta(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_elleta(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3465 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3466 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3466; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3466; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3466; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k108p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k108p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3466; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3467 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(elleta(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3467; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.elleta");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k109p;

static char (__pyx_k109[]) = "error in ellglobalred";

static PyObject *__pyx_f_7py_pari_3gen_ellglobalred(PyObject *__pyx_v_e1, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellglobalred(PyObject *__pyx_v_e1, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_e1);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3471 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3472 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3472; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3472; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3472; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k109p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k109p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3472; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3473 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(globalreduction(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e1)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3473; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.ellglobalred");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e1);
  return __pyx_r;
}

static PyObject *__pyx_k110p;

static char (__pyx_k110[]) = "error in ellheight";

static PyObject *__pyx_f_7py_pari_3gen_ellheight(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellheight(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_a = 0;
  PyObject *__pyx_v_flag = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__a;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  long __pyx_5;
  static char *__pyx_argnames[] = {"a","flag",0};
  __pyx_v_flag = __pyx_k15;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|O", __pyx_argnames, &__pyx_v_a, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_a);
  Py_INCREF(__pyx_v_flag);
  ((PyObject*)__pyx_v__a) = Py_None; Py_INCREF(((PyObject*)__pyx_v__a));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3477 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3477; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3477; goto __pyx_L1;}
  Py_INCREF(__pyx_v_a);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_a);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3477; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3477; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__a));
  ((PyObject *)__pyx_v__a) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3479 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3480 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3480; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3480; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3480; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k110p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k110p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3480; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3481 */
  __pyx_5 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3481; goto __pyx_L1;}
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(ellheight0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g),__pyx_v__a->g,__pyx_5,__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3481; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellheight");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__a);
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_a);
  Py_DECREF(__pyx_v_flag);
  return __pyx_r;
}

static PyObject *__pyx_k111p;

static char (__pyx_k111[]) = "error in ellheightmatrix";

static PyObject *__pyx_f_7py_pari_3gen_ellheightmatrix(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_ellheightmatrix[] = "\n        ellheightmatrix(e,x)\n\n        Returns the height matrix for vector of points x on elliptic curve e using\n        theta functions.\n        ";
static PyObject *__pyx_f_7py_pari_3gen_ellheightmatrix(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_x = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__x;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"x",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_x)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_x);
  ((PyObject*)__pyx_v__x) = Py_None; Py_INCREF(((PyObject*)__pyx_v__x));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3491 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3491; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3491; goto __pyx_L1;}
  Py_INCREF(__pyx_v_x);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_x);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3491; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3491; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__x));
  ((PyObject *)__pyx_v__x) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3493 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3494 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3494; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3494; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3494; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k111p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k111p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3494; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3495 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(mathell(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g),__pyx_v__x->g,__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3495; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellheightmatrix");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__x);
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_n_ValueError;

static PyObject *__pyx_k112p;
static PyObject *__pyx_k113p;

static char (__pyx_k112[]) = "in ellinit: invalid input '%s' (flag=%s) to the elliptic curve creation function";
static char (__pyx_k113[]) = "flag must be 0 or 1";

static PyObject *__pyx_f_7py_pari_3gen_ellinit(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_ellinit[] = "\n        ellinit(x,{flag=0}): x being the vector [a1,a2,a3,a4,a6], gives\n        the vector: [a1,a2,a3,a4,a6,\n                    b2,b4,b6,b8,\n                    c4,c6,\n                    delta,j,\n                    [e1,e2,e3],\n                    w1,w2,eta1,eta2,area].\n        If the curve is defined over a p-adic field, the last six components\n        are replaced by root,u^2,u,q,w,0. If optional flag is 1, omit them\n        altogether.\n        ";
static PyObject *__pyx_f_7py_pari_3gen_ellinit(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_flag;
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {"flag",0};
  __pyx_v_flag = __pyx_k16;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|i", __pyx_argnames, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3511 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3512 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3512; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3512; goto __pyx_L1;}
    __pyx_4 = PyInt_FromLong(__pyx_v_flag); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3512; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3512; goto __pyx_L1;}
    Py_INCREF(__pyx_v_self);
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_v_self);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
    __pyx_4 = 0;
    __pyx_4 = PyNumber_Remainder(__pyx_k112p, __pyx_5); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3512; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3512; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
    __pyx_3 = 0;
    __pyx_4 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3512; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3513 */
  __pyx_1 = (__pyx_v_flag < 0);
  if (!__pyx_1) {
    __pyx_1 = (__pyx_v_flag >= 1);
  }
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3514 */
    __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_ValueError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3514; goto __pyx_L1;}
    __Pyx_Raise(__pyx_4, __pyx_k113p, 0);
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3514; goto __pyx_L1;}
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3515 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(ellinit0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_flag,__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3515; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.gen.ellinit");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k114p;

static char (__pyx_k114[]) = "in elleisoncurve: invalid input e=%s, x=%s";

static PyObject *__pyx_f_7py_pari_3gen_ellisoncurve(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellisoncurve(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_x = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__x;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {"x",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_x)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_x);
  ((PyObject*)__pyx_v__x) = Py_None; Py_INCREF(((PyObject*)__pyx_v__x));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3519 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3519; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3519; goto __pyx_L1;}
  Py_INCREF(__pyx_v_x);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_x);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3519; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3519; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__x));
  ((PyObject *)__pyx_v__x) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3522 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3523 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3523; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3523; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3523; goto __pyx_L1;}
    Py_INCREF(__pyx_v_e);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_e);
    Py_INCREF(__pyx_v_x);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_v_x);
    __pyx_5 = PyNumber_Remainder(__pyx_k114p, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3523; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3523; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_5);
    __pyx_2 = 0;
    __pyx_5 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3523; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3525 */
  __pyx_5 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3525; goto __pyx_L1;}
  __pyx_1 = PyInt_FromLong((oncurve(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_v__x->g) == 1)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3525; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3525; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_1);
  __pyx_1 = 0;
  __pyx_2 = PyObject_CallObject(__pyx_5, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3525; goto __pyx_L1;}
  Py_DECREF(__pyx_5); __pyx_5 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.gen.ellisoncurve");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__x);
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_k115p;

static char (__pyx_k115[]) = "in ellj: invalid input '%s', argument must be element of the upper half plane";

static PyObject *__pyx_f_7py_pari_3gen_ellj(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellj(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_e);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3529 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3530 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3530; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3530; goto __pyx_L1;}
    __pyx_4 = PyNumber_Remainder(__pyx_k115p, __pyx_v_e); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3530; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3530; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
    __pyx_3 = 0;
    __pyx_4 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3530; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3531 */
  __pyx_4 = ((PyObject *)__pyx_f_7py_pari_new_gen(jell(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g),__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3531; goto __pyx_L1;}
  __pyx_r = __pyx_4;
  __pyx_4 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.gen.ellj");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  return __pyx_r;
}

static PyObject *__pyx_k116p;

static char (__pyx_k116[]) = "in ellj: invalid input '%s', argument must be element of the upper half plane";

static PyObject *__pyx_f_7py_pari_3gen_elllocalred(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_elllocalred(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_p = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__p;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {"p",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_p)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_p);
  ((PyObject*)__pyx_v__p) = Py_None; Py_INCREF(((PyObject*)__pyx_v__p));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3535 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3535; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3535; goto __pyx_L1;}
  Py_INCREF(__pyx_v_p);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_p);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3535; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3535; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__p));
  ((PyObject *)__pyx_v__p) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3537 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3538 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3538; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3538; goto __pyx_L1;}
    __pyx_3 = PyNumber_Remainder(__pyx_k116p, __pyx_v_e); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3538; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3538; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_2);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_3);
    __pyx_2 = 0;
    __pyx_3 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_5); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3538; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3539 */
  __pyx_3 = ((PyObject *)__pyx_f_7py_pari_new_gen(localreduction(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g),__pyx_v__p->g))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3539; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.gen.elllocalred");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__p);
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_p);
  return __pyx_r;
}

static PyObject *__pyx_n_int;
static PyObject *__pyx_n_float;

static PyObject *__pyx_k117p;
static PyObject *__pyx_k118p;

static char (__pyx_k117[]) = "prec must be >= 3.";
static char (__pyx_k118[]) = "in elllseries: Error evaluating L(E,%s)";

static PyObject *__pyx_f_7py_pari_3gen_elllseries(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_elllseries(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_s = 0;
  PyObject *__pyx_v_A = 0;
  long __pyx_v_prec;
  struct __pyx_obj_7py_pari_gen *__pyx_v__s;
  struct __pyx_obj_7py_pari_gen *__pyx_v__A;
  PyObject *__pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {"s","A","prec",0};
  __pyx_v_A = __pyx_k17;
  __pyx_v_prec = __pyx_k18;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|Ol", __pyx_argnames, &__pyx_v_s, &__pyx_v_A, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_s);
  Py_INCREF(__pyx_v_A);
  ((PyObject*)__pyx_v__s) = Py_None; Py_INCREF(((PyObject*)__pyx_v__s));
  ((PyObject*)__pyx_v__A) = Py_None; Py_INCREF(((PyObject*)__pyx_v__A));
  __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3543 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3543; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3543; goto __pyx_L1;}
  Py_INCREF(__pyx_v_s);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_s);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3543; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3543; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__s));
  ((PyObject *)__pyx_v__s) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3544 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3544; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3544; goto __pyx_L1;}
  Py_INCREF(__pyx_v_A);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_A);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3544; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3544; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__A));
  ((PyObject *)__pyx_v__A) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3545 */
  __pyx_4 = (__pyx_v_prec <= 2);
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3546 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_RuntimeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3546; goto __pyx_L1;}
    __Pyx_Raise(__pyx_1, __pyx_k117p, 0);
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3546; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3550 */
  if (PyObject_Cmp(__pyx_v_s, ((PyObject *)__pyx_v_7py_pari_ZERO), &__pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3550; goto __pyx_L1;}
  __pyx_4 = __pyx_4 <= 0;
  if (__pyx_4) {
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_int); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3550; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3550; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_s);
    __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3550; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_float); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3550; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3550; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_s);
    __pyx_5 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3550; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (PyObject_Cmp(__pyx_1, __pyx_5, &__pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3550; goto __pyx_L1;}
    __pyx_4 = __pyx_4 == 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
  }
  if (__pyx_4) {
    Py_INCREF(((PyObject *)__pyx_v_7py_pari_ZERO));
    __pyx_r = ((PyObject *)__pyx_v_7py_pari_ZERO);
    goto __pyx_L0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3552 */
  __pyx_2 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3552; goto __pyx_L1;}
  Py_DECREF(__pyx_v_n);
  __pyx_v_n = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3553 */
  __pyx_4 = PyObject_IsTrue(__pyx_v_n); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3553; goto __pyx_L1;}
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3557 */
    __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3557; goto __pyx_L1;}
    __pyx_1 = PyNumber_Remainder(__pyx_k118p, __pyx_v_s); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3557; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3557; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_v_n);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_1);
    __pyx_1 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_3, __pyx_5); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3557; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L4;
  }
  __pyx_L4:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3559 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(lseriesell(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g),__pyx_v__s->g,__pyx_v__A->g,__pyx_v_prec))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3559; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.gen.elllseries");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__s);
  Py_DECREF(__pyx_v__A);
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_s);
  Py_DECREF(__pyx_v_A);
  return __pyx_r;
}

static PyObject *__pyx_k119p;

static char (__pyx_k119[]) = "error in ellminimalmodel";

static PyObject *__pyx_f_7py_pari_3gen_ellminimalmodel(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_ellminimalmodel[] = "\n        \n        ellminimalmodel(e): return the standard minimal integral model\n        of the rational elliptic curve e and the corresponding change\n        of variables.\n        INPUT:\n            e -- gen (that defines an elliptic curve)\n        OUTPUT:\n            gen -- minimal model\n            gen -- change of coordinates\n        EXAMPLES:\n            >>> e = pari([1,2,3,4,5]).ellinit()\n            >>> F, ch = e.ellminimalmodel()\n            >>> F[:5]\n            [1, -1, 0, 4, 3]\n            >>> ch\n            [1, -1, 0, -1]\n            >>> e.ellchangecurve(ch)[:5]\n            [1, -1, 0, 4, 3]\n        ";
static PyObject *__pyx_f_7py_pari_3gen_ellminimalmodel(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  GEN __pyx_v_x;
  GEN __pyx_v_y;
  struct __pyx_obj_7py_pari_gen *__pyx_v_model;
  struct __pyx_obj_7py_pari_gen *__pyx_v_change;
  pari_sp __pyx_v_t;
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_e);
  ((PyObject*)__pyx_v_model) = Py_None; Py_INCREF(((PyObject*)__pyx_v_model));
  ((PyObject*)__pyx_v_change) = Py_None; Py_INCREF(((PyObject*)__pyx_v_change));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3586 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3587 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3587; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3587; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3587; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k119p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k119p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3587; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3588 */
  __pyx_v_x = ellminimalmodel(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g),(&__pyx_v_y));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3589 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen_noclear(__pyx_v_x)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3589; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_model));
  ((PyObject *)__pyx_v_model) = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3590 */
  __pyx_4 = ((PyObject *)__pyx_f_7py_pari_new_gen(__pyx_v_y)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3590; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_change));
  ((PyObject *)__pyx_v_change) = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3591 */
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3591; goto __pyx_L1;}
  Py_INCREF(((PyObject *)__pyx_v_model));
  PyTuple_SET_ITEM(__pyx_3, 0, ((PyObject *)__pyx_v_model));
  Py_INCREF(((PyObject *)__pyx_v_change));
  PyTuple_SET_ITEM(__pyx_3, 1, ((PyObject *)__pyx_v_change));
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.ellminimalmodel");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_model);
  Py_DECREF(__pyx_v_change);
  Py_DECREF(__pyx_v_e);
  return __pyx_r;
}

static PyObject *__pyx_k120p;

static char (__pyx_k120[]) = "error in ellorder";

static PyObject *__pyx_f_7py_pari_3gen_ellorder(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellorder(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_x = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__x;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"x",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_x)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_x);
  ((PyObject*)__pyx_v__x) = Py_None; Py_INCREF(((PyObject*)__pyx_v__x));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3595 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3595; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3595; goto __pyx_L1;}
  Py_INCREF(__pyx_v_x);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_x);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3595; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3595; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__x));
  ((PyObject *)__pyx_v__x) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3597 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3598 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3598; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3598; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3598; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k120p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k120p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3598; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3599 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(orderell(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g),__pyx_v__x->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3599; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellorder");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__x);
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_k121p;

static char (__pyx_k121[]) = "error in ellordinate";

static PyObject *__pyx_f_7py_pari_3gen_ellordinate(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellordinate(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_x = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__x;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"x",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_x)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_x);
  ((PyObject*)__pyx_v__x) = Py_None; Py_INCREF(((PyObject*)__pyx_v__x));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3603 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3603; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3603; goto __pyx_L1;}
  Py_INCREF(__pyx_v_x);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_x);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3603; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3603; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__x));
  ((PyObject *)__pyx_v__x) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3605 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3606 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3606; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3606; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3606; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k121p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k121p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3606; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3607 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(ordell(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g),__pyx_v__x->g,__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3607; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellordinate");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__x);
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_k122p;

static char (__pyx_k122[]) = "error in ellpointtoz";

static PyObject *__pyx_f_7py_pari_3gen_ellpointtoz(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellpointtoz(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_z = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__x;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"z",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_z)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_z);
  ((PyObject*)__pyx_v__x) = Py_None; Py_INCREF(((PyObject*)__pyx_v__x));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3611 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3611; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3611; goto __pyx_L1;}
  Py_INCREF(__pyx_v_z);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3611; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3611; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__x));
  ((PyObject *)__pyx_v__x) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3613 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3614 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3614; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3614; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3614; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k122p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k122p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3614; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3615 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(zell(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g),__pyx_v__x->g,__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3615; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellpointtoz");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__x);
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_z);
  return __pyx_r;
}

static PyObject *__pyx_k123p;

static char (__pyx_k123[]) = "in ellpow";

static PyObject *__pyx_f_7py_pari_3gen_ellpow(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellpow(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_z = 0;
  PyObject *__pyx_v_n = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__z;
  struct __pyx_obj_7py_pari_gen *__pyx_v__n;
  int __pyx_v_r;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"z","n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_z, &__pyx_v_n)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_z);
  Py_INCREF(__pyx_v_n);
  ((PyObject*)__pyx_v__z) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z));
  ((PyObject*)__pyx_v__n) = Py_None; Py_INCREF(((PyObject*)__pyx_v__n));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3619 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3619; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3619; goto __pyx_L1;}
  Py_INCREF(__pyx_v_z);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3619; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3619; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__z));
  ((PyObject *)__pyx_v__z) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3619 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3619; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3619; goto __pyx_L1;}
  Py_INCREF(__pyx_v_n);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_n);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3619; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3619; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__n));
  ((PyObject *)__pyx_v__n) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3621 */
  __pyx_v_r = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3622 */
  __pyx_4 = __pyx_v_r;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3622; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_r); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3622; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3622; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k123p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k123p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3622; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3623 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(powell(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g),__pyx_v__z->g,__pyx_v__n->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3623; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellpow");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__z);
  Py_DECREF(__pyx_v__n);
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_z);
  Py_DECREF(__pyx_v_n);
  return __pyx_r;
}

static PyObject *__pyx_k124p;

static char (__pyx_k124[]) = "in ellrootno";

static PyObject *__pyx_f_7py_pari_3gen_ellrootno(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellrootno(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_p = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__p;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"p",0};
  __pyx_v_p = __pyx_k19;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_p)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_p);
  ((PyObject*)__pyx_v__p) = Py_None; Py_INCREF(((PyObject*)__pyx_v__p));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3627 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3627; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3627; goto __pyx_L1;}
  Py_INCREF(__pyx_v_p);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_p);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3627; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3627; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__p));
  ((PyObject *)__pyx_v__p) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3629 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3630 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3630; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3630; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3630; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k124p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k124p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3630; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3631 */
  __pyx_1 = PyInt_FromLong(ellrootno(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g),__pyx_v__p->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3631; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellrootno");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__p);
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_p);
  return __pyx_r;
}

static PyObject *__pyx_k125p;

static char (__pyx_k125[]) = "in ellsigma";

static PyObject *__pyx_f_7py_pari_3gen_ellsigma(PyObject *__pyx_v_om, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellsigma(PyObject *__pyx_v_om, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_z = 0;
  PyObject *__pyx_v_flag = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__x;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  long __pyx_5;
  static char *__pyx_argnames[] = {"z","flag",0};
  __pyx_v_flag = __pyx_k20;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|O", __pyx_argnames, &__pyx_v_z, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_om);
  Py_INCREF(__pyx_v_z);
  Py_INCREF(__pyx_v_flag);
  ((PyObject*)__pyx_v__x) = Py_None; Py_INCREF(((PyObject*)__pyx_v__x));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3635 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3635; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3635; goto __pyx_L1;}
  Py_INCREF(__pyx_v_z);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3635; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3635; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__x));
  ((PyObject *)__pyx_v__x) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3637 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3638 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3638; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3638; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3638; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k125p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k125p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3638; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3639 */
  __pyx_5 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3639; goto __pyx_L1;}
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(ellsigma(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_om)->g),__pyx_v__x->g,__pyx_5,__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3639; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellsigma");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__x);
  Py_DECREF(__pyx_v_om);
  Py_DECREF(__pyx_v_z);
  Py_DECREF(__pyx_v_flag);
  return __pyx_r;
}

static PyObject *__pyx_k126p;

static char (__pyx_k126[]) = "in ellsub";

static PyObject *__pyx_f_7py_pari_3gen_ellsub(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellsub(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_z1 = 0;
  PyObject *__pyx_v_z2 = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__z1;
  struct __pyx_obj_7py_pari_gen *__pyx_v__z2;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"z1","z2",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_z1, &__pyx_v_z2)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_z1);
  Py_INCREF(__pyx_v_z2);
  ((PyObject*)__pyx_v__z1) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z1));
  ((PyObject*)__pyx_v__z2) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z2));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3643 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3643; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3643; goto __pyx_L1;}
  Py_INCREF(__pyx_v_z1);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z1);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3643; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3643; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__z1));
  ((PyObject *)__pyx_v__z1) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3643 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3643; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3643; goto __pyx_L1;}
  Py_INCREF(__pyx_v_z2);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z2);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3643; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3643; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__z2));
  ((PyObject *)__pyx_v__z2) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3645 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3646 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3646; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3646; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3646; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k126p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k126p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3646; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3647 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(subell(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g),__pyx_v__z1->g,__pyx_v__z2->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3647; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellsub");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__z1);
  Py_DECREF(__pyx_v__z2);
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_z1);
  Py_DECREF(__pyx_v_z2);
  return __pyx_r;
}

static PyObject *__pyx_k127p;

static char (__pyx_k127[]) = "in elltaniyama";

static PyObject *__pyx_f_7py_pari_3gen_elltaniyama(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_elltaniyama(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_e);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3651 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3652 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3652; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3652; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3652; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k127p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k127p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3652; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3653 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(taniyama(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3653; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.elltaniyama");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  return __pyx_r;
}

static PyObject *__pyx_k128p;

static char (__pyx_k128[]) = "in elltors";

static PyObject *__pyx_f_7py_pari_3gen_elltors(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_elltors(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_flag = 0;
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  long __pyx_5;
  static char *__pyx_argnames[] = {"flag",0};
  __pyx_v_flag = __pyx_k21;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_flag);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3657 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3658 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3658; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3658; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3658; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k128p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k128p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3658; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3659 */
  __pyx_5 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3659; goto __pyx_L1;}
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(elltors0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g),__pyx_5))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3659; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.elltors");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_flag);
  return __pyx_r;
}

static PyObject *__pyx_n_prec;

static PyObject *__pyx_k129p;

static char (__pyx_k129[]) = "in ellwp";

static PyObject *__pyx_f_7py_pari_3gen_ellwp(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellwp(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_z = 0;
  long __pyx_v_flag;
  struct __pyx_obj_7py_pari_gen *__pyx_v__z;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  long __pyx_5;
  static char *__pyx_argnames[] = {"z","flag",0};
  __pyx_v_flag = __pyx_k22;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|l", __pyx_argnames, &__pyx_v_z, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_z);
  ((PyObject*)__pyx_v__z) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3663 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3663; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3663; goto __pyx_L1;}
  Py_INCREF(__pyx_v_z);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3663; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3663; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__z));
  ((PyObject *)__pyx_v__z) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3665 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3666 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3666; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3666; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3666; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k129p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k129p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3666; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3667 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_prec); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3667; goto __pyx_L1;}
  __pyx_5 = PyInt_AsLong(__pyx_1); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3667; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_3 = ((PyObject *)__pyx_f_7py_pari_new_gen(ellwp0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g),__pyx_v__z->g,__pyx_v_flag,__pyx_5,__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3667; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellwp");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__z);
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_z);
  return __pyx_r;
}

static PyObject *__pyx_k130p;

static char (__pyx_k130[]) = "in ellzeta";

static PyObject *__pyx_f_7py_pari_3gen_ellzeta(PyObject *__pyx_v_om, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellzeta(PyObject *__pyx_v_om, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_z = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__z;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"z",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_z)) return 0;
  Py_INCREF(__pyx_v_om);
  Py_INCREF(__pyx_v_z);
  ((PyObject*)__pyx_v__z) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3671 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3671; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3671; goto __pyx_L1;}
  Py_INCREF(__pyx_v_z);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3671; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3671; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__z));
  ((PyObject *)__pyx_v__z) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3673 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3674 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3674; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3674; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3674; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k130p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k130p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3674; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3675 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(ellzeta(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_om)->g),__pyx_v__z->g,__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3675; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellzeta");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__z);
  Py_DECREF(__pyx_v_om);
  Py_DECREF(__pyx_v_z);
  return __pyx_r;
}

static PyObject *__pyx_k131p;

static char (__pyx_k131[]) = "in ellztopoint";

static PyObject *__pyx_f_7py_pari_3gen_ellztopoint(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellztopoint(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_z = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__z;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"z",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_z)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_z);
  ((PyObject*)__pyx_v__z) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z));
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_z), __pyx_ptype_7py_pari_gen, 1, "z")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3677; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3679 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3679; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3679; goto __pyx_L1;}
  Py_INCREF(((PyObject *)__pyx_v_z));
  PyTuple_SET_ITEM(__pyx_2, 0, ((PyObject *)__pyx_v_z));
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3679; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3679; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__z));
  ((PyObject *)__pyx_v__z) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3681 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3682 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3682; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3682; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3682; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k131p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k131p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3682; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3683 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(pointell(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g),__pyx_v__z->g,__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3683; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellztopoint");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__z);
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_z);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_omega(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_omega[] = "\n        e.omega(): return basis for the period lattice of the elliptic curve e.\n        \n        EXAMPLES:\n            >>> e = pari([0, -1, 1, -10, -20]).ellinit()\n            >>> e.omega()\n            [1.2692093042795534216887946168, 0.63460465213977671084439730838 + 1.4588166169384952293308896128*I]\n        ";
static PyObject *__pyx_f_7py_pari_3gen_omega(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_e);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3694 */
  __pyx_1 = PySequence_GetSlice(__pyx_v_e, 14, 16); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3694; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.omega");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_disc(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_disc[] = "\n        e.disc(): return the discriminant of the elliptic curve e.\n        \n        EXAMPLES:\n            >>> e = pari([0, -1, 1, -10, -20]).ellinit()\n            >>> e.disc()\n            -161051\n            >>> _.factor()\n            [-1, 1; 11, 5]\n        ";
static PyObject *__pyx_f_7py_pari_3gen_disc(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_e);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3707 */
  __pyx_1 = PyInt_FromLong(11); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3707; goto __pyx_L1;}
  __pyx_2 = PyObject_GetItem(__pyx_v_e, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3707; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("py_pari.gen.disc");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_j(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_j[] = "\n        e.disc(): return the discriminant of the elliptic curve e.\n        \n        EXAMPLES:\n            >>> e = pari([0, -1, 1, -10, -20]).ellinit()\n            >>> e.disc()\n            -161051\n            >>> _.factor()\n            [-1, 1; 11, 5]\n        ";
static PyObject *__pyx_f_7py_pari_3gen_j(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_e);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3720 */
  __pyx_1 = PyInt_FromLong(12); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3720; goto __pyx_L1;}
  __pyx_2 = PyObject_GetItem(__pyx_v_e, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3720; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("py_pari.gen.j");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  return __pyx_r;
}

static PyObject *__pyx_k132p;

static char (__pyx_k132[]) = "error in bnfunit";

static PyObject *__pyx_f_7py_pari_3gen_bnfunit(PyObject *__pyx_v_k, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_bnfunit(PyObject *__pyx_v_k, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_k);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3727 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3728 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3729 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3729; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3729; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3729; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k132p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k132p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3729; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3730 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(buchfu(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_k)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3730; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.bnfunit");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_k);
  return __pyx_r;
}

static PyObject *__pyx_k133p;

static char (__pyx_k133[]) = "error in nfinit";

static PyObject *__pyx_f_7py_pari_3gen_bnfinit(PyObject *__pyx_v_f, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_bnfinit(PyObject *__pyx_v_f, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_flag;
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"flag",0};
  __pyx_v_flag = __pyx_k23;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|l", __pyx_argnames, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_f);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3734 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3735 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3736 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3736; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3736; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3736; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k133p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k133p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3736; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3738 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(bnfinit0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_f)->g),__pyx_v_flag,((GEN )0),__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3738; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.bnfinit");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_f);
  return __pyx_r;
}

static PyObject *__pyx_k134p;

static char (__pyx_k134[]) = "error in idealfactor";

static PyObject *__pyx_f_7py_pari_3gen_idealfactor(PyObject *__pyx_v_nf, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_idealfactor(PyObject *__pyx_v_nf, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_x = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__x;
  PyObject *__pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"x",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_x)) return 0;
  Py_INCREF(__pyx_v_nf);
  Py_INCREF(__pyx_v_x);
  ((PyObject*)__pyx_v__x) = Py_None; Py_INCREF(((PyObject*)__pyx_v__x));
  __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3742 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3742; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3742; goto __pyx_L1;}
  Py_INCREF(__pyx_v_x);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_x);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3742; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3742; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__x));
  ((PyObject *)__pyx_v__x) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3743 */
  __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3743; goto __pyx_L1;}
  Py_DECREF(__pyx_v_n);
  __pyx_v_n = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3744 */
  __pyx_4 = PyObject_IsTrue(__pyx_v_n); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3744; goto __pyx_L1;}
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3745 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3745; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3745; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    Py_INCREF(__pyx_k134p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k134p);
    __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3745; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3746 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(idealfactor(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_nf)->g),__pyx_v__x->g))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3746; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.idealfactor");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__x);
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_nf);
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_k135p;

static char (__pyx_k135[]) = "error in nfbasis";

static PyObject *__pyx_f_7py_pari_3gen_nfbasis(PyObject *__pyx_v_f, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_nfbasis(PyObject *__pyx_v_f, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_flag;
  PyObject *__pyx_v_p = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__p;
  GEN __pyx_v_g;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"flag","p",0};
  __pyx_v_flag = __pyx_k24;
  __pyx_v_p = __pyx_k25;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|lO", __pyx_argnames, &__pyx_v_flag, &__pyx_v_p)) return 0;
  Py_INCREF(__pyx_v_f);
  Py_INCREF(__pyx_v_p);
  ((PyObject*)__pyx_v__p) = Py_None; Py_INCREF(((PyObject*)__pyx_v__p));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3751 */
  __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3751; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_v_p, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3751; goto __pyx_L1;}
  __pyx_2 = __pyx_2 != 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3752 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3752; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3752; goto __pyx_L1;}
    Py_INCREF(__pyx_v_p);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_p);
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3752; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (!__Pyx_TypeTest(__pyx_4, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3752; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__p));
    ((PyObject *)__pyx_v__p) = __pyx_4;
    __pyx_4 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3753 */
    __pyx_v_g = __pyx_v__p->g;
    goto __pyx_L2;
  }
  /*else*/ {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3755 */
    __pyx_v_g = ((GEN )0);
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3758 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3759 */
  __pyx_2 = __pyx_v_n;
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3760 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3760; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3760; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3760; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k135p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k135p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3760; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3762 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(nfbasis0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_f)->g),__pyx_v_flag,__pyx_v_g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3762; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.nfbasis");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__p);
  Py_DECREF(__pyx_v_f);
  Py_DECREF(__pyx_v_p);
  return __pyx_r;
}

static PyObject *__pyx_k136p;

static char (__pyx_k136[]) = "error in nfinit";

static PyObject *__pyx_f_7py_pari_3gen_nfinit(PyObject *__pyx_v_f, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_nfinit(PyObject *__pyx_v_f, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_flag;
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"flag",0};
  __pyx_v_flag = __pyx_k26;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|l", __pyx_argnames, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_f);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3766 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3767 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3768 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3768; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3768; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3768; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k136p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k136p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3768; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3769 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(nfinit0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_f)->g),__pyx_v_flag,__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3769; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.nfinit");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_f);
  return __pyx_r;
}

static PyObject *__pyx_k137p;

static char (__pyx_k137[]) = "error in nfbasis";

static PyObject *__pyx_f_7py_pari_3gen_polcompositum(PyObject *__pyx_v_pol1, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_polcompositum(PyObject *__pyx_v_pol1, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_pol2 = 0;
  long __pyx_v_flag;
  struct __pyx_obj_7py_pari_gen *__pyx_v__pol2;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"pol2","flag",0};
  __pyx_v_flag = __pyx_k27;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|l", __pyx_argnames, &__pyx_v_pol2, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_pol1);
  Py_INCREF(__pyx_v_pol2);
  ((PyObject*)__pyx_v__pol2) = Py_None; Py_INCREF(((PyObject*)__pyx_v__pol2));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3773 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3773; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3773; goto __pyx_L1;}
  Py_INCREF(__pyx_v_pol2);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_pol2);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3773; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3773; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__pol2));
  ((PyObject *)__pyx_v__pol2) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3776 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3777 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3778 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3778; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3778; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3778; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k137p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k137p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3778; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3779 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(polcompositum0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_pol1)->g),__pyx_v__pol2->g,__pyx_v_flag))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3779; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.polcompositum");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__pol2);
  Py_DECREF(__pyx_v_pol1);
  Py_DECREF(__pyx_v_pol2);
  return __pyx_r;
}

static PyObject *__pyx_k138p;

static char (__pyx_k138[]) = "error in poldisc";

static PyObject *__pyx_f_7py_pari_3gen_poldisc(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_poldisc(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_var = 0;
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"var",0};
  __pyx_v_var = __pyx_k28;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_var)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_var);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3787 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3788 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3789 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3789; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3789; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3789; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k138p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k138p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3789; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3790 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(poldisc0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),__pyx_f_7py_pari_get_var(__pyx_v_var)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3790; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.poldisc");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_var);
  return __pyx_r;
}

static PyObject *__pyx_k139p;

static char (__pyx_k139[]) = "error in polresultant";

static PyObject *__pyx_f_7py_pari_3gen_polresultant(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_polresultant(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  PyObject *__pyx_v_var = 0;
  PyObject *__pyx_v_flag = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__y;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  long __pyx_5;
  static char *__pyx_argnames[] = {"y","var","flag",0};
  __pyx_v_var = __pyx_k29;
  __pyx_v_flag = __pyx_k30;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|OO", __pyx_argnames, &__pyx_v_y, &__pyx_v_var, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  Py_INCREF(__pyx_v_var);
  Py_INCREF(__pyx_v_flag);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3794 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3794; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3794; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3794; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3794; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3796 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3797 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3798 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3798; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3798; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3798; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k139p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k139p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3798; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3800 */
  __pyx_5 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3800; goto __pyx_L1;}
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(polresultant0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),__pyx_v__y->g,__pyx_f_7py_pari_get_var(__pyx_v_var),__pyx_5))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3800; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.polresultant");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  Py_DECREF(__pyx_v_var);
  Py_DECREF(__pyx_v_flag);
  return __pyx_r;
}

static PyObject *__pyx_k140p;

static char (__pyx_k140[]) = "error in nfbasis";

static PyObject *__pyx_f_7py_pari_3gen_polroots(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_polroots[] = "\n        polroots(x,{flag=0}): complex roots of the polynomial x. flag\n        is optional, and can be 0: default, uses Schonhage\'s method modified\n        by Gourdon, or 1: uses a modified Newton method.\n        ";
static PyObject *__pyx_f_7py_pari_3gen_polroots(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_flag = 0;
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  long __pyx_5;
  static char *__pyx_argnames[] = {"flag",0};
  __pyx_v_flag = __pyx_k31;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_flag);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3809 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3810 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3811 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3811; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3811; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3811; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k140p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k140p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3811; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3813 */
  __pyx_5 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3813; goto __pyx_L1;}
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(roots0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g),__pyx_5,__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3813; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.polroots");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_flag);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_factor(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_factor[] = "\n        factor(x,{lim}): factorization of x. lim is optional and can\n        be set whenever x is of (possibly recursive) rational\n        type. If lim is set return partial factorization, using\n        primes up to lim (up to primelimit if lim=0)\n        ";
static PyObject *__pyx_f_7py_pari_3gen_factor(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_limit = 0;
  PyObject *__pyx_r;
  long __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"limit",0};
  __pyx_v_limit = __pyx_k32;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_limit)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_limit);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3838 */
  __pyx_1 = PyInt_AsLong(__pyx_v_limit); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3838; goto __pyx_L1;}
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(factor0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_1))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3838; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("py_pari.gen.factor");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_limit);
  return __pyx_r;
}

static PyObject *__pyx_n_abs;

static PyObject *__pyx_f_7py_pari_3gen___abs__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___abs__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3847 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_abs); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3847; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3847; goto __pyx_L1;}
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3847; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.__abs__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k141p;

static char (__pyx_k141[]) = "error in abs";

static PyObject *__pyx_f_7py_pari_3gen_abs(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_abs(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_err;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3851 */
  __pyx_v_err = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3852 */
  __pyx_1 = __pyx_v_err;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3852; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3852; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3852; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k141p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k141p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3852; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3853 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(gabs(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3853; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.abs");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k142p;

static char (__pyx_k142[]) = "error in mattranspose";

static PyObject *__pyx_f_7py_pari_3gen_mattranspose(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_mattranspose[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_mattranspose(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3859 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3860 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3860; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3860; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3860; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k142p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k142p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3860; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3861 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(gtrans(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3861; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.mattranspose");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k143p;

static char (__pyx_k143[]) = "error in matker";

static PyObject *__pyx_f_7py_pari_3gen_matker(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_matker[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_matker(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_flag;
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"flag",0};
  __pyx_v_flag = __pyx_k33;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|l", __pyx_argnames, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3867 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3868 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3868; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3868; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3868; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k143p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k143p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3868; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3869 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(matker0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_flag))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3869; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.matker");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k144p;

static char (__pyx_k144[]) = "error in matkerint";

static PyObject *__pyx_f_7py_pari_3gen_matkerint(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_matkerint[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_matkerint(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_flag;
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"flag",0};
  __pyx_v_flag = __pyx_k34;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|l", __pyx_argnames, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3875 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3876 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3876; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3876; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3876; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k144p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k144p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3876; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3877 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(matkerint0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_flag))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3877; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.matkerint");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k145p;

static char (__pyx_k145[]) = "error in trace";

static PyObject *__pyx_f_7py_pari_3gen_trace(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_trace(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3881 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3882 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3882; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3882; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3882; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k145p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k145p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3882; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3883 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(gtrace(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3883; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.trace");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k146p;

static char (__pyx_k146[]) = "error in norm";

static PyObject *__pyx_f_7py_pari_3gen_norm(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_norm(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3887 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3888 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3888; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3888; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3888; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k146p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k146p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3888; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3889 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(gnorm(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3889; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.norm");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k147p;

static char (__pyx_k147[]) = "error in charpoly";

static PyObject *__pyx_f_7py_pari_3gen_charpoly(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_charpoly[] = "\n        charpoly(A,{v=x},{flag=0}): det(v*Id-A) = characteristic polynomial of the\n        matrix A using the comatrix. flag is optional and may be set to 1 (use\n        Lagrange interpolation) or 2 (use Hessenberg form), 0 being the default.\n        ";
static PyObject *__pyx_f_7py_pari_3gen_charpoly(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_var = 0;
  PyObject *__pyx_v_flag = 0;
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  long __pyx_5;
  static char *__pyx_argnames[] = {"var","flag",0};
  __pyx_v_var = __pyx_k35;
  __pyx_v_flag = __pyx_k36;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|OO", __pyx_argnames, &__pyx_v_var, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_var);
  Py_INCREF(__pyx_v_flag);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3898 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3899 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3899; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3899; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3899; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k147p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k147p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3899; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3900 */
  __pyx_5 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3900; goto __pyx_L1;}
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(charpoly0(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_f_7py_pari_get_var(__pyx_v_var),__pyx_5))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3900; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.charpoly");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_var);
  Py_DECREF(__pyx_v_flag);
  return __pyx_r;
}

static PyObject *__pyx_k148p;

static char (__pyx_k148[]) = "error in nextprime";

static PyObject *__pyx_f_7py_pari_3gen_nextprime(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_nextprime[] = "\n        nextprime(x): smallest pseudoprime >= x\n        ";
static PyObject *__pyx_f_7py_pari_3gen_nextprime(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3908 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3909 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3909; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3909; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3909; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k148p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k148p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3909; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3910 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(gnextprime(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3910; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.nextprime");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k149p;

static char (__pyx_k149[]) = "error in subst";

static PyObject *__pyx_f_7py_pari_3gen_subst(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_subst[] = "\n        EXAMPLES:\n           >>> x = pari(\"x\"); y = pari(\"y\")\n           >>> f = x**3 + 17*x + 3\n           >>> f.subst(x, y)\n           y^3 + 17*y + 3\n           >>> f.subst(x, \"z\")\n           z^3 + 17*z + 3\n           >>> f.subst(x, \"z\")**2\n           z^6 + 34*z^4 + 6*z^3 + 289*z^2 + 102*z + 9\n           >>> f.subst(x, \"x+1\")\n           x^3 + 3*x^2 + 20*x + 21\n           >>> f.subst(x, \"xyz\")\n           xyz^3 + 17*xyz + 3\n           >>> f.subst(x, \"xyz\")**2\n           xyz^6 + 34*xyz^4 + 6*xyz^3 + 289*xyz^2 + 102*xyz + 9\n        ";
static PyObject *__pyx_f_7py_pari_3gen_subst(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_var = 0;
  PyObject *__pyx_v_y = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__y;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"var","y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_var, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_var);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3931 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3931; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3931; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3931; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3931; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3933 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3934 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3934; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3934; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3934; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k149p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k149p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3934; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3935 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gsubst(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_f_7py_pari_get_var(__pyx_v_var),__pyx_v__y->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3935; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.subst");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_var);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_k150p;

static char (__pyx_k150[]) = "error in __call__";

static PyObject *__pyx_f_7py_pari_3gen___call__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___call__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__y;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3940 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3940; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3940; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3940; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3940; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3942 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3943 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3943; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3943; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3943; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k150p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k150p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3943; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3944 */
  __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3944; goto __pyx_L1;}
  __pyx_3 = ((PyObject *)__pyx_f_7py_pari_new_gen(gsubst(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_f_7py_pari_get_var(__pyx_1),__pyx_v__y->g))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3944; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.__call__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_k151p;

static char (__pyx_k151[]) = "error in imag";

static PyObject *__pyx_f_7py_pari_3gen_kronecker(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_kronecker(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v__y;
  int __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3948 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3948; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3948; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3948; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3948; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3951 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3952 */
  __pyx_4 = __pyx_v_n;
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3953 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3953; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3953; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3953; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k151p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k151p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3953; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3955 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gkronecker(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v__y->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3955; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.kronecker");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_k152p;

static char (__pyx_k152[]) = "error in imag";

static PyObject *__pyx_f_7py_pari_3gen_exp(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_exp(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3959 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3960 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3961 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3961; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3961; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3961; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k152p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k152p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3961; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3962 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(gexp(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3962; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.exp");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k153p;

static char (__pyx_k153[]) = "error in imag";

static PyObject *__pyx_f_7py_pari_3gen_log(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_log(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3966 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3967 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3968 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3968; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3968; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3968; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k153p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k153p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3968; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3969 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(glog(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_7py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3969; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.log");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_type(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_type(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3973 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3973; goto __pyx_L1;}
  __pyx_2 = PyString_FromString(type_name(typ(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3973; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3973; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
  __pyx_2 = 0;
  __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3973; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.type");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_save_avma(void) {
  PyObject *__pyx_r;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3984 */
  __pyx_v_7py_pari_stack_avma = avma;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("py_pari.save_avma");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static char (__pyx_k154[]) = "\n    Create a new gen, but don\'t free any memory on the stack.\n    ";

static struct __pyx_obj_7py_pari_gen *__pyx_f_7py_pari_new_gen_noclear(GEN __pyx_v_x) {
  struct __pyx_obj_7py_pari_gen *__pyx_r;
  PyObject *__pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3987 */
  __pyx_k154;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3992 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari__new_gen(__pyx_v_x,top)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3992; goto __pyx_L1;}
  __pyx_r = (struct __pyx_obj_7py_pari_gen *)__pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  (PyObject *)__pyx_r = Py_None; Py_INCREF((PyObject *)__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.new_gen_noclear");
  __pyx_r = 0;
  __pyx_L0:;
  return ((struct __pyx_obj_7py_pari_gen *)__pyx_r) ;
}

static char (__pyx_k155[]) = "\n    Create a new gen, then free the *entire* stack.\n    ";

static struct __pyx_obj_7py_pari_gen *__pyx_f_7py_pari_new_gen(GEN __pyx_v_x) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_g;
  struct __pyx_obj_7py_pari_gen *__pyx_r;
  PyObject *__pyx_1 = 0;
  ((PyObject*)__pyx_v_g) = Py_None; Py_INCREF(((PyObject*)__pyx_v_g));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4006 */
  __pyx_k155;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4011 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari__new_gen(__pyx_v_x,top)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4011; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_g));
  ((PyObject *)__pyx_v_g) = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4012 */
  avma = top;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4013 */
  Py_INCREF(((PyObject *)__pyx_v_g));
  __pyx_r = (struct __pyx_obj_7py_pari_gen *)((PyObject *)__pyx_v_g);
  goto __pyx_L0;

  (PyObject *)__pyx_r = Py_None; Py_INCREF((PyObject *)__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.new_gen");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_g);
  return ((struct __pyx_obj_7py_pari_gen *)__pyx_r) ;
}

static struct __pyx_obj_7py_pari_gen *__pyx_f_7py_pari___xxx_new_gen(GEN __pyx_v_x,pari_sp __pyx_v_start) {
  size_t __pyx_v_s;
  pari_sp __pyx_v_tmp_bot;
  pari_sp __pyx_v_tmp_top;
  pari_sp __pyx_v_tmp_avma;
  GEN __pyx_v_h;
  struct __pyx_obj_7py_pari_gen *__pyx_v_p;
  struct __pyx_obj_7py_pari_gen *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  ((PyObject*)__pyx_v_p) = Py_None; Py_INCREF(((PyObject*)__pyx_v_p));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4023 */
  __pyx_1 = (((pari_sp )__pyx_v_x) < bot);
  if (!__pyx_1) {
    __pyx_1 = (((pari_sp )__pyx_v_x) > top);
  }
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4024 */
    __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4024; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(((PyObject*)__pyx_ptype_7py_pari_gen), __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4024; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4024; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_p));
    ((PyObject *)__pyx_v_p) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4025 */
    __pyx_2 = ((struct __pyx_vtabstruct_7py_pari_gen *)__pyx_v_p->__pyx_vtab)->init(__pyx_v_p,__pyx_v_x,0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4025; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4026 */
    Py_INCREF(((PyObject *)__pyx_v_p));
    __pyx_r = (struct __pyx_obj_7py_pari_gen *)((PyObject *)__pyx_v_p);
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4028 */
  __pyx_v_tmp_top = top;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4029 */
  __pyx_v_tmp_bot = bot;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4030 */
  __pyx_v_tmp_avma = avma;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4031 */
  __pyx_v_s = ((size_t )(__pyx_v_start - avma));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4033 */
  bot = ((pari_sp )PyMem_Malloc(__pyx_v_s));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4034 */
  top = (bot + __pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4035 */
  avma = top;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4036 */
  __pyx_v_h = forcecopy(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4037 */
  __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4037; goto __pyx_L1;}
  __pyx_2 = PyObject_CallObject(((PyObject*)__pyx_ptype_7py_pari_gen), __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4037; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (!__Pyx_TypeTest(__pyx_2, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4037; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_p));
  ((PyObject *)__pyx_v_p) = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4037 */
  __pyx_3 = ((struct __pyx_vtabstruct_7py_pari_gen *)__pyx_v_p->__pyx_vtab)->init(__pyx_v_p,__pyx_v_h,bot); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4037; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4040 */
  top = __pyx_v_tmp_top;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4041 */
  bot = __pyx_v_tmp_bot;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4042 */
  avma = __pyx_v_tmp_avma;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4043 */
  Py_INCREF(((PyObject *)__pyx_v_p));
  __pyx_r = (struct __pyx_obj_7py_pari_gen *)((PyObject *)__pyx_v_p);
  goto __pyx_L0;

  (PyObject *)__pyx_r = Py_None; Py_INCREF((PyObject *)__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.__xxx_new_gen");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_p);
  return ((struct __pyx_obj_7py_pari_gen *)__pyx_r) ;
}

static struct __pyx_obj_7py_pari_gen *__pyx_f_7py_pari__new_gen(GEN __pyx_v_x,pari_sp __pyx_v_start) {
  size_t __pyx_v_s;
  pari_sp __pyx_v_tmp_bot;
  pari_sp __pyx_v_tmp_top;
  pari_sp __pyx_v_tmp_avma;
  GEN __pyx_v_h;
  struct __pyx_obj_7py_pari_gen *__pyx_v_p;
  struct __pyx_obj_7py_pari_gen *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  ((PyObject*)__pyx_v_p) = Py_None; Py_INCREF(((PyObject*)__pyx_v_p));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4053 */
  __pyx_1 = (((pari_sp )__pyx_v_x) < bot);
  if (!__pyx_1) {
    __pyx_1 = (((pari_sp )__pyx_v_x) > top);
  }
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4054 */
    __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4054; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(((PyObject*)__pyx_ptype_7py_pari_gen), __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4054; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4054; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_p));
    ((PyObject *)__pyx_v_p) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4055 */
    __pyx_2 = ((struct __pyx_vtabstruct_7py_pari_gen *)__pyx_v_p->__pyx_vtab)->init(__pyx_v_p,__pyx_v_x,0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4055; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4056 */
    Py_INCREF(((PyObject *)__pyx_v_p));
    __pyx_r = (struct __pyx_obj_7py_pari_gen *)((PyObject *)__pyx_v_p);
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4058 */
  __pyx_v_tmp_top = top;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4059 */
  __pyx_v_tmp_bot = bot;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4060 */
  __pyx_v_tmp_avma = avma;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4061 */
  __pyx_v_h = forcecopy(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4062 */
  __pyx_v_s = ((size_t )(__pyx_v_tmp_avma - avma));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4064 */
  bot = ((pari_sp )PyMem_Malloc(__pyx_v_s));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4065 */
  top = (bot + __pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4066 */
  avma = top;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4067 */
  __pyx_v_h = forcecopy(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4068 */
  __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4068; goto __pyx_L1;}
  __pyx_2 = PyObject_CallObject(((PyObject*)__pyx_ptype_7py_pari_gen), __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4068; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (!__Pyx_TypeTest(__pyx_2, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4068; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_p));
  ((PyObject *)__pyx_v_p) = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4068 */
  __pyx_3 = ((struct __pyx_vtabstruct_7py_pari_gen *)__pyx_v_p->__pyx_vtab)->init(__pyx_v_p,__pyx_v_h,bot); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4068; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4071 */
  top = __pyx_v_tmp_top;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4072 */
  bot = __pyx_v_tmp_bot;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4073 */
  avma = __pyx_v_tmp_avma;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4074 */
  Py_INCREF(((PyObject *)__pyx_v_p));
  __pyx_r = (struct __pyx_obj_7py_pari_gen *)((PyObject *)__pyx_v_p);
  goto __pyx_L0;

  (PyObject *)__pyx_r = Py_None; Py_INCREF((PyObject *)__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari._new_gen");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_p);
  return ((struct __pyx_obj_7py_pari_gen *)__pyx_r) ;
}

static struct __pyx_obj_7py_pari_gen *__pyx_f_7py_pari_new_ref(GEN __pyx_v_x,struct __pyx_obj_7py_pari_gen *__pyx_v_g) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_p;
  struct __pyx_obj_7py_pari_gen *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  Py_INCREF(__pyx_v_g);
  ((PyObject*)__pyx_v_p) = Py_None; Py_INCREF(((PyObject*)__pyx_v_p));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4078 */
  __pyx_1 = PyTuple_New(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4078; goto __pyx_L1;}
  __pyx_2 = PyObject_CallObject(((PyObject*)__pyx_ptype_7py_pari_gen), __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4078; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (!__Pyx_TypeTest(__pyx_2, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4078; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_p));
  ((PyObject *)__pyx_v_p) = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4078 */
  __pyx_1 = ((struct __pyx_vtabstruct_7py_pari_gen *)__pyx_v_p->__pyx_vtab)->init(__pyx_v_p,__pyx_v_x,0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4078; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4079 */
  __pyx_2 = PyInt_FromLong((-1)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4079; goto __pyx_L1;}
  if (PyObject_SetItem(__pyx_v_p->refers_to, __pyx_2, ((PyObject *)__pyx_v_g)) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4079; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4081 */
  Py_INCREF(((PyObject *)__pyx_v_p));
  __pyx_r = (struct __pyx_obj_7py_pari_gen *)((PyObject *)__pyx_v_p);
  goto __pyx_L0;

  (PyObject *)__pyx_r = Py_None; Py_INCREF((PyObject *)__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("py_pari.new_ref");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_p);
  Py_DECREF(__pyx_v_g);
  return ((struct __pyx_obj_7py_pari_gen *)__pyx_r) ;
}

static PyObject *__pyx_n_list;
static PyObject *__pyx_n_xrange;
static PyObject *__pyx_n_len;
static PyObject *__pyx_n_enumerate;
static PyObject *__pyx_n_AttributeError;
static PyObject *__pyx_n_True;
static PyObject *__pyx_n_False;

static PyObject *__pyx_f_7py_pari_pari(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_pari[] = "\n    Create the PARI object got by evaluating s using PARI.\n    ";
static PyObject *__pyx_f_7py_pari_pari(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_s = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v_p;
  GEN __pyx_v_g;
  pari_sp __pyx_v_prev_avma;
  PyObject *__pyx_v_v;
  PyObject *__pyx_v_i;
  PyObject *__pyx_v_x;
  PyObject *__pyx_v_t;
  PyObject *__pyx_v_again;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  PyObject *__pyx_5 = 0;
  PyObject *__pyx_6 = 0;
  char (*__pyx_7);
  GEN __pyx_8;
  static char *__pyx_argnames[] = {"s",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_s)) return 0;
  Py_INCREF(__pyx_v_s);
  ((PyObject*)__pyx_v_p) = Py_None; Py_INCREF(((PyObject*)__pyx_v_p));
  __pyx_v_v = Py_None; Py_INCREF(__pyx_v_v);
  __pyx_v_i = Py_None; Py_INCREF(__pyx_v_i);
  __pyx_v_x = Py_None; Py_INCREF(__pyx_v_x);
  __pyx_v_t = Py_None; Py_INCREF(__pyx_v_t);
  __pyx_v_again = Py_None; Py_INCREF(__pyx_v_again);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4092 */
  __pyx_v_prev_avma = avma;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4094 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4094; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4094; goto __pyx_L1;}
  Py_INCREF(__pyx_v_s);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_s);
  Py_INCREF(((PyObject*)__pyx_ptype_7py_pari_gen));
  PyTuple_SET_ITEM(__pyx_2, 1, ((PyObject*)__pyx_ptype_7py_pari_gen));
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4094; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_4 = PyObject_IsTrue(__pyx_3); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4094; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4095 */
    Py_INCREF(__pyx_v_s);
    __pyx_r = __pyx_v_s;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4096; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_list); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4096; goto __pyx_L1;}
  __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_xrange); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4096; goto __pyx_L1;}
  __pyx_5 = __Pyx_GetName(__pyx_b, __pyx_n_tuple); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4096; goto __pyx_L1;}
  __pyx_6 = PyTuple_New(3); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4096; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_6, 0, __pyx_2);
  PyTuple_SET_ITEM(__pyx_6, 1, __pyx_3);
  PyTuple_SET_ITEM(__pyx_6, 2, __pyx_5);
  __pyx_2 = 0;
  __pyx_3 = 0;
  __pyx_5 = 0;
  __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4096; goto __pyx_L1;}
  Py_INCREF(__pyx_v_s);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_s);
  PyTuple_SET_ITEM(__pyx_2, 1, __pyx_6);
  __pyx_6 = 0;
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4096; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_4 = PyObject_IsTrue(__pyx_3); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4096; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4097 */
    __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n_vector); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4097; goto __pyx_L1;}
    __pyx_6 = __Pyx_GetName(__pyx_b, __pyx_n_len); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4097; goto __pyx_L1;}
    __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4097; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_1, 0, __pyx_v_s);
    __pyx_2 = PyObject_CallObject(__pyx_6, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4097; goto __pyx_L1;}
    Py_DECREF(__pyx_6); __pyx_6 = 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4097; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    __pyx_2 = 0;
    __pyx_6 = PyObject_CallObject(__pyx_5, __pyx_3); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4097; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_v_v);
    __pyx_v_v = __pyx_6;
    __pyx_6 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4098 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_enumerate); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4098; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4098; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_s);
    __pyx_5 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4098; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_3 = PyObject_GetIter(__pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4098; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    for (;;) {
      __pyx_L3:;
      __pyx_6 = PyIter_Next(__pyx_3);
      if (!__pyx_6) {
        if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4098; goto __pyx_L1;}
        break;
      }
      __pyx_1 = __Pyx_UnpackItem(__pyx_6, 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4098; goto __pyx_L1;}
      Py_DECREF(__pyx_v_i);
      __pyx_v_i = __pyx_1;
      __pyx_1 = 0;
      __pyx_2 = __Pyx_UnpackItem(__pyx_6, 1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4098; goto __pyx_L1;}
      Py_DECREF(__pyx_v_x);
      __pyx_v_x = __pyx_2;
      __pyx_2 = 0;
      if (__Pyx_EndUnpack(__pyx_6, 2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4098; goto __pyx_L1;}
      Py_DECREF(__pyx_6); __pyx_6 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4099 */
      __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4099; goto __pyx_L1;}
      __pyx_6 = PyTuple_New(1); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4099; goto __pyx_L1;}
      Py_INCREF(__pyx_v_x);
      PyTuple_SET_ITEM(__pyx_6, 0, __pyx_v_x);
      __pyx_1 = PyObject_CallObject(__pyx_5, __pyx_6); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4099; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_6); __pyx_6 = 0;
      if (PyObject_SetItem(__pyx_v_v, __pyx_v_i, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4099; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
    }
    __pyx_L4:;
    Py_DECREF(__pyx_3); __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4100 */
    Py_INCREF(__pyx_v_v);
    __pyx_r = __pyx_v_v;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4101; goto __pyx_L1;}
  __pyx_5 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4101; goto __pyx_L1;}
  __pyx_6 = PyTuple_New(2); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4101; goto __pyx_L1;}
  Py_INCREF(__pyx_v_s);
  PyTuple_SET_ITEM(__pyx_6, 0, __pyx_v_s);
  PyTuple_SET_ITEM(__pyx_6, 1, __pyx_5);
  __pyx_5 = 0;
  __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_6); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4101; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_6); __pyx_6 = 0;
  __pyx_4 = PyObject_IsTrue(__pyx_1); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4101; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4102 */
    __pyx_4 = PyObject_IsTrue(__pyx_v_s); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4102; goto __pyx_L1;}
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4103 */
      Py_INCREF(((PyObject *)__pyx_v_7py_pari_ONE));
      __pyx_r = ((PyObject *)__pyx_v_7py_pari_ONE);
      goto __pyx_L0;
      goto __pyx_L5;
    }
    __pyx_L5:;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4104 */
    Py_INCREF(((PyObject *)__pyx_v_7py_pari_ZERO));
    __pyx_r = ((PyObject *)__pyx_v_7py_pari_ZERO);
    goto __pyx_L0;
    goto __pyx_L2;
  }
  /*else*/ {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4106 */
    /*try:*/ {

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4107 */
      __pyx_3 = PyObject_GetAttr(__pyx_v_s, __pyx_n_pari); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4107; goto __pyx_L6;}
      __pyx_5 = PyTuple_New(0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4107; goto __pyx_L6;}
      __pyx_2 = PyObject_CallObject(__pyx_3, __pyx_5); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4107; goto __pyx_L6;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      __pyx_r = __pyx_2;
      __pyx_2 = 0;
      goto __pyx_L0;
    }
    goto __pyx_L7;
    __pyx_L6:;
    Py_XDECREF(__pyx_6); __pyx_6 = 0;
    Py_XDECREF(__pyx_1); __pyx_1 = 0;
    Py_XDECREF(__pyx_3); __pyx_3 = 0;
    Py_XDECREF(__pyx_5); __pyx_5 = 0;
    Py_XDECREF(__pyx_2); __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4108 */
    __pyx_6 = __Pyx_GetName(__pyx_b, __pyx_n_AttributeError); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4108; goto __pyx_L1;}
    __pyx_4 = PyErr_ExceptionMatches(__pyx_6);
    Py_DECREF(__pyx_6); __pyx_6 = 0;
    if (__pyx_4) {
      __Pyx_AddTraceback("py_pari.pari");
      __pyx_1 = __Pyx_GetExcValue(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4108; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4109 */
      goto __pyx_L7;
    }
    goto __pyx_L1;
    __pyx_L7:;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4111 */
  __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4111; goto __pyx_L1;}
  __pyx_5 = PyTuple_New(1); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4111; goto __pyx_L1;}
  Py_INCREF(__pyx_v_s);
  PyTuple_SET_ITEM(__pyx_5, 0, __pyx_v_s);
  __pyx_2 = PyObject_CallObject(__pyx_3, __pyx_5); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4111; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_5); __pyx_5 = 0;
  Py_DECREF(__pyx_v_t);
  __pyx_v_t = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4112 */
  __pyx_6 = __Pyx_GetName(__pyx_b, __pyx_n_True); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4112; goto __pyx_L1;}
  Py_DECREF(__pyx_v_again);
  __pyx_v_again = __pyx_6;
  __pyx_6 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4113 */
  while (1) {
    __pyx_L8:;
    __pyx_4 = PyObject_IsTrue(__pyx_v_again); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4113; goto __pyx_L1;}
    if (!__pyx_4) break;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4114 */
    /*try:*/ {

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4115 */
      __pyx_7 = PyString_AsString(__pyx_v_t); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4115; goto __pyx_L10;}
      __pyx_8 = __pyx_f_7py_pari_str_to_GEN(__pyx_7); if (__pyx_8 == 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4115; goto __pyx_L10;}
      __pyx_v_g = __pyx_8;

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4116 */
      __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_False); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4116; goto __pyx_L10;}
      Py_DECREF(__pyx_v_again);
      __pyx_v_again = __pyx_1;
      __pyx_1 = 0;
    }
    goto __pyx_L11;
    __pyx_L10:;
    Py_XDECREF(__pyx_3); __pyx_3 = 0;
    Py_XDECREF(__pyx_5); __pyx_5 = 0;
    Py_XDECREF(__pyx_2); __pyx_2 = 0;
    Py_XDECREF(__pyx_6); __pyx_6 = 0;
    Py_XDECREF(__pyx_1); __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4117 */
    __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_MemoryError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4117; goto __pyx_L1;}
    __pyx_4 = PyErr_ExceptionMatches(__pyx_3);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (__pyx_4) {
      __Pyx_AddTraceback("py_pari.pari");
      __pyx_5 = __Pyx_GetExcValue(); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4117; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4118 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_True); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4118; goto __pyx_L1;}
      Py_DECREF(__pyx_v_again);
      __pyx_v_again = __pyx_2;
      __pyx_2 = 0;
      goto __pyx_L11;
    }
    goto __pyx_L1;
    __pyx_L11:;
  }
  __pyx_L9:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4121 */
  __pyx_6 = ((PyObject *)__pyx_f_7py_pari_new_gen(__pyx_v_g)); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4121; goto __pyx_L1;}
  __pyx_r = __pyx_6;
  __pyx_6 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_5);
  Py_XDECREF(__pyx_6);
  __Pyx_AddTraceback("py_pari.pari");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_p);
  Py_DECREF(__pyx_v_v);
  Py_DECREF(__pyx_v_i);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_t);
  Py_DECREF(__pyx_v_again);
  Py_DECREF(__pyx_v_s);
  return __pyx_r;
}

static char (__pyx_k156[]) = "\n    Converts a Python string into a PARI variable reference number.\n    Or if v = -1, returns -1.\n    ";

static int __pyx_f_7py_pari_get_var(PyObject *__pyx_v_v) {
  PyObject *__pyx_v_s;
  int __pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  char (*__pyx_5);
  Py_INCREF(__pyx_v_v);
  __pyx_v_s = Py_None; Py_INCREF(__pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4125 */
  __pyx_k156;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4129 */
  __pyx_1 = PyInt_FromLong((-1)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4129; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_v_v, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4129; goto __pyx_L1;}
  __pyx_2 = __pyx_2 != 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4130 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4130; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4130; goto __pyx_L1;}
    Py_INCREF(__pyx_v_v);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_v);
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4130; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_v_s);
    __pyx_v_s = __pyx_4;
    __pyx_4 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4131 */
    __pyx_5 = PyString_AsString(__pyx_v_s); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4131; goto __pyx_L1;}
    __pyx_r = fetch_user_var(__pyx_5);
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4132 */
  __pyx_r = (-1);
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_WriteUnraisable("py_pari.get_var");
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  Py_DECREF(__pyx_v_v);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_stack_ptr(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_stack_ptr(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4135 */
  __pyx_1 = PyLong_FromUnsignedLong(avma); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4135; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.stack_ptr");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_stack_top(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_stack_top(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4138 */
  __pyx_1 = PyLong_FromUnsignedLong(top); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4138; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.stack_top");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_stack_bottom(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_stack_bottom(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4141 */
  __pyx_1 = PyLong_FromUnsignedLong(bot); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4141; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.stack_bottom");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_stack_size(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_stack_size[] = "\n    Stack size, in bytes\n    ";
static PyObject *__pyx_f_7py_pari_stack_size(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4148 */
  __pyx_1 = PyLong_FromUnsignedLong((top - bot)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4148; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.stack_size");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_stack_usage(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_stack_usage[] = "\n    How much memory in megabytes is currently being used on the PARI stack.\n    ";
static PyObject *__pyx_f_7py_pari_stack_usage(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4155 */
  __pyx_1 = PyLong_FromUnsignedLong((top - avma)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4155; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.stack_usage");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_stack_available(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_stack_available[] = "\n    How much memory in bytes is currently available on the PARI stack.\n    ";
static PyObject *__pyx_f_7py_pari_stack_available(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4162 */
  __pyx_1 = PyLong_FromUnsignedLong((avma - bot)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4162; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.stack_available");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_k157p;

static char (__pyx_k157[]) = "\n";

static PyObject *__pyx_f_7py_pari_execute(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_execute(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_s = 0;
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  char (*__pyx_5);
  static char *__pyx_argnames[] = {"s",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_s)) return 0;
  Py_INCREF(__pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4171 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4172 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4173 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4173; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4173; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4173; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_v_s);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4173; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4174 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_execute); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4174; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4174; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_s);
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4174; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4177 */
  __pyx_2 = PyNumber_Add(__pyx_v_s, __pyx_k157p); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4177; goto __pyx_L1;}
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4178 */
  __pyx_5 = PyString_AsString(__pyx_v_s); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4178; goto __pyx_L1;}
  flisseq(__pyx_5);

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.execute");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  return __pyx_r;
}

static PyObject *__pyx_k158p;

static char (__pyx_k158[]) = "\n";

static PyObject *__pyx_f_7py_pari_eval(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_eval(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_s = 0;
  int __pyx_v_n;
  GEN __pyx_v_x;
  char (*__pyx_v_c);
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  char (*__pyx_5);
  static char *__pyx_argnames[] = {"s",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_s)) return 0;
  Py_INCREF(__pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4182 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4183 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4184 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4184; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4184; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4184; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_v_s);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4184; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4185 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_eval); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4185; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4185; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_s);
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4185; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4191 */
  __pyx_2 = PyNumber_Add(__pyx_v_s, __pyx_k158p); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4191; goto __pyx_L1;}
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4192 */
  __pyx_5 = PyString_AsString(__pyx_v_s); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4192; goto __pyx_L1;}
  __pyx_v_x = flisseq(__pyx_5);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4194 */
  __pyx_v_c = GENtostr(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4196 */
  cgiv(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4198 */
  __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4198; goto __pyx_L1;}
  __pyx_3 = PyString_FromString(__pyx_v_c); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4198; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4198; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_3);
  __pyx_3 = 0;
  __pyx_3 = PyObject_CallObject(__pyx_4, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4198; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4200 */
  free(__pyx_v_c);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4201 */
  Py_INCREF(__pyx_v_s);
  __pyx_r = __pyx_v_s;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.eval");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  return __pyx_r;
}

static PyObject *__pyx_n_sys;
static PyObject *__pyx_n_InputError;
static PyObject *__pyx_n_OverflowError;

static PyObject *__pyx_k160p;
static PyObject *__pyx_k161p;
static PyObject *__pyx_k162p;
static PyObject *__pyx_k163p;
static PyObject *__pyx_k164p;

static char (__pyx_k160[]) = "PARI ran out of memory, so we automatically increase the memory available to PARI.";
static char (__pyx_k161[]) = "Doubling number of precomputed primes.";
static char (__pyx_k162[]) = "Bad arguments to an elliptic curve function: %s";
static char (__pyx_k163[]) = "Object too big to fit in a codeword: %s";
static char (__pyx_k164[]) = "PARI error %s: %s";

static PyObject *__pyx_f_7py_pari__error(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari__error(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_n = 0;
  PyObject *__pyx_v_s = 0;
  PyObject *__pyx_v_sys;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"n","s",0};
  __pyx_v_s = __pyx_k38;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|O", __pyx_argnames, &__pyx_v_n, &__pyx_v_s)) return 0;
  Py_INCREF(__pyx_v_n);
  Py_INCREF(__pyx_v_s);
  __pyx_v_sys = Py_None; Py_INCREF(__pyx_v_sys);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4204 */
  __pyx_1 = __Pyx_Import(__pyx_n_sys, 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4204; goto __pyx_L1;}
  Py_DECREF(__pyx_v_sys);
  __pyx_v_sys = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4206 */
  __pyx_1 = PyInt_FromLong(64); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4206; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_v_n, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4206; goto __pyx_L1;}
  __pyx_2 = __pyx_2 == 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4207 */
    if (__Pyx_PrintItem(__pyx_k160p) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4207; goto __pyx_L1;}
    if (__Pyx_PrintNewline() < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4207; goto __pyx_L1;}

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4208 */
    __pyx_2 = __pyx_f_7py_pari_init_stack(0); if (__pyx_2 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4208; goto __pyx_L1;}

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4209 */
    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4210 */
  __pyx_1 = PyInt_FromLong(83); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4210; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_v_n, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4210; goto __pyx_L1;}
  __pyx_2 = __pyx_2 == 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4212 */
    if (__Pyx_PrintItem(__pyx_k161p) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4212; goto __pyx_L1;}
    if (__Pyx_PrintNewline() < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4212; goto __pyx_L1;}

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4213 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_init_primes); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4213; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong((2 * __pyx_v_7py_pari_num_primes)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4213; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4213; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4213; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4214 */
    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4215 */
  __pyx_1 = PyInt_FromLong(97); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4215; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_v_n, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4215; goto __pyx_L1;}
  __pyx_2 = __pyx_2 == 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4216 */
    __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_InputError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4216; goto __pyx_L1;}
    __pyx_3 = PyNumber_Remainder(__pyx_k162p, __pyx_v_s); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4216; goto __pyx_L1;}
    __Pyx_Raise(__pyx_4, __pyx_3, 0);
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4216; goto __pyx_L1;}
    goto __pyx_L4;
  }
  __pyx_L4:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4217 */
  __pyx_1 = PyInt_FromLong(65); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4217; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_v_n, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4217; goto __pyx_L1;}
  __pyx_2 = __pyx_2 == 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4218 */
    __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_OverflowError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4218; goto __pyx_L1;}
    __pyx_3 = PyNumber_Remainder(__pyx_k163p, __pyx_v_s); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4218; goto __pyx_L1;}
    __Pyx_Raise(__pyx_4, __pyx_3, 0);
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4218; goto __pyx_L1;}
    goto __pyx_L5;
  }
  __pyx_L5:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4219 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_RuntimeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4219; goto __pyx_L1;}
  __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4219; goto __pyx_L1;}
  Py_INCREF(__pyx_v_n);
  PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_n);
  Py_INCREF(__pyx_v_s);
  PyTuple_SET_ITEM(__pyx_4, 1, __pyx_v_s);
  __pyx_3 = PyNumber_Remainder(__pyx_k164p, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4219; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  __Pyx_Raise(__pyx_1, __pyx_3, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4219; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari._error");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_sys);
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_s);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_min(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_min(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_x = 0;
  PyObject *__pyx_v_y = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  static char *__pyx_argnames[] = {"x","y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_x, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4224 */
  if (PyObject_Cmp(__pyx_v_x, __pyx_v_y, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4224; goto __pyx_L1;}
  __pyx_1 = __pyx_1 <= 0;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4225 */
    Py_INCREF(__pyx_v_x);
    __pyx_r = __pyx_v_x;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4226 */
  Py_INCREF(__pyx_v_y);
  __pyx_r = __pyx_v_y;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("py_pari.min");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_max(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_max(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_x = 0;
  PyObject *__pyx_v_y = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  static char *__pyx_argnames[] = {"x","y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_x, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4229 */
  if (PyObject_Cmp(__pyx_v_x, __pyx_v_y, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4229; goto __pyx_L1;}
  __pyx_1 = __pyx_1 >= 0;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4230 */
    Py_INCREF(__pyx_v_x);
    __pyx_r = __pyx_v_x;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4231 */
  Py_INCREF(__pyx_v_y);
  __pyx_r = __pyx_v_y;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("py_pari.max");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}


static PyObject *__pyx_f_7py_pari_prime_list(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_prime_list[] = "\n    prime_list(n): returns list of the first n primes\n\n    INPUT:\n        n -- C long\n    OUTPUT:\n        gen -- PARI list of first n primes\n    EXAMPLES:\n        >>> prime_list(0)\n        []\n        >>> prime_list(-1)\n        []\n        >>> prime_list(3)\n        [2, 3, 5]\n        >>> prime_list(10)\n        [2, 3, 5, 7, 11, 13, 17, 19, 23, 29]\n        >>> prime_list(20)\n        [2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71]\n        >>> len(prime_list(1000))\n        1000\n    ";
static PyObject *__pyx_f_7py_pari_prime_list(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  int __pyx_v_e;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4257 */
  __pyx_v_e = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4258 */
  __pyx_1 = __pyx_v_e;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4258; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_e); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4258; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4258; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_n_prime_list);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_n_prime_list);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4258; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4259 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(primes(__pyx_v_n))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4259; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.prime_list");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_k166p;

static char (__pyx_k166[]) = "nth prime meaningless for negative n (=%s)";

static PyObject *__pyx_f_7py_pari_nth_prime(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_nth_prime[] = "\n    nth_prime(n): returns the n-th prime, where n is a C-int\n    ";
static PyObject *__pyx_f_7py_pari_nth_prime(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  GEN __pyx_v_g;
  PyObject *__pyx_v_z;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  PyObject *__pyx_6 = 0;
  static char *__pyx_argnames[] = {"n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;
  __pyx_v_z = Py_None; Py_INCREF(__pyx_v_z);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4267 */
  __pyx_1 = (__pyx_v_n <= 0);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4268 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_ArithmeticError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4268; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4268; goto __pyx_L1;}
    __pyx_4 = PyNumber_Remainder(__pyx_k166p, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4268; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __Pyx_Raise(__pyx_2, __pyx_4, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4268; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4270 */
  __pyx_3 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4270; goto __pyx_L1;}
  Py_DECREF(__pyx_v_z);
  __pyx_v_z = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4271 */
  __pyx_1 = PyObject_IsTrue(__pyx_v_z); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4271; goto __pyx_L1;}
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4272 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_init_primes); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4272; goto __pyx_L1;}
    __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n_max); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4272; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong((2 * __pyx_v_7py_pari_num_primes)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4272; goto __pyx_L1;}
    __pyx_5 = PyInt_FromLong((20 * __pyx_v_n)); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4272; goto __pyx_L1;}
    __pyx_6 = PyTuple_New(2); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4272; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_6, 0, __pyx_3);
    PyTuple_SET_ITEM(__pyx_6, 1, __pyx_5);
    __pyx_3 = 0;
    __pyx_5 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_4, __pyx_6); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4272; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_6); __pyx_6 = 0;
    __pyx_5 = PyTuple_New(1); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4272; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
    __pyx_3 = 0;
    __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_5); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4272; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4273 */
    __pyx_6 = __Pyx_GetName(__pyx_m, __pyx_n_nth_prime); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4273; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4273; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4273; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_3);
    __pyx_3 = 0;
    __pyx_5 = PyObject_CallObject(__pyx_6, __pyx_2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4273; goto __pyx_L1;}
    Py_DECREF(__pyx_6); __pyx_6 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_r = __pyx_5;
    __pyx_5 = 0;
    goto __pyx_L0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4275 */
  __pyx_v_g = prime(__pyx_v_n);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4276 */
  __pyx_4 = ((PyObject *)__pyx_f_7py_pari_new_gen(__pyx_v_g)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4276; goto __pyx_L1;}
  __pyx_r = __pyx_4;
  __pyx_4 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  Py_XDECREF(__pyx_6);
  __Pyx_AddTraceback("py_pari.nth_prime");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_z);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_euler(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_euler[] = "\n    EXAMPLES:\n        >> euler()\n        0.57721566490153286060651209008\n        >> get_real_precision()\n        5\n        >> euler(6)\n        0.57721566490153286060651209008240243104\n        >> set_real_precision(10)\n        >> euler()\n        0.57721566490153286060651209008240243104215933593992359880576723488486772677767\n        \n    We restore precision to the default.\n        >>> set_real_precision(5)\n        \n    Note that euler is still saved to the largest precision to which it has been\n    computed so far:\n        >> euler()\n        0.57721566490153286060651209008240243104215933593992359880576723488486772677767\n    ";
static PyObject *__pyx_f_7py_pari_euler(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_prec;
  struct __pyx_obj_7py_pari_gen *__pyx_v_g;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"prec",0};
  __pyx_v_prec = __pyx_k39;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|i", __pyx_argnames, &__pyx_v_prec)) return 0;
  ((PyObject*)__pyx_v_g) = Py_None; Py_INCREF(((PyObject*)__pyx_v_g));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4299 */
  __pyx_1 = (__pyx_v_prec <= 3);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4300 */
    consteuler(__pyx_v_7py_pari_REAL_PREC);
    goto __pyx_L2;
  }
  /*else*/ {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4302 */
    consteuler(__pyx_v_prec);
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4304 */
  __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4304; goto __pyx_L1;}
  __pyx_3 = PyObject_CallObject(((PyObject*)__pyx_ptype_7py_pari_gen), __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4304; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4304; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_g));
  ((PyObject *)__pyx_v_g) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4305 */
  __pyx_2 = ((struct __pyx_vtabstruct_7py_pari_gen *)__pyx_v_g->__pyx_vtab)->init(__pyx_v_g,geuler,0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4305; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4306 */
  Py_INCREF(((PyObject *)__pyx_v_g));
  __pyx_r = ((PyObject *)__pyx_v_g);
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.euler");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_g);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_pi(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_pi[] = "\n    EXAMPLES:\n        >> set_real_precision(5)\n        >> pi()\n        3.1415926535897932384626433833\n        >> pi(6)\n        3.14159265358979323846264338327950288419\n        >> get_real_precision()\n        5\n        >> set_real_precision(10)\n        >> pi()\n        3.1415926535897932384626433832795028841971693993751058209749445923078164062862\n        \n    We restore precision to the default.\n        >> set_real_precision(5)\n        \n    Note that pi is still saved to the largest precision to which it has been\n    computed so far:\n        >> pi()\n        3.1415926535897932384626433832795028841971693993751058209749445923078164062862\n    ";
static PyObject *__pyx_f_7py_pari_pi(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_prec;
  struct __pyx_obj_7py_pari_gen *__pyx_v_g;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"prec",0};
  __pyx_v_prec = __pyx_k40;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|i", __pyx_argnames, &__pyx_v_prec)) return 0;
  ((PyObject*)__pyx_v_g) = Py_None; Py_INCREF(((PyObject*)__pyx_v_g));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4330 */
  __pyx_1 = (__pyx_v_prec <= 3);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4331 */
    constpi(__pyx_v_7py_pari_REAL_PREC);
    goto __pyx_L2;
  }
  /*else*/ {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4333 */
    constpi(__pyx_v_prec);
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4336 */
  __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4336; goto __pyx_L1;}
  __pyx_3 = PyObject_CallObject(((PyObject*)__pyx_ptype_7py_pari_gen), __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4336; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4336; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_g));
  ((PyObject *)__pyx_v_g) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4337 */
  __pyx_2 = ((struct __pyx_vtabstruct_7py_pari_gen *)__pyx_v_g->__pyx_vtab)->init(__pyx_v_g,gpi,0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4337; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4338 */
  Py_INCREF(((PyObject *)__pyx_v_g));
  __pyx_r = ((PyObject *)__pyx_v_g);
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.pi");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_g);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_factorial(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_factorial(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4341 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(mpfact(__pyx_v_n))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4341; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.factorial");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_k168p;

static char (__pyx_k168[]) = "length of entries (=%s) must equal n (=%s)";

static PyObject *__pyx_f_7py_pari_vector(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_vector(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  PyObject *__pyx_v_entries = 0;
  int __pyx_v_e;
  struct __pyx_obj_7py_pari_gen *__pyx_v_v;
  PyObject *__pyx_v_i;
  PyObject *__pyx_v_x;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {"n","entries",0};
  __pyx_v_entries = __pyx_k41;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l|O", __pyx_argnames, &__pyx_v_n, &__pyx_v_entries)) return 0;
  Py_INCREF(__pyx_v_entries);
  ((PyObject*)__pyx_v_v) = Py_None; Py_INCREF(((PyObject*)__pyx_v_v));
  __pyx_v_i = Py_None; Py_INCREF(__pyx_v_i);
  __pyx_v_x = Py_None; Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4345 */
  __pyx_v_e = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4346 */
  __pyx_1 = __pyx_v_e;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4346; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_e); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4346; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4346; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_n_vector);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_n_vector);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4346; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4348 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(zerovec(__pyx_v_n))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4348; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_v));
  ((PyObject *)__pyx_v_v) = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4349 */
  if (PyObject_Cmp(__pyx_v_entries, Py_None, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4349; goto __pyx_L1;}
  __pyx_1 = __pyx_1 != 0;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4350 */
    __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_len); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4350; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4350; goto __pyx_L1;}
    Py_INCREF(__pyx_v_entries);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_entries);
    __pyx_2 = PyObject_CallObject(__pyx_4, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4350; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_4 = PyInt_FromLong(__pyx_v_n); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4350; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_2, __pyx_4, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4350; goto __pyx_L1;}
    __pyx_1 = __pyx_1 != 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4351 */
      __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4351; goto __pyx_L1;}
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_len); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4352; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4352; goto __pyx_L1;}
      Py_INCREF(__pyx_v_entries);
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_entries);
      __pyx_5 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4352; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4352; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4352; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_5);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_2);
      __pyx_5 = 0;
      __pyx_2 = 0;
      __pyx_5 = PyNumber_Remainder(__pyx_k168p, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4351; goto __pyx_L1;}
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __Pyx_Raise(__pyx_3, __pyx_5, 0);
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4351; goto __pyx_L1;}
      goto __pyx_L4;
    }
    __pyx_L4:;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4353 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_enumerate); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4353; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4353; goto __pyx_L1;}
    Py_INCREF(__pyx_v_entries);
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_entries);
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4353; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_5 = PyObject_GetIter(__pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4353; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    for (;;) {
      __pyx_L5:;
      __pyx_2 = PyIter_Next(__pyx_5);
      if (!__pyx_2) {
        if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4353; goto __pyx_L1;}
        break;
      }
      __pyx_4 = __Pyx_UnpackItem(__pyx_2, 0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4353; goto __pyx_L1;}
      Py_DECREF(__pyx_v_i);
      __pyx_v_i = __pyx_4;
      __pyx_4 = 0;
      __pyx_3 = __Pyx_UnpackItem(__pyx_2, 1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4353; goto __pyx_L1;}
      Py_DECREF(__pyx_v_x);
      __pyx_v_x = __pyx_3;
      __pyx_3 = 0;
      if (__Pyx_EndUnpack(__pyx_2, 2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4353; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4354 */
      if (PyObject_SetItem(((PyObject *)__pyx_v_v), __pyx_v_i, __pyx_v_x) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4354; goto __pyx_L1;}
    }
    __pyx_L6:;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4355 */
  Py_INCREF(((PyObject *)__pyx_v_v));
  __pyx_r = ((PyObject *)__pyx_v_v);
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.vector");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_v);
  Py_DECREF(__pyx_v_i);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_entries);
  return __pyx_r;
}

static PyObject *__pyx_k170p;

static char (__pyx_k170[]) = "len of entries (=%s) must be %s*%s=%s";

static PyObject *__pyx_f_7py_pari_matrix(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_matrix(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_m;
  long __pyx_v_n;
  PyObject *__pyx_v_entries = 0;
  int __pyx_v_e;
  int __pyx_v_i;
  int __pyx_v_j;
  int __pyx_v_k;
  struct __pyx_obj_7py_pari_gen *__pyx_v_A;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  PyObject *__pyx_6 = 0;
  PyObject *__pyx_7 = 0;
  static char *__pyx_argnames[] = {"m","n","entries",0};
  __pyx_v_entries = __pyx_k42;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "ll|O", __pyx_argnames, &__pyx_v_m, &__pyx_v_n, &__pyx_v_entries)) return 0;
  Py_INCREF(__pyx_v_entries);
  ((PyObject*)__pyx_v_A) = Py_None; Py_INCREF(((PyObject*)__pyx_v_A));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4359 */
  __pyx_v_e = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4360 */
  __pyx_1 = __pyx_v_e;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4360; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_e); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4360; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4360; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_n_matrix);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_n_matrix);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4360; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4362 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(forcecopy(zeromat(__pyx_v_m,__pyx_v_n)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4362; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_A));
  ((PyObject *)__pyx_v_A) = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4363 */
  if (PyObject_Cmp(__pyx_v_entries, Py_None, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4363; goto __pyx_L1;}
  __pyx_1 = __pyx_1 != 0;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4364 */
    __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_len); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4364; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4364; goto __pyx_L1;}
    Py_INCREF(__pyx_v_entries);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_entries);
    __pyx_2 = PyObject_CallObject(__pyx_4, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4364; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_4 = PyInt_FromLong((__pyx_v_m * __pyx_v_n)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4364; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_2, __pyx_4, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4364; goto __pyx_L1;}
    __pyx_1 = __pyx_1 != 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4365 */
      __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4365; goto __pyx_L1;}
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_len); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4365; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4365; goto __pyx_L1;}
      Py_INCREF(__pyx_v_entries);
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_entries);
      __pyx_5 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4365; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_2 = PyInt_FromLong(__pyx_v_m); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4365; goto __pyx_L1;}
      __pyx_4 = PyInt_FromLong(__pyx_v_n); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4365; goto __pyx_L1;}
      __pyx_6 = PyInt_FromLong((__pyx_v_m * __pyx_v_n)); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4365; goto __pyx_L1;}
      __pyx_7 = PyTuple_New(4); if (!__pyx_7) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4365; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_7, 0, __pyx_5);
      PyTuple_SET_ITEM(__pyx_7, 1, __pyx_2);
      PyTuple_SET_ITEM(__pyx_7, 2, __pyx_4);
      PyTuple_SET_ITEM(__pyx_7, 3, __pyx_6);
      __pyx_5 = 0;
      __pyx_2 = 0;
      __pyx_4 = 0;
      __pyx_6 = 0;
      __pyx_5 = PyNumber_Remainder(__pyx_k170p, __pyx_7); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4365; goto __pyx_L1;}
      Py_DECREF(__pyx_7); __pyx_7 = 0;
      __Pyx_Raise(__pyx_3, __pyx_5, 0);
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4365; goto __pyx_L1;}
      goto __pyx_L4;
    }
    __pyx_L4:;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4366 */
    __pyx_v_k = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4367 */
    for (__pyx_v_i = 0; __pyx_v_i < __pyx_v_m; ++__pyx_v_i) {

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4368 */
      for (__pyx_v_j = 0; __pyx_v_j < __pyx_v_n; ++__pyx_v_j) {

        /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4369 */
        __pyx_2 = PyInt_FromLong(__pyx_v_k); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4369; goto __pyx_L1;}
        __pyx_4 = PyObject_GetItem(__pyx_v_entries, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4369; goto __pyx_L1;}
        Py_DECREF(__pyx_2); __pyx_2 = 0;
        __pyx_6 = PyInt_FromLong(__pyx_v_i); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4369; goto __pyx_L1;}
        __pyx_7 = PyInt_FromLong(__pyx_v_j); if (!__pyx_7) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4369; goto __pyx_L1;}
        __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4369; goto __pyx_L1;}
        PyTuple_SET_ITEM(__pyx_3, 0, __pyx_6);
        PyTuple_SET_ITEM(__pyx_3, 1, __pyx_7);
        __pyx_6 = 0;
        __pyx_7 = 0;
        if (PyObject_SetItem(((PyObject *)__pyx_v_A), __pyx_3, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4369; goto __pyx_L1;}
        Py_DECREF(__pyx_3); __pyx_3 = 0;
        Py_DECREF(__pyx_4); __pyx_4 = 0;

        /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4370 */
        __pyx_v_k = (__pyx_v_k + 1);
        __pyx_L7:;
      }
      __pyx_L8:;
      __pyx_L5:;
    }
    __pyx_L6:;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4371 */
  Py_INCREF(((PyObject *)__pyx_v_A));
  __pyx_r = ((PyObject *)__pyx_v_A);
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  Py_XDECREF(__pyx_6);
  Py_XDECREF(__pyx_7);
  __Pyx_AddTraceback("py_pari.matrix");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_A);
  Py_DECREF(__pyx_v_entries);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_set_real_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_set_real_precision[] = "\n    Set the default precision to n words (word = 4 bytes on\n    a 32-bit machine). \n    \n    EXAMPLES:\n        >>> get_real_precision()\n        5\n        >>> set_real_precision(10)\n        >>> get_real_precision()\n        10\n        >>> set_real_precision(5)        \n    ";
static PyObject *__pyx_f_7py_pari_set_real_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  static char *__pyx_argnames[] = {"n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4387 */
  __pyx_1 = (__pyx_v_n <= 2);
  if (__pyx_1) {
    __pyx_v_n = 3;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4388 */
  __pyx_v_7py_pari_REAL_PREC = __pyx_v_n;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("py_pari.set_real_precision");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_get_real_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_get_real_precision[] = "\n    EXAMPLES:\n        >>> get_real_precision()\n        5\n        >>> set_real_precision(10)\n        >>> get_real_precision()\n        10\n        >>> set_real_precision(5)\n    ";
static PyObject *__pyx_f_7py_pari_get_real_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4401 */
  __pyx_1 = PyInt_FromLong(__pyx_v_7py_pari_REAL_PREC); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4401; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.get_real_precision");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_set_series_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_set_series_precision[] = "\n    Set the default precision used when coercing objects into power series.\n    \n    EXAMPLES:\n        >>> default = get_series_precision()\n        >>> f = pari(\'1+x + x^2 + x^3\')\n        >>> set_series_precision(3)\n        >>> f.exp()\n        2.7182818284590452353602874713 + 2.7182818284590452353602874713*x + 4.0774227426885678530404312070*x^2 + 5.8896106283279313432806228545*x^3 + O(x^4)\n        >>> set_series_precision(10)\n        >>> f.exp()\n        2.7182818284590452353602874713 + 2.7182818284590452353602874713*x + 4.0774227426885678530404312070*x^2 + 5.8896106283279313432806228545*x^3 + 5.5498253997705506888605869205*x^4 + 5.9122629768984233869086252500*x^5 + 5.7801242769038864657452779424*x^6 + 4.8934466328589121865920413149*x^7 + 4.2738105146702444098510591187*x^8 + 3.4890085123444142422523306195*x^9 + O(x^10)\n        >>> set_series_precision(default)\n    ";
static PyObject *__pyx_f_7py_pari_set_series_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  static char *__pyx_argnames[] = {"n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4419 */
  __pyx_1 = (__pyx_v_n <= 2);
  if (__pyx_1) {
    __pyx_v_n = 3;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4420 */
  precdl = __pyx_v_n;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("py_pari.set_series_precision");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_get_series_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_get_series_precision[] = "\n    Get the default precision used when coercing objects into power series.\n    \n    EXAMPLES:\n        >>> get_series_precision()\n        16\n    ";
static PyObject *__pyx_f_7py_pari_get_series_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4431 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_int); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4431; goto __pyx_L1;}
  __pyx_2 = PyLong_FromUnsignedLong(precdl); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4431; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4431; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
  __pyx_2 = 0;
  __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4431; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.get_series_precision");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_init_primes(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_init_primes[] = "\n    Recompute the primes table including at least all primes up to M.\n    \n    EXAMPLES:\n        >>> init_primes(200000)\n    ";
static PyObject *__pyx_f_7py_pari_init_primes(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  unsigned long __pyx_v_M;
  PyObject *__pyx_r;
  static char *__pyx_argnames[] = {"M",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_M)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4441 */
  free(((void (*))diffptr));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4442 */
  __pyx_v_7py_pari_num_primes = __pyx_v_M;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4443 */
  diffptr = initprimes(__pyx_v_M);

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("py_pari.init_primes");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static __Pyx_InternTabEntry __pyx_intern_tab[] = {
  {&__pyx_n_ArithmeticError, "ArithmeticError"},
  {&__pyx_n_AttributeError, "AttributeError"},
  {&__pyx_n_False, "False"},
  {&__pyx_n_IndexError, "IndexError"},
  {&__pyx_n_InputError, "InputError"},
  {&__pyx_n_KeyboardInterrupt, "KeyboardInterrupt"},
  {&__pyx_n_MemoryError, "MemoryError"},
  {&__pyx_n_NotImplementedError, "NotImplementedError"},
  {&__pyx_n_OverflowError, "OverflowError"},
  {&__pyx_n_RuntimeError, "RuntimeError"},
  {&__pyx_n_SIGINT, "SIGINT"},
  {&__pyx_n_True, "True"},
  {&__pyx_n_TypeError, "TypeError"},
  {&__pyx_n_ValueError, "ValueError"},
  {&__pyx_n___cmp__, "__cmp__"},
  {&__pyx_n___setitem__, "__setitem__"},
  {&__pyx_n__add, "_add"},
  {&__pyx_n__div, "_div"},
  {&__pyx_n__error, "_error"},
  {&__pyx_n__init, "_init"},
  {&__pyx_n__mod, "_mod"},
  {&__pyx_n__mul, "_mul"},
  {&__pyx_n__sub, "_sub"},
  {&__pyx_n_abs, "abs"},
  {&__pyx_n_bezout, "bezout"},
  {&__pyx_n_bool, "bool"},
  {&__pyx_n_ellan, "ellan"},
  {&__pyx_n_enumerate, "enumerate"},
  {&__pyx_n_euler, "euler"},
  {&__pyx_n_eval, "eval"},
  {&__pyx_n_execute, "execute"},
  {&__pyx_n_factorial, "factorial"},
  {&__pyx_n_find, "find"},
  {&__pyx_n_float, "float"},
  {&__pyx_n_gc, "gc"},
  {&__pyx_n_get_real_precision, "get_real_precision"},
  {&__pyx_n_get_series_precision, "get_series_precision"},
  {&__pyx_n_init_fmt, "init_fmt"},
  {&__pyx_n_init_primes, "init_primes"},
  {&__pyx_n_initialized, "initialized"},
  {&__pyx_n_int, "int"},
  {&__pyx_n_isinstance, "isinstance"},
  {&__pyx_n_len, "len"},
  {&__pyx_n_list, "list"},
  {&__pyx_n_long, "long"},
  {&__pyx_n_matrix, "matrix"},
  {&__pyx_n_max, "max"},
  {&__pyx_n_min, "min"},
  {&__pyx_n_my_sigint, "my_sigint"},
  {&__pyx_n_ncols, "ncols"},
  {&__pyx_n_nrows, "nrows"},
  {&__pyx_n_nth_prime, "nth_prime"},
  {&__pyx_n_pari, "pari"},
  {&__pyx_n_pi, "pi"},
  {&__pyx_n_polcoeff, "polcoeff"},
  {&__pyx_n_prec, "prec"},
  {&__pyx_n_prime_list, "prime_list"},
  {&__pyx_n_py_pari_py, "py_pari_py"},
  {&__pyx_n_python, "python"},
  {&__pyx_n_replace, "replace"},
  {&__pyx_n_set_real_precision, "set_real_precision"},
  {&__pyx_n_set_series_precision, "set_series_precision"},
  {&__pyx_n_signal, "signal"},
  {&__pyx_n_stack_available, "stack_available"},
  {&__pyx_n_stack_bottom, "stack_bottom"},
  {&__pyx_n_stack_ptr, "stack_ptr"},
  {&__pyx_n_stack_size, "stack_size"},
  {&__pyx_n_stack_top, "stack_top"},
  {&__pyx_n_stack_usage, "stack_usage"},
  {&__pyx_n_str, "str"},
  {&__pyx_n_sys, "sys"},
  {&__pyx_n_tuple, "tuple"},
  {&__pyx_n_vector, "vector"},
  {&__pyx_n_xrange, "xrange"},
  {0, 0}
};

static __Pyx_StringTabEntry __pyx_string_tab[] = {
  {&__pyx_k37p, __pyx_k37, sizeof(__pyx_k37)},
  {&__pyx_k43p, __pyx_k43, sizeof(__pyx_k43)},
  {&__pyx_k45p, __pyx_k45, sizeof(__pyx_k45)},
  {&__pyx_k47p, __pyx_k47, sizeof(__pyx_k47)},
  {&__pyx_k49p, __pyx_k49, sizeof(__pyx_k49)},
  {&__pyx_k50p, __pyx_k50, sizeof(__pyx_k50)},
  {&__pyx_k51p, __pyx_k51, sizeof(__pyx_k51)},
  {&__pyx_k52p, __pyx_k52, sizeof(__pyx_k52)},
  {&__pyx_k53p, __pyx_k53, sizeof(__pyx_k53)},
  {&__pyx_k54p, __pyx_k54, sizeof(__pyx_k54)},
  {&__pyx_k55p, __pyx_k55, sizeof(__pyx_k55)},
  {&__pyx_k56p, __pyx_k56, sizeof(__pyx_k56)},
  {&__pyx_k57p, __pyx_k57, sizeof(__pyx_k57)},
  {&__pyx_k58p, __pyx_k58, sizeof(__pyx_k58)},
  {&__pyx_k59p, __pyx_k59, sizeof(__pyx_k59)},
  {&__pyx_k60p, __pyx_k60, sizeof(__pyx_k60)},
  {&__pyx_k61p, __pyx_k61, sizeof(__pyx_k61)},
  {&__pyx_k62p, __pyx_k62, sizeof(__pyx_k62)},
  {&__pyx_k63p, __pyx_k63, sizeof(__pyx_k63)},
  {&__pyx_k65p, __pyx_k65, sizeof(__pyx_k65)},
  {&__pyx_k66p, __pyx_k66, sizeof(__pyx_k66)},
  {&__pyx_k67p, __pyx_k67, sizeof(__pyx_k67)},
  {&__pyx_k70p, __pyx_k70, sizeof(__pyx_k70)},
  {&__pyx_k71p, __pyx_k71, sizeof(__pyx_k71)},
  {&__pyx_k72p, __pyx_k72, sizeof(__pyx_k72)},
  {&__pyx_k73p, __pyx_k73, sizeof(__pyx_k73)},
  {&__pyx_k74p, __pyx_k74, sizeof(__pyx_k74)},
  {&__pyx_k75p, __pyx_k75, sizeof(__pyx_k75)},
  {&__pyx_k76p, __pyx_k76, sizeof(__pyx_k76)},
  {&__pyx_k77p, __pyx_k77, sizeof(__pyx_k77)},
  {&__pyx_k78p, __pyx_k78, sizeof(__pyx_k78)},
  {&__pyx_k79p, __pyx_k79, sizeof(__pyx_k79)},
  {&__pyx_k80p, __pyx_k80, sizeof(__pyx_k80)},
  {&__pyx_k81p, __pyx_k81, sizeof(__pyx_k81)},
  {&__pyx_k82p, __pyx_k82, sizeof(__pyx_k82)},
  {&__pyx_k83p, __pyx_k83, sizeof(__pyx_k83)},
  {&__pyx_k84p, __pyx_k84, sizeof(__pyx_k84)},
  {&__pyx_k85p, __pyx_k85, sizeof(__pyx_k85)},
  {&__pyx_k86p, __pyx_k86, sizeof(__pyx_k86)},
  {&__pyx_k87p, __pyx_k87, sizeof(__pyx_k87)},
  {&__pyx_k88p, __pyx_k88, sizeof(__pyx_k88)},
  {&__pyx_k89p, __pyx_k89, sizeof(__pyx_k89)},
  {&__pyx_k90p, __pyx_k90, sizeof(__pyx_k90)},
  {&__pyx_k91p, __pyx_k91, sizeof(__pyx_k91)},
  {&__pyx_k92p, __pyx_k92, sizeof(__pyx_k92)},
  {&__pyx_k93p, __pyx_k93, sizeof(__pyx_k93)},
  {&__pyx_k94p, __pyx_k94, sizeof(__pyx_k94)},
  {&__pyx_k95p, __pyx_k95, sizeof(__pyx_k95)},
  {&__pyx_k96p, __pyx_k96, sizeof(__pyx_k96)},
  {&__pyx_k97p, __pyx_k97, sizeof(__pyx_k97)},
  {&__pyx_k98p, __pyx_k98, sizeof(__pyx_k98)},
  {&__pyx_k99p, __pyx_k99, sizeof(__pyx_k99)},
  {&__pyx_k100p, __pyx_k100, sizeof(__pyx_k100)},
  {&__pyx_k101p, __pyx_k101, sizeof(__pyx_k101)},
  {&__pyx_k102p, __pyx_k102, sizeof(__pyx_k102)},
  {&__pyx_k103p, __pyx_k103, sizeof(__pyx_k103)},
  {&__pyx_k104p, __pyx_k104, sizeof(__pyx_k104)},
  {&__pyx_k105p, __pyx_k105, sizeof(__pyx_k105)},
  {&__pyx_k106p, __pyx_k106, sizeof(__pyx_k106)},
  {&__pyx_k107p, __pyx_k107, sizeof(__pyx_k107)},
  {&__pyx_k108p, __pyx_k108, sizeof(__pyx_k108)},
  {&__pyx_k109p, __pyx_k109, sizeof(__pyx_k109)},
  {&__pyx_k110p, __pyx_k110, sizeof(__pyx_k110)},
  {&__pyx_k111p, __pyx_k111, sizeof(__pyx_k111)},
  {&__pyx_k112p, __pyx_k112, sizeof(__pyx_k112)},
  {&__pyx_k113p, __pyx_k113, sizeof(__pyx_k113)},
  {&__pyx_k114p, __pyx_k114, sizeof(__pyx_k114)},
  {&__pyx_k115p, __pyx_k115, sizeof(__pyx_k115)},
  {&__pyx_k116p, __pyx_k116, sizeof(__pyx_k116)},
  {&__pyx_k117p, __pyx_k117, sizeof(__pyx_k117)},
  {&__pyx_k118p, __pyx_k118, sizeof(__pyx_k118)},
  {&__pyx_k119p, __pyx_k119, sizeof(__pyx_k119)},
  {&__pyx_k120p, __pyx_k120, sizeof(__pyx_k120)},
  {&__pyx_k121p, __pyx_k121, sizeof(__pyx_k121)},
  {&__pyx_k122p, __pyx_k122, sizeof(__pyx_k122)},
  {&__pyx_k123p, __pyx_k123, sizeof(__pyx_k123)},
  {&__pyx_k124p, __pyx_k124, sizeof(__pyx_k124)},
  {&__pyx_k125p, __pyx_k125, sizeof(__pyx_k125)},
  {&__pyx_k126p, __pyx_k126, sizeof(__pyx_k126)},
  {&__pyx_k127p, __pyx_k127, sizeof(__pyx_k127)},
  {&__pyx_k128p, __pyx_k128, sizeof(__pyx_k128)},
  {&__pyx_k129p, __pyx_k129, sizeof(__pyx_k129)},
  {&__pyx_k130p, __pyx_k130, sizeof(__pyx_k130)},
  {&__pyx_k131p, __pyx_k131, sizeof(__pyx_k131)},
  {&__pyx_k132p, __pyx_k132, sizeof(__pyx_k132)},
  {&__pyx_k133p, __pyx_k133, sizeof(__pyx_k133)},
  {&__pyx_k134p, __pyx_k134, sizeof(__pyx_k134)},
  {&__pyx_k135p, __pyx_k135, sizeof(__pyx_k135)},
  {&__pyx_k136p, __pyx_k136, sizeof(__pyx_k136)},
  {&__pyx_k137p, __pyx_k137, sizeof(__pyx_k137)},
  {&__pyx_k138p, __pyx_k138, sizeof(__pyx_k138)},
  {&__pyx_k139p, __pyx_k139, sizeof(__pyx_k139)},
  {&__pyx_k140p, __pyx_k140, sizeof(__pyx_k140)},
  {&__pyx_k141p, __pyx_k141, sizeof(__pyx_k141)},
  {&__pyx_k142p, __pyx_k142, sizeof(__pyx_k142)},
  {&__pyx_k143p, __pyx_k143, sizeof(__pyx_k143)},
  {&__pyx_k144p, __pyx_k144, sizeof(__pyx_k144)},
  {&__pyx_k145p, __pyx_k145, sizeof(__pyx_k145)},
  {&__pyx_k146p, __pyx_k146, sizeof(__pyx_k146)},
  {&__pyx_k147p, __pyx_k147, sizeof(__pyx_k147)},
  {&__pyx_k148p, __pyx_k148, sizeof(__pyx_k148)},
  {&__pyx_k149p, __pyx_k149, sizeof(__pyx_k149)},
  {&__pyx_k150p, __pyx_k150, sizeof(__pyx_k150)},
  {&__pyx_k151p, __pyx_k151, sizeof(__pyx_k151)},
  {&__pyx_k152p, __pyx_k152, sizeof(__pyx_k152)},
  {&__pyx_k153p, __pyx_k153, sizeof(__pyx_k153)},
  {&__pyx_k157p, __pyx_k157, sizeof(__pyx_k157)},
  {&__pyx_k158p, __pyx_k158, sizeof(__pyx_k158)},
  {&__pyx_k160p, __pyx_k160, sizeof(__pyx_k160)},
  {&__pyx_k161p, __pyx_k161, sizeof(__pyx_k161)},
  {&__pyx_k162p, __pyx_k162, sizeof(__pyx_k162)},
  {&__pyx_k163p, __pyx_k163, sizeof(__pyx_k163)},
  {&__pyx_k164p, __pyx_k164, sizeof(__pyx_k164)},
  {&__pyx_k166p, __pyx_k166, sizeof(__pyx_k166)},
  {&__pyx_k168p, __pyx_k168, sizeof(__pyx_k168)},
  {&__pyx_k170p, __pyx_k170, sizeof(__pyx_k170)},
  {0, 0, 0}
};
static struct __pyx_vtabstruct_7py_pari_gen __pyx_vtable_7py_pari_gen;

static PyObject *__pyx_tp_new_7py_pari_gen(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = (*t->tp_alloc)(t, 0);
  struct __pyx_obj_7py_pari_gen *p = (struct __pyx_obj_7py_pari_gen *)o;
  (struct __pyx_vtabstruct_7py_pari_gen *)p->__pyx_vtab = __pyx_vtabptr_7py_pari_gen;
  p->refers_to = Py_None; Py_INCREF(p->refers_to);
  return o;
}

static void __pyx_tp_dealloc_7py_pari_gen(PyObject *o) {
  struct __pyx_obj_7py_pari_gen *p = (struct __pyx_obj_7py_pari_gen *)o;
  {
    PyObject *etype, *eval, *etb;
    PyErr_Fetch(&etype, &eval, &etb);
    ++o->ob_refcnt;
    __pyx_f_7py_pari_3gen___dealloc__(o);
    if (PyErr_Occurred()) PyErr_WriteUnraisable(o);
    --o->ob_refcnt;
    PyErr_Restore(etype, eval, etb);
  }
  Py_XDECREF(p->refers_to);
  (*o->ob_type->tp_free)(o);
}

static int __pyx_tp_traverse_7py_pari_gen(PyObject *o, visitproc v, void *a) {
  int e;
  struct __pyx_obj_7py_pari_gen *p = (struct __pyx_obj_7py_pari_gen *)o;
  if (p->refers_to) {
    e = (*v)(p->refers_to, a); if (e) return e;
  }
  return 0;
}

static int __pyx_tp_clear_7py_pari_gen(PyObject *o) {
  struct __pyx_obj_7py_pari_gen *p = (struct __pyx_obj_7py_pari_gen *)o;
  Py_XDECREF(p->refers_to);
  p->refers_to = Py_None; Py_INCREF(p->refers_to);
  return 0;
}
static PyObject *__pyx_sq_item_7py_pari_gen(PyObject *o, int i) {
  PyObject *r;
  PyObject *x = PyInt_FromLong(i); if(!x) return 0;
  r = o->ob_type->tp_as_mapping->mp_subscript(o, x);
  Py_DECREF(x);
  return r;
}

static int __pyx_mp_ass_subscript_7py_pari_gen(PyObject *o, PyObject *i, PyObject *v) {
  if (v) {
    return __pyx_f_7py_pari_3gen___setitem__(o, i, v);
  }
  else {
    PyErr_Format(PyExc_NotImplementedError,
      "Subscript deletion not supported by %s", o->ob_type->tp_name);
    return -1;
  }
}

static struct PyMethodDef __pyx_methods_7py_pari_gen[] = {
  {"__reduce__", (PyCFunction)__pyx_f_7py_pari_3gen___reduce__, METH_VARARGS|METH_KEYWORDS, 0},
  {"_add", (PyCFunction)__pyx_f_7py_pari_3gen__add, METH_VARARGS|METH_KEYWORDS, 0},
  {"_sub", (PyCFunction)__pyx_f_7py_pari_3gen__sub, METH_VARARGS|METH_KEYWORDS, 0},
  {"_mul", (PyCFunction)__pyx_f_7py_pari_3gen__mul, METH_VARARGS|METH_KEYWORDS, 0},
  {"_div", (PyCFunction)__pyx_f_7py_pari_3gen__div, METH_VARARGS|METH_KEYWORDS, 0},
  {"_mod", (PyCFunction)__pyx_f_7py_pari_3gen__mod, METH_VARARGS|METH_KEYWORDS, 0},
  {"ncols", (PyCFunction)__pyx_f_7py_pari_3gen_ncols, METH_VARARGS|METH_KEYWORDS, 0},
  {"nrows", (PyCFunction)__pyx_f_7py_pari_3gen_nrows, METH_VARARGS|METH_KEYWORDS, 0},
  {"polcoeff", (PyCFunction)__pyx_f_7py_pari_3gen_polcoeff, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_polcoeff},
  {"copy", (PyCFunction)__pyx_f_7py_pari_3gen_copy, METH_VARARGS|METH_KEYWORDS, 0},
  {"list_str", (PyCFunction)__pyx_f_7py_pari_3gen_list_str, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_list_str},
  {"python", (PyCFunction)__pyx_f_7py_pari_3gen_python, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_python},
  {"__bool__", (PyCFunction)__pyx_f_7py_pari_3gen___bool__, METH_VARARGS|METH_KEYWORDS, 0},
  {"isprime", (PyCFunction)__pyx_f_7py_pari_3gen_isprime, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_isprime},
  {"divrem", (PyCFunction)__pyx_f_7py_pari_3gen_divrem, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_divrem},
  {"lex", (PyCFunction)__pyx_f_7py_pari_3gen_lex, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_lex},
  {"max", (PyCFunction)__pyx_f_7py_pari_3gen_max, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_max},
  {"min", (PyCFunction)__pyx_f_7py_pari_3gen_min, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_min},
  {"shift", (PyCFunction)__pyx_f_7py_pari_3gen_shift, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_shift},
  {"shiftmul", (PyCFunction)__pyx_f_7py_pari_3gen_shiftmul, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_shiftmul},
  {"sign", (PyCFunction)__pyx_f_7py_pari_3gen_sign, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_sign},
  {"vecmax", (PyCFunction)__pyx_f_7py_pari_3gen_vecmax, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_vecmax},
  {"vecmin", (PyCFunction)__pyx_f_7py_pari_3gen_vecmin, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_vecmin},
  {"Col", (PyCFunction)__pyx_f_7py_pari_3gen_Col, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Col},
  {"List", (PyCFunction)__pyx_f_7py_pari_3gen_List, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_List},
  {"Mat", (PyCFunction)__pyx_f_7py_pari_3gen_Mat, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Mat},
  {"Mod", (PyCFunction)__pyx_f_7py_pari_3gen_Mod, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Mod},
  {"Pol", (PyCFunction)__pyx_f_7py_pari_3gen_Pol, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Pol},
  {"Polrev", (PyCFunction)__pyx_f_7py_pari_3gen_Polrev, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Polrev},
  {"Qfb", (PyCFunction)__pyx_f_7py_pari_3gen_Qfb, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Qfb},
  {"Ser", (PyCFunction)__pyx_f_7py_pari_3gen_Ser, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Ser},
  {"Set", (PyCFunction)__pyx_f_7py_pari_3gen_Set, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Set},
  {"Str", (PyCFunction)__pyx_f_7py_pari_3gen_Str, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Str},
  {"Strchr", (PyCFunction)__pyx_f_7py_pari_3gen_Strchr, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Strchr},
  {"Strexpand", (PyCFunction)__pyx_f_7py_pari_3gen_Strexpand, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Strexpand},
  {"Strtex", (PyCFunction)__pyx_f_7py_pari_3gen_Strtex, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Strtex},
  {"Vec", (PyCFunction)__pyx_f_7py_pari_3gen_Vec, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Vec},
  {"Vecsmall", (PyCFunction)__pyx_f_7py_pari_3gen_Vecsmall, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Vecsmall},
  {"binary", (PyCFunction)__pyx_f_7py_pari_3gen_binary, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_binary},
  {"bitand", (PyCFunction)__pyx_f_7py_pari_3gen_bitand, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_bitand},
  {"bitneg", (PyCFunction)__pyx_f_7py_pari_3gen_bitneg, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_bitneg},
  {"bitnegimply", (PyCFunction)__pyx_f_7py_pari_3gen_bitnegimply, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_bitnegimply},
  {"bitor", (PyCFunction)__pyx_f_7py_pari_3gen_bitor, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_bitor},
  {"bittest", (PyCFunction)__pyx_f_7py_pari_3gen_bittest, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_bittest},
  {"bitxor", (PyCFunction)__pyx_f_7py_pari_3gen_bitxor, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_bitxor},
  {"ceil", (PyCFunction)__pyx_f_7py_pari_3gen_ceil, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_ceil},
  {"centerlift", (PyCFunction)__pyx_f_7py_pari_3gen_centerlift, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_centerlift},
  {"changevar", (PyCFunction)__pyx_f_7py_pari_3gen_changevar, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_changevar},
  {"component", (PyCFunction)__pyx_f_7py_pari_3gen_component, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_component},
  {"conj", (PyCFunction)__pyx_f_7py_pari_3gen_conj, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_conj},
  {"conjvec", (PyCFunction)__pyx_f_7py_pari_3gen_conjvec, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_conjvec},
  {"denominator", (PyCFunction)__pyx_f_7py_pari_3gen_denominator, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_denominator},
  {"floor", (PyCFunction)__pyx_f_7py_pari_3gen_floor, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_floor},
  {"frac", (PyCFunction)__pyx_f_7py_pari_3gen_frac, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_frac},
  {"imag", (PyCFunction)__pyx_f_7py_pari_3gen_imag, METH_VARARGS|METH_KEYWORDS, 0},
  {"length", (PyCFunction)__pyx_f_7py_pari_3gen_length, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_length},
  {"lift", (PyCFunction)__pyx_f_7py_pari_3gen_lift, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_lift},
  {"numerator", (PyCFunction)__pyx_f_7py_pari_3gen_numerator, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_numerator},
  {"numtoperm", (PyCFunction)__pyx_f_7py_pari_3gen_numtoperm, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_numtoperm},
  {"padicprec", (PyCFunction)__pyx_f_7py_pari_3gen_padicprec, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_padicprec},
  {"permtonum", (PyCFunction)__pyx_f_7py_pari_3gen_permtonum, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_permtonum},
  {"precision", (PyCFunction)__pyx_f_7py_pari_3gen_precision, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_precision},
  {"random", (PyCFunction)__pyx_f_7py_pari_3gen_random, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_random},
  {"real", (PyCFunction)__pyx_f_7py_pari_3gen_real, METH_VARARGS|METH_KEYWORDS, 0},
  {"round", (PyCFunction)__pyx_f_7py_pari_3gen_round, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_round},
  {"simplify", (PyCFunction)__pyx_f_7py_pari_3gen_simplify, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_simplify},
  {"sizebyte", (PyCFunction)__pyx_f_7py_pari_3gen_sizebyte, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_sizebyte},
  {"sizedigit", (PyCFunction)__pyx_f_7py_pari_3gen_sizedigit, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_sizedigit},
  {"truncate", (PyCFunction)__pyx_f_7py_pari_3gen_truncate, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_truncate},
  {"valuation", (PyCFunction)__pyx_f_7py_pari_3gen_valuation, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_valuation},
  {"variable", (PyCFunction)__pyx_f_7py_pari_3gen_variable, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_variable},
  {"sqrt", (PyCFunction)__pyx_f_7py_pari_3gen_sqrt, METH_VARARGS|METH_KEYWORDS, 0},
  {"gamma", (PyCFunction)__pyx_f_7py_pari_3gen_gamma, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_gamma},
  {"zeta", (PyCFunction)__pyx_f_7py_pari_3gen_zeta, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_zeta},
  {"issquare", (PyCFunction)__pyx_f_7py_pari_3gen_issquare, METH_VARARGS|METH_KEYWORDS, 0},
  {"issquarefree", (PyCFunction)__pyx_f_7py_pari_3gen_issquarefree, METH_VARARGS|METH_KEYWORDS, 0},
  {"lcm", (PyCFunction)__pyx_f_7py_pari_3gen_lcm, METH_VARARGS|METH_KEYWORDS, 0},
  {"gcd", (PyCFunction)__pyx_f_7py_pari_3gen_gcd, METH_VARARGS|METH_KEYWORDS, 0},
  {"bezout", (PyCFunction)__pyx_f_7py_pari_3gen_bezout, METH_VARARGS|METH_KEYWORDS, 0},
  {"xgcd", (PyCFunction)__pyx_f_7py_pari_3gen_xgcd, METH_VARARGS|METH_KEYWORDS, 0},
  {"elladd", (PyCFunction)__pyx_f_7py_pari_3gen_elladd, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_elladd},
  {"ellak", (PyCFunction)__pyx_f_7py_pari_3gen_ellak, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_ellak},
  {"ellan", (PyCFunction)__pyx_f_7py_pari_3gen_ellan, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_ellan},
  {"ellap", (PyCFunction)__pyx_f_7py_pari_3gen_ellap, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_ellap},
  {"ellbil", (PyCFunction)__pyx_f_7py_pari_3gen_ellbil, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_ellbil},
  {"ellchangecurve", (PyCFunction)__pyx_f_7py_pari_3gen_ellchangecurve, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_ellchangecurve},
  {"ellchangepoint", (PyCFunction)__pyx_f_7py_pari_3gen_ellchangepoint, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_ellchangepoint},
  {"elleisnum", (PyCFunction)__pyx_f_7py_pari_3gen_elleisnum, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_elleisnum},
  {"elleta", (PyCFunction)__pyx_f_7py_pari_3gen_elleta, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellglobalred", (PyCFunction)__pyx_f_7py_pari_3gen_ellglobalred, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellheight", (PyCFunction)__pyx_f_7py_pari_3gen_ellheight, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellheightmatrix", (PyCFunction)__pyx_f_7py_pari_3gen_ellheightmatrix, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_ellheightmatrix},
  {"ellinit", (PyCFunction)__pyx_f_7py_pari_3gen_ellinit, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_ellinit},
  {"ellisoncurve", (PyCFunction)__pyx_f_7py_pari_3gen_ellisoncurve, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellj", (PyCFunction)__pyx_f_7py_pari_3gen_ellj, METH_VARARGS|METH_KEYWORDS, 0},
  {"elllocalred", (PyCFunction)__pyx_f_7py_pari_3gen_elllocalred, METH_VARARGS|METH_KEYWORDS, 0},
  {"elllseries", (PyCFunction)__pyx_f_7py_pari_3gen_elllseries, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellminimalmodel", (PyCFunction)__pyx_f_7py_pari_3gen_ellminimalmodel, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_ellminimalmodel},
  {"ellorder", (PyCFunction)__pyx_f_7py_pari_3gen_ellorder, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellordinate", (PyCFunction)__pyx_f_7py_pari_3gen_ellordinate, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellpointtoz", (PyCFunction)__pyx_f_7py_pari_3gen_ellpointtoz, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellpow", (PyCFunction)__pyx_f_7py_pari_3gen_ellpow, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellrootno", (PyCFunction)__pyx_f_7py_pari_3gen_ellrootno, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellsigma", (PyCFunction)__pyx_f_7py_pari_3gen_ellsigma, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellsub", (PyCFunction)__pyx_f_7py_pari_3gen_ellsub, METH_VARARGS|METH_KEYWORDS, 0},
  {"elltaniyama", (PyCFunction)__pyx_f_7py_pari_3gen_elltaniyama, METH_VARARGS|METH_KEYWORDS, 0},
  {"elltors", (PyCFunction)__pyx_f_7py_pari_3gen_elltors, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellwp", (PyCFunction)__pyx_f_7py_pari_3gen_ellwp, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellzeta", (PyCFunction)__pyx_f_7py_pari_3gen_ellzeta, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellztopoint", (PyCFunction)__pyx_f_7py_pari_3gen_ellztopoint, METH_VARARGS|METH_KEYWORDS, 0},
  {"omega", (PyCFunction)__pyx_f_7py_pari_3gen_omega, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_omega},
  {"disc", (PyCFunction)__pyx_f_7py_pari_3gen_disc, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_disc},
  {"j", (PyCFunction)__pyx_f_7py_pari_3gen_j, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_j},
  {"bnfunit", (PyCFunction)__pyx_f_7py_pari_3gen_bnfunit, METH_VARARGS|METH_KEYWORDS, 0},
  {"bnfinit", (PyCFunction)__pyx_f_7py_pari_3gen_bnfinit, METH_VARARGS|METH_KEYWORDS, 0},
  {"idealfactor", (PyCFunction)__pyx_f_7py_pari_3gen_idealfactor, METH_VARARGS|METH_KEYWORDS, 0},
  {"nfbasis", (PyCFunction)__pyx_f_7py_pari_3gen_nfbasis, METH_VARARGS|METH_KEYWORDS, 0},
  {"nfinit", (PyCFunction)__pyx_f_7py_pari_3gen_nfinit, METH_VARARGS|METH_KEYWORDS, 0},
  {"polcompositum", (PyCFunction)__pyx_f_7py_pari_3gen_polcompositum, METH_VARARGS|METH_KEYWORDS, 0},
  {"poldisc", (PyCFunction)__pyx_f_7py_pari_3gen_poldisc, METH_VARARGS|METH_KEYWORDS, 0},
  {"polresultant", (PyCFunction)__pyx_f_7py_pari_3gen_polresultant, METH_VARARGS|METH_KEYWORDS, 0},
  {"polroots", (PyCFunction)__pyx_f_7py_pari_3gen_polroots, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_polroots},
  {"factor", (PyCFunction)__pyx_f_7py_pari_3gen_factor, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_factor},
  {"abs", (PyCFunction)__pyx_f_7py_pari_3gen_abs, METH_VARARGS|METH_KEYWORDS, 0},
  {"mattranspose", (PyCFunction)__pyx_f_7py_pari_3gen_mattranspose, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_mattranspose},
  {"matker", (PyCFunction)__pyx_f_7py_pari_3gen_matker, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_matker},
  {"matkerint", (PyCFunction)__pyx_f_7py_pari_3gen_matkerint, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_matkerint},
  {"trace", (PyCFunction)__pyx_f_7py_pari_3gen_trace, METH_VARARGS|METH_KEYWORDS, 0},
  {"norm", (PyCFunction)__pyx_f_7py_pari_3gen_norm, METH_VARARGS|METH_KEYWORDS, 0},
  {"charpoly", (PyCFunction)__pyx_f_7py_pari_3gen_charpoly, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_charpoly},
  {"nextprime", (PyCFunction)__pyx_f_7py_pari_3gen_nextprime, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_nextprime},
  {"subst", (PyCFunction)__pyx_f_7py_pari_3gen_subst, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_subst},
  {"kronecker", (PyCFunction)__pyx_f_7py_pari_3gen_kronecker, METH_VARARGS|METH_KEYWORDS, 0},
  {"exp", (PyCFunction)__pyx_f_7py_pari_3gen_exp, METH_VARARGS|METH_KEYWORDS, 0},
  {"log", (PyCFunction)__pyx_f_7py_pari_3gen_log, METH_VARARGS|METH_KEYWORDS, 0},
  {"type", (PyCFunction)__pyx_f_7py_pari_3gen_type, METH_VARARGS|METH_KEYWORDS, 0},
  {0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number_gen = {
  __pyx_f_7py_pari_3gen___add__, /*nb_add*/
  __pyx_f_7py_pari_3gen___sub__, /*nb_subtract*/
  __pyx_f_7py_pari_3gen___mul__, /*nb_multiply*/
  __pyx_f_7py_pari_3gen___div__, /*nb_divide*/
  __pyx_f_7py_pari_3gen___mod__, /*nb_remainder*/
  0, /*nb_divmod*/
  __pyx_f_7py_pari_3gen___pow__, /*nb_power*/
  __pyx_f_7py_pari_3gen___neg__, /*nb_negative*/
  0, /*nb_positive*/
  __pyx_f_7py_pari_3gen___abs__, /*nb_absolute*/
  0, /*nb_nonzero*/
  __pyx_f_7py_pari_3gen___invert__, /*nb_invert*/
  __pyx_f_7py_pari_3gen___lshift__, /*nb_lshift*/
  __pyx_f_7py_pari_3gen___rshift__, /*nb_rshift*/
  0, /*nb_and*/
  __pyx_f_7py_pari_3gen___xor__, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  __pyx_f_7py_pari_3gen___int__, /*nb_int*/
  __pyx_f_7py_pari_3gen___long__, /*nb_long*/
  __pyx_f_7py_pari_3gen___float__, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
};

static PySequenceMethods __pyx_tp_as_sequence_gen = {
  __pyx_f_7py_pari_3gen___len__, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  __pyx_sq_item_7py_pari_gen, /*sq_item*/
  __pyx_f_7py_pari_3gen___getslice__, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping_gen = {
  __pyx_f_7py_pari_3gen___len__, /*mp_length*/
  __pyx_f_7py_pari_3gen___getitem__, /*mp_subscript*/
  __pyx_mp_ass_subscript_7py_pari_gen, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer_gen = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

statichere PyTypeObject __pyx_type_7py_pari_gen = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "py_pari.gen", /*tp_name*/
  sizeof(struct __pyx_obj_7py_pari_gen), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_7py_pari_gen, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  __pyx_f_7py_pari_3gen___cmp__, /*tp_compare*/
  __pyx_f_7py_pari_3gen___repr__, /*tp_repr*/
  &__pyx_tp_as_number_gen, /*tp_as_number*/
  &__pyx_tp_as_sequence_gen, /*tp_as_sequence*/
  &__pyx_tp_as_mapping_gen, /*tp_as_mapping*/
  0, /*tp_hash*/
  __pyx_f_7py_pari_3gen___call__, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer_gen, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC, /*tp_flags*/
  0, /*tp_doc*/
  __pyx_tp_traverse_7py_pari_gen, /*tp_traverse*/
  __pyx_tp_clear_7py_pari_gen, /*tp_clear*/
  __pyx_f_7py_pari_3gen___richcmp__, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  0, /*tp_iter*/
  0, /*tp_iternext*/
  __pyx_methods_7py_pari_gen, /*tp_methods*/
  0, /*tp_members*/
  0, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  0, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_7py_pari_gen, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static struct PyMethodDef __pyx_methods[] = {
  {"my_sigint", (PyCFunction)__pyx_f_7py_pari_my_sigint, METH_VARARGS|METH_KEYWORDS, 0},
  {"init_fmt", (PyCFunction)__pyx_f_7py_pari_init_fmt, METH_VARARGS|METH_KEYWORDS, 0},
  {"_init", (PyCFunction)__pyx_f_7py_pari__init, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari__init},
  {"pari", (PyCFunction)__pyx_f_7py_pari_pari, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_pari},
  {"stack_ptr", (PyCFunction)__pyx_f_7py_pari_stack_ptr, METH_VARARGS|METH_KEYWORDS, 0},
  {"stack_top", (PyCFunction)__pyx_f_7py_pari_stack_top, METH_VARARGS|METH_KEYWORDS, 0},
  {"stack_bottom", (PyCFunction)__pyx_f_7py_pari_stack_bottom, METH_VARARGS|METH_KEYWORDS, 0},
  {"stack_size", (PyCFunction)__pyx_f_7py_pari_stack_size, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_stack_size},
  {"stack_usage", (PyCFunction)__pyx_f_7py_pari_stack_usage, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_stack_usage},
  {"stack_available", (PyCFunction)__pyx_f_7py_pari_stack_available, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_stack_available},
  {"execute", (PyCFunction)__pyx_f_7py_pari_execute, METH_VARARGS|METH_KEYWORDS, 0},
  {"eval", (PyCFunction)__pyx_f_7py_pari_eval, METH_VARARGS|METH_KEYWORDS, 0},
  {"_error", (PyCFunction)__pyx_f_7py_pari__error, METH_VARARGS|METH_KEYWORDS, 0},
  {"min", (PyCFunction)__pyx_f_7py_pari_min, METH_VARARGS|METH_KEYWORDS, 0},
  {"max", (PyCFunction)__pyx_f_7py_pari_max, METH_VARARGS|METH_KEYWORDS, 0},
  {"prime_list", (PyCFunction)__pyx_f_7py_pari_prime_list, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_prime_list},
  {"nth_prime", (PyCFunction)__pyx_f_7py_pari_nth_prime, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_nth_prime},
  {"euler", (PyCFunction)__pyx_f_7py_pari_euler, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_euler},
  {"pi", (PyCFunction)__pyx_f_7py_pari_pi, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_pi},
  {"factorial", (PyCFunction)__pyx_f_7py_pari_factorial, METH_VARARGS|METH_KEYWORDS, 0},
  {"vector", (PyCFunction)__pyx_f_7py_pari_vector, METH_VARARGS|METH_KEYWORDS, 0},
  {"matrix", (PyCFunction)__pyx_f_7py_pari_matrix, METH_VARARGS|METH_KEYWORDS, 0},
  {"set_real_precision", (PyCFunction)__pyx_f_7py_pari_set_real_precision, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_set_real_precision},
  {"get_real_precision", (PyCFunction)__pyx_f_7py_pari_get_real_precision, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_get_real_precision},
  {"set_series_precision", (PyCFunction)__pyx_f_7py_pari_set_series_precision, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_set_series_precision},
  {"get_series_precision", (PyCFunction)__pyx_f_7py_pari_get_series_precision, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_get_series_precision},
  {"init_primes", (PyCFunction)__pyx_f_7py_pari_init_primes, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_init_primes},
  {0, 0, 0, 0}
};

DL_EXPORT(void) initpy_pari(void); /*proto*/
DL_EXPORT(void) initpy_pari(void) {
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  PyObject *__pyx_6 = 0;
  PyObject *__pyx_7 = 0;
  PyObject *__pyx_8 = 0;
  PyObject *__pyx_9 = 0;
  PyObject *__pyx_10 = 0;
  PyObject *__pyx_11 = 0;
  PyObject *__pyx_12 = 0;
  PyObject *__pyx_13 = 0;
  PyObject *__pyx_14 = 0;
  PyObject *__pyx_15 = 0;
  PyObject *__pyx_16 = 0;
  PyObject *__pyx_17 = 0;
  PyObject *__pyx_18 = 0;
  PyObject *__pyx_19 = 0;
  int __pyx_20;
  PyObject *__pyx_21 = 0;
  PyObject *__pyx_22 = 0;
  PyObject *__pyx_23 = 0;
  __pyx_m = Py_InitModule4("py_pari", __pyx_methods, __pyx_mdoc, 0, PYTHON_API_VERSION);
  if (!__pyx_m) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  __pyx_b = PyImport_AddModule("__builtin__");
  if (!__pyx_b) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  if (PyObject_SetAttrString(__pyx_m, "__builtins__", __pyx_b) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  if (__Pyx_InternStrings(__pyx_intern_tab) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  if (__Pyx_InitStrings(__pyx_string_tab) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  ((PyObject*)__pyx_v_7py_pari_ZERO) = Py_None; Py_INCREF(((PyObject*)__pyx_v_7py_pari_ZERO));
  ((PyObject*)__pyx_v_7py_pari_ONE) = Py_None; Py_INCREF(((PyObject*)__pyx_v_7py_pari_ONE));
  ((PyObject*)__pyx_v_7py_pari_TWO) = Py_None; Py_INCREF(((PyObject*)__pyx_v_7py_pari_TWO));
  __pyx_vtabptr_7py_pari_gen = &__pyx_vtable_7py_pari_gen;
  __pyx_vtable_7py_pari_gen.init = (void *)__pyx_f_7py_pari_3gen_init;
  __pyx_vtable_7py_pari_gen._gen = (void *)__pyx_f_7py_pari_3gen__gen;
  __pyx_type_7py_pari_gen.tp_free = _PyObject_GC_Del;
  if (PyType_Ready(&__pyx_type_7py_pari_gen) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2171; goto __pyx_L1;}
  if (__Pyx_SetVtable(__pyx_type_7py_pari_gen.tp_dict, __pyx_vtabptr_7py_pari_gen) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2171; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "gen", (PyObject *)&__pyx_type_7py_pari_gen) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2171; goto __pyx_L1;}
  __pyx_ptype_7py_pari_gen = &__pyx_type_7py_pari_gen;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":70 */
  __pyx_k1;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":131 */
  __pyx_1 = __Pyx_Import(__pyx_n_gc, 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 131; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_gc, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 131; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2026 */
  GP_DATA = (&__pyx_v_7py_pari___GP_DATA);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2029 */
  __pyx_v_7py_pari_REAL_PREC = 5;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2087 */
  __pyx_k3 = 20000000;
  __pyx_k4 = 500000;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2444 */
  __pyx_1 = PyInt_FromLong((-1)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2444; goto __pyx_L1;}
  __pyx_k5 = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2595 */
  __pyx_2 = PyInt_FromLong(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2595; goto __pyx_L1;}
  __pyx_k6 = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2626 */
  __pyx_3 = PyInt_FromLong((-1)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2626; goto __pyx_L1;}
  __pyx_k7 = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2793 */
  __pyx_4 = PyInt_FromLong((-1)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2793; goto __pyx_L1;}
  __pyx_k8 = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2823 */
  __pyx_5 = PyInt_FromLong((-1)); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2823; goto __pyx_L1;}
  __pyx_k9 = __pyx_5;
  __pyx_5 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2856 */
  __pyx_6 = PyInt_FromLong(0); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2856; goto __pyx_L1;}
  __pyx_k10 = __pyx_6;
  __pyx_6 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3110 */
  __pyx_k11 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3120 */
  __pyx_k12 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3139 */
  __pyx_k13 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3416 */
  __pyx_k14 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3475 */
  __pyx_7 = PyInt_FromLong(0); if (!__pyx_7) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3475; goto __pyx_L1;}
  __pyx_k15 = __pyx_7;
  __pyx_7 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3497 */
  __pyx_k16 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3541 */
  __pyx_8 = PyInt_FromLong(1); if (!__pyx_8) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3541; goto __pyx_L1;}
  __pyx_k17 = __pyx_8;
  __pyx_8 = 0;
  __pyx_k18 = 4;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3625 */
  __pyx_9 = PyInt_FromLong(1); if (!__pyx_9) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3625; goto __pyx_L1;}
  __pyx_k19 = __pyx_9;
  __pyx_9 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3633 */
  __pyx_10 = PyInt_FromLong(0); if (!__pyx_10) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3633; goto __pyx_L1;}
  __pyx_k20 = __pyx_10;
  __pyx_10 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3655 */
  __pyx_11 = PyInt_FromLong(0); if (!__pyx_11) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3655; goto __pyx_L1;}
  __pyx_k21 = __pyx_11;
  __pyx_11 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3661 */
  __pyx_k22 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3732 */
  __pyx_k23 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3748 */
  __pyx_k24 = 0;
  __pyx_12 = PyInt_FromLong(0); if (!__pyx_12) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3748; goto __pyx_L1;}
  __pyx_k25 = __pyx_12;
  __pyx_12 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3764 */
  __pyx_k26 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3771 */
  __pyx_k27 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3785 */
  __pyx_13 = PyInt_FromLong((-1)); if (!__pyx_13) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3785; goto __pyx_L1;}
  __pyx_k28 = __pyx_13;
  __pyx_13 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3792 */
  __pyx_14 = PyInt_FromLong((-1)); if (!__pyx_14) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3792; goto __pyx_L1;}
  __pyx_k29 = __pyx_14;
  __pyx_14 = 0;
  __pyx_15 = PyInt_FromLong(0); if (!__pyx_15) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3792; goto __pyx_L1;}
  __pyx_k30 = __pyx_15;
  __pyx_15 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3802 */
  __pyx_16 = PyInt_FromLong(0); if (!__pyx_16) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3802; goto __pyx_L1;}
  __pyx_k31 = __pyx_16;
  __pyx_16 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3831 */
  __pyx_17 = PyInt_FromLong((-1)); if (!__pyx_17) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3831; goto __pyx_L1;}
  __pyx_k32 = __pyx_17;
  __pyx_17 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3863 */
  __pyx_k33 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3871 */
  __pyx_k34 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3891 */
  __pyx_18 = PyInt_FromLong((-1)); if (!__pyx_18) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3891; goto __pyx_L1;}
  __pyx_k35 = __pyx_18;
  __pyx_18 = 0;
  __pyx_19 = PyInt_FromLong(0); if (!__pyx_19) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3891; goto __pyx_L1;}
  __pyx_k36 = __pyx_19;
  __pyx_19 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4203 */
  Py_INCREF(__pyx_k37p);
  __pyx_k38 = __pyx_k37p;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4278 */
  __pyx_k39 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4308 */
  __pyx_k40 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4343 */
  Py_INCREF(Py_None);
  __pyx_k41 = Py_None;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4357 */
  Py_INCREF(Py_None);
  __pyx_k42 = Py_None;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4456 */
  __pyx_20 = (precdl == 0);
  if (__pyx_20) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":4457 */
    __pyx_21 = __Pyx_GetName(__pyx_m, __pyx_n__init); if (!__pyx_21) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4457; goto __pyx_L1;}
    __pyx_22 = PyTuple_New(0); if (!__pyx_22) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4457; goto __pyx_L1;}
    __pyx_23 = PyObject_CallObject(__pyx_21, __pyx_22); if (!__pyx_23) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4457; goto __pyx_L1;}
    Py_DECREF(__pyx_21); __pyx_21 = 0;
    Py_DECREF(__pyx_22); __pyx_22 = 0;
    Py_DECREF(__pyx_23); __pyx_23 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;
  return;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  Py_XDECREF(__pyx_6);
  Py_XDECREF(__pyx_7);
  Py_XDECREF(__pyx_8);
  Py_XDECREF(__pyx_9);
  Py_XDECREF(__pyx_10);
  Py_XDECREF(__pyx_11);
  Py_XDECREF(__pyx_12);
  Py_XDECREF(__pyx_13);
  Py_XDECREF(__pyx_14);
  Py_XDECREF(__pyx_15);
  Py_XDECREF(__pyx_16);
  Py_XDECREF(__pyx_17);
  Py_XDECREF(__pyx_18);
  Py_XDECREF(__pyx_19);
  Py_XDECREF(__pyx_21);
  Py_XDECREF(__pyx_22);
  Py_XDECREF(__pyx_23);
  __Pyx_AddTraceback("py_pari");
}

static char *__pyx_filenames[] = {
  "py_pari.pyx",
};
statichere char **__pyx_f = __pyx_filenames;

/* Runtime support code */

static int __Pyx_ArgTypeTest(PyObject *obj, PyTypeObject *type, int none_allowed, char *name) {
    if (!type) {
        PyErr_Format(PyExc_SystemError, "Missing type object");
        return 0;
    }
    if ((none_allowed && obj == Py_None) || PyObject_TypeCheck(obj, type))
        return 1;
    PyErr_Format(PyExc_TypeError,
        "Argument '%s' has incorrect type (expected %s, got %s)",
        name, type->tp_name, obj->ob_type->tp_name);
    return 0;
}

static PyObject *__Pyx_Import(PyObject *name, PyObject *from_list) {
    PyObject *__import__ = 0;
    PyObject *empty_list = 0;
    PyObject *module = 0;
    PyObject *global_dict = 0;
    PyObject *empty_dict = 0;
    PyObject *list;
    __import__ = PyObject_GetAttrString(__pyx_b, "__import__");
    if (!__import__)
        goto bad;
    if (from_list)
        list = from_list;
    else {
        empty_list = PyList_New(0);
        if (!empty_list)
            goto bad;
        list = empty_list;
    }
    global_dict = PyModule_GetDict(__pyx_m);
    if (!global_dict)
        goto bad;
    empty_dict = PyDict_New();
    if (!empty_dict)
        goto bad;
    module = PyObject_CallFunction(__import__, "OOOO",
        name, global_dict, empty_dict, list);
bad:
    Py_XDECREF(empty_list);
    Py_XDECREF(__import__);
    Py_XDECREF(empty_dict);
    return module;
}

static PyObject *__Pyx_GetName(PyObject *dict, PyObject *name) {
    PyObject *result;
    result = PyObject_GetAttr(dict, name);
    if (!result)
        PyErr_SetObject(PyExc_NameError, name);
    return result;
}

static void __Pyx_WriteUnraisable(char *name) {
    PyObject *old_exc, *old_val, *old_tb;
    PyObject *ctx;
    PyErr_Fetch(&old_exc, &old_val, &old_tb);
    ctx = PyString_FromString(name);
    PyErr_Restore(old_exc, old_val, old_tb);
    if (!ctx)
        ctx = Py_None;
    PyErr_WriteUnraisable(ctx);
}

static void __Pyx_Raise(PyObject *type, PyObject *value, PyObject *tb) {
    Py_XINCREF(type);
    Py_XINCREF(value);
    Py_XINCREF(tb);
    /* First, check the traceback argument, replacing None with NULL. */
    if (tb == Py_None) {
        Py_DECREF(tb);
        tb = 0;
    }
    else if (tb != NULL && !PyTraceBack_Check(tb)) {
        PyErr_SetString(PyExc_TypeError,
            "raise: arg 3 must be a traceback or None");
        goto raise_error;
    }
    /* Next, replace a missing value with None */
    if (value == NULL) {
        value = Py_None;
        Py_INCREF(value);
    }
    /* Next, repeatedly, replace a tuple exception with its first item */
    while (PyTuple_Check(type) && PyTuple_Size(type) > 0) {
        PyObject *tmp = type;
        type = PyTuple_GET_ITEM(type, 0);
        Py_INCREF(type);
        Py_DECREF(tmp);
    }
    if (PyString_Check(type))
        ;
    else if (PyClass_Check(type))
        ; /*PyErr_NormalizeException(&type, &value, &tb);*/
    else if (PyInstance_Check(type)) {
        /* Raising an instance.  The value should be a dummy. */
        if (value != Py_None) {
            PyErr_SetString(PyExc_TypeError,
              "instance exception may not have a separate value");
            goto raise_error;
        }
        else {
            /* Normalize to raise <class>, <instance> */
            Py_DECREF(value);
            value = type;
            type = (PyObject*) ((PyInstanceObject*)type)->in_class;
            Py_INCREF(type);
        }
    }
    else {
        /* Not something you can raise.  You get an exception
           anyway, just not what you specified :-) */
        PyErr_Format(PyExc_TypeError,
                 "exceptions must be strings, classes, or "
                 "instances, not %s", type->ob_type->tp_name);
        goto raise_error;
    }
    PyErr_Restore(type, value, tb);
    return;
raise_error:
    Py_XDECREF(value);
    Py_XDECREF(type);
    Py_XDECREF(tb);
    return;
}

static int __Pyx_TypeTest(PyObject *obj, PyTypeObject *type) {
    if (!type) {
        PyErr_Format(PyExc_SystemError, "Missing type object");
        return 0;
    }
    if (obj == Py_None || PyObject_TypeCheck(obj, type))
        return 1;
    PyErr_Format(PyExc_TypeError, "Cannot convert %s to %s",
        obj->ob_type->tp_name, type->tp_name);
    return 0;
}

static void __Pyx_UnpackError(void) {
    PyErr_SetString(PyExc_ValueError, "unpack sequence of wrong size");
}

static PyObject *__Pyx_UnpackItem(PyObject *seq, int i) {
  PyObject *item;
  if (!(item = PySequence_GetItem(seq, i))) {
    if (PyErr_ExceptionMatches(PyExc_IndexError))
    	__Pyx_UnpackError();
  }
  return item;
}

static int __Pyx_EndUnpack(PyObject *seq, int i) {
  PyObject *item;
  if (item = PySequence_GetItem(seq, i)) {
    Py_DECREF(item);
    __Pyx_UnpackError();
    return -1;
  }
  PyErr_Clear();
    return 0;
}

static PyObject *__Pyx_GetExcValue(void) {
    PyObject *type = 0, *value = 0, *tb = 0;
    PyObject *result = 0;
    PyThreadState *tstate = PyThreadState_Get();
    PyErr_Fetch(&type, &value, &tb);
    PyErr_NormalizeException(&type, &value, &tb);
    if (PyErr_Occurred())
        goto bad;
    if (!value) {
        value = Py_None;
        Py_INCREF(value);
    }
    Py_XDECREF(tstate->exc_type);
    Py_XDECREF(tstate->exc_value);
    Py_XDECREF(tstate->exc_traceback);
    tstate->exc_type = type;
    tstate->exc_value = value;
    tstate->exc_traceback = tb;
    result = value;
    Py_XINCREF(result);
    type = 0;
    value = 0;
    tb = 0;
bad:
    Py_XDECREF(type);
    Py_XDECREF(value);
    Py_XDECREF(tb);
    return result;
}

static PyObject *__Pyx_GetStdout(void) {
    PyObject *f = PySys_GetObject("stdout");
    if (!f) {
        PyErr_SetString(PyExc_RuntimeError, "lost sys.stdout");
    }
    return f;
}

static int __Pyx_PrintItem(PyObject *v) {
    PyObject *f;
    
    if (!(f = __Pyx_GetStdout()))
        return -1;
    if (PyFile_SoftSpace(f, 1)) {
        if (PyFile_WriteString(" ", f) < 0)
            return -1;
    }
    if (PyFile_WriteObject(v, f, Py_PRINT_RAW) < 0)
        return -1;
    if (PyString_Check(v)) {
        char *s = PyString_AsString(v);
        int len = PyString_Size(v);
        if (len > 0 &&
            isspace(Py_CHARMASK(s[len-1])) &&
            s[len-1] != ' ')
                PyFile_SoftSpace(f, 0);
    }
    return 0;
}

static int __Pyx_PrintNewline(void) {
    PyObject *f;
    
    if (!(f = __Pyx_GetStdout()))
        return -1;
    if (PyFile_WriteString("\n", f) < 0)
        return -1;
    PyFile_SoftSpace(f, 0);
    return 0;
}

static int __Pyx_InternStrings(__Pyx_InternTabEntry *t) {
    while (t->p) {
        *t->p = PyString_InternFromString(t->s);
        if (!*t->p)
            return -1;
        ++t;
    }
    return 0;
}

static int __Pyx_InitStrings(__Pyx_StringTabEntry *t) {
    while (t->p) {
        *t->p = PyString_FromStringAndSize(t->s, t->n - 1);
        if (!*t->p)
            return -1;
        ++t;
    }
    return 0;
}

static int __Pyx_SetVtable(PyObject *dict, void *vtable) {
    PyObject *pycobj = 0;
    int result;
    
    pycobj = PyCObject_FromVoidPtr(vtable, 0);
    if (!pycobj)
        goto bad;
    if (PyDict_SetItemString(dict, "__pyx_vtable__", pycobj) < 0)
        goto bad;
    result = 0;
    goto done;

bad:
    result = -1;
done:
    Py_XDECREF(pycobj);
    return result;
}

#include "compile.h"
#include "frameobject.h"
#include "traceback.h"

static void __Pyx_AddTraceback(char *funcname) {
    PyObject *py_srcfile = 0;
    PyObject *py_funcname = 0;
    PyObject *py_globals = 0;
    PyObject *empty_tuple = 0;
    PyObject *empty_string = 0;
    PyCodeObject *py_code = 0;
    PyFrameObject *py_frame = 0;
    
    py_srcfile = PyString_FromString(__pyx_filename);
    if (!py_srcfile) goto bad;
    py_funcname = PyString_FromString(funcname);
    if (!py_funcname) goto bad;
    py_globals = PyModule_GetDict(__pyx_m);
    if (!py_globals) goto bad;
    empty_tuple = PyTuple_New(0);
    if (!empty_tuple) goto bad;
    empty_string = PyString_FromString("");
    if (!empty_string) goto bad;
    py_code = PyCode_New(
        0,            /*int argcount,*/
        0,            /*int nlocals,*/
        0,            /*int stacksize,*/
        0,            /*int flags,*/
        empty_string, /*PyObject *code,*/
        empty_tuple,  /*PyObject *consts,*/
        empty_tuple,  /*PyObject *names,*/
        empty_tuple,  /*PyObject *varnames,*/
        empty_tuple,  /*PyObject *freevars,*/
        empty_tuple,  /*PyObject *cellvars,*/
        py_srcfile,   /*PyObject *filename,*/
        py_funcname,  /*PyObject *name,*/
        __pyx_lineno,   /*int firstlineno,*/
        empty_string  /*PyObject *lnotab*/
    );
    if (!py_code) goto bad;
    py_frame = PyFrame_New(
        PyThreadState_Get(), /*PyThreadState *tstate,*/
        py_code,             /*PyCodeObject *code,*/
        py_globals,          /*PyObject *globals,*/
        0                    /*PyObject *locals*/
    );
    if (!py_frame) goto bad;
    py_frame->f_lineno = __pyx_lineno;
    PyTraceBack_Here(py_frame);
bad:
    Py_XDECREF(py_srcfile);
    Py_XDECREF(py_funcname);
    Py_XDECREF(empty_tuple);
    Py_XDECREF(empty_string);
    Py_XDECREF(py_code);
    Py_XDECREF(py_frame);
}
